"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Bid = exports.Auctions = exports.Auction = exports.Params = exports.protobufPackage = void 0;
/* eslint-disable */
const duration_1 = require("../../../google/protobuf/duration");
const coin_1 = require("../../../cosmos/base/v1beta1/coin");
const timestamp_1 = require("../../../google/protobuf/timestamp");
const long_1 = __importDefault(require("long"));
const minimal_1 = __importDefault(require("protobufjs/minimal"));
exports.protobufPackage = "cerc.auction.v1";
function createBaseParams() {
    return {
        commitsDuration: undefined,
        revealsDuration: undefined,
        commitFee: undefined,
        revealFee: undefined,
        minimumBid: undefined,
    };
}
exports.Params = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.commitsDuration !== undefined) {
            duration_1.Duration.encode(message.commitsDuration, writer.uint32(10).fork()).ldelim();
        }
        if (message.revealsDuration !== undefined) {
            duration_1.Duration.encode(message.revealsDuration, writer.uint32(18).fork()).ldelim();
        }
        if (message.commitFee !== undefined) {
            coin_1.Coin.encode(message.commitFee, writer.uint32(26).fork()).ldelim();
        }
        if (message.revealFee !== undefined) {
            coin_1.Coin.encode(message.revealFee, writer.uint32(34).fork()).ldelim();
        }
        if (message.minimumBid !== undefined) {
            coin_1.Coin.encode(message.minimumBid, writer.uint32(42).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseParams();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.commitsDuration = duration_1.Duration.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.revealsDuration = duration_1.Duration.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.commitFee = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.revealFee = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.minimumBid = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            commitsDuration: isSet(object.commitsDuration)
                ? duration_1.Duration.fromJSON(object.commitsDuration)
                : undefined,
            revealsDuration: isSet(object.revealsDuration)
                ? duration_1.Duration.fromJSON(object.revealsDuration)
                : undefined,
            commitFee: isSet(object.commitFee)
                ? coin_1.Coin.fromJSON(object.commitFee)
                : undefined,
            revealFee: isSet(object.revealFee)
                ? coin_1.Coin.fromJSON(object.revealFee)
                : undefined,
            minimumBid: isSet(object.minimumBid)
                ? coin_1.Coin.fromJSON(object.minimumBid)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.commitsDuration !== undefined &&
            (obj.commitsDuration = message.commitsDuration
                ? duration_1.Duration.toJSON(message.commitsDuration)
                : undefined);
        message.revealsDuration !== undefined &&
            (obj.revealsDuration = message.revealsDuration
                ? duration_1.Duration.toJSON(message.revealsDuration)
                : undefined);
        message.commitFee !== undefined &&
            (obj.commitFee = message.commitFee
                ? coin_1.Coin.toJSON(message.commitFee)
                : undefined);
        message.revealFee !== undefined &&
            (obj.revealFee = message.revealFee
                ? coin_1.Coin.toJSON(message.revealFee)
                : undefined);
        message.minimumBid !== undefined &&
            (obj.minimumBid = message.minimumBid
                ? coin_1.Coin.toJSON(message.minimumBid)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseParams();
        message.commitsDuration =
            object.commitsDuration !== undefined && object.commitsDuration !== null
                ? duration_1.Duration.fromPartial(object.commitsDuration)
                : undefined;
        message.revealsDuration =
            object.revealsDuration !== undefined && object.revealsDuration !== null
                ? duration_1.Duration.fromPartial(object.revealsDuration)
                : undefined;
        message.commitFee =
            object.commitFee !== undefined && object.commitFee !== null
                ? coin_1.Coin.fromPartial(object.commitFee)
                : undefined;
        message.revealFee =
            object.revealFee !== undefined && object.revealFee !== null
                ? coin_1.Coin.fromPartial(object.revealFee)
                : undefined;
        message.minimumBid =
            object.minimumBid !== undefined && object.minimumBid !== null
                ? coin_1.Coin.fromPartial(object.minimumBid)
                : undefined;
        return message;
    },
};
function createBaseAuction() {
    return {
        id: "",
        status: "",
        ownerAddress: "",
        createTime: undefined,
        commitsEndTime: undefined,
        revealsEndTime: undefined,
        commitFee: undefined,
        revealFee: undefined,
        minimumBid: undefined,
        winnerAddress: "",
        winningBid: undefined,
        winningPrice: undefined,
    };
}
exports.Auction = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.id !== "") {
            writer.uint32(10).string(message.id);
        }
        if (message.status !== "") {
            writer.uint32(18).string(message.status);
        }
        if (message.ownerAddress !== "") {
            writer.uint32(26).string(message.ownerAddress);
        }
        if (message.createTime !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.createTime), writer.uint32(34).fork()).ldelim();
        }
        if (message.commitsEndTime !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.commitsEndTime), writer.uint32(42).fork()).ldelim();
        }
        if (message.revealsEndTime !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.revealsEndTime), writer.uint32(50).fork()).ldelim();
        }
        if (message.commitFee !== undefined) {
            coin_1.Coin.encode(message.commitFee, writer.uint32(58).fork()).ldelim();
        }
        if (message.revealFee !== undefined) {
            coin_1.Coin.encode(message.revealFee, writer.uint32(66).fork()).ldelim();
        }
        if (message.minimumBid !== undefined) {
            coin_1.Coin.encode(message.minimumBid, writer.uint32(74).fork()).ldelim();
        }
        if (message.winnerAddress !== "") {
            writer.uint32(82).string(message.winnerAddress);
        }
        if (message.winningBid !== undefined) {
            coin_1.Coin.encode(message.winningBid, writer.uint32(90).fork()).ldelim();
        }
        if (message.winningPrice !== undefined) {
            coin_1.Coin.encode(message.winningPrice, writer.uint32(98).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAuction();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    message.status = reader.string();
                    break;
                case 3:
                    message.ownerAddress = reader.string();
                    break;
                case 4:
                    message.createTime = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                case 5:
                    message.commitsEndTime = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                case 6:
                    message.revealsEndTime = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                case 7:
                    message.commitFee = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 8:
                    message.revealFee = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 9:
                    message.minimumBid = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 10:
                    message.winnerAddress = reader.string();
                    break;
                case 11:
                    message.winningBid = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 12:
                    message.winningPrice = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? String(object.id) : "",
            status: isSet(object.status) ? String(object.status) : "",
            ownerAddress: isSet(object.ownerAddress)
                ? String(object.ownerAddress)
                : "",
            createTime: isSet(object.createTime)
                ? fromJsonTimestamp(object.createTime)
                : undefined,
            commitsEndTime: isSet(object.commitsEndTime)
                ? fromJsonTimestamp(object.commitsEndTime)
                : undefined,
            revealsEndTime: isSet(object.revealsEndTime)
                ? fromJsonTimestamp(object.revealsEndTime)
                : undefined,
            commitFee: isSet(object.commitFee)
                ? coin_1.Coin.fromJSON(object.commitFee)
                : undefined,
            revealFee: isSet(object.revealFee)
                ? coin_1.Coin.fromJSON(object.revealFee)
                : undefined,
            minimumBid: isSet(object.minimumBid)
                ? coin_1.Coin.fromJSON(object.minimumBid)
                : undefined,
            winnerAddress: isSet(object.winnerAddress)
                ? String(object.winnerAddress)
                : "",
            winningBid: isSet(object.winningBid)
                ? coin_1.Coin.fromJSON(object.winningBid)
                : undefined,
            winningPrice: isSet(object.winningPrice)
                ? coin_1.Coin.fromJSON(object.winningPrice)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        message.status !== undefined && (obj.status = message.status);
        message.ownerAddress !== undefined &&
            (obj.ownerAddress = message.ownerAddress);
        message.createTime !== undefined &&
            (obj.createTime = message.createTime.toISOString());
        message.commitsEndTime !== undefined &&
            (obj.commitsEndTime = message.commitsEndTime.toISOString());
        message.revealsEndTime !== undefined &&
            (obj.revealsEndTime = message.revealsEndTime.toISOString());
        message.commitFee !== undefined &&
            (obj.commitFee = message.commitFee
                ? coin_1.Coin.toJSON(message.commitFee)
                : undefined);
        message.revealFee !== undefined &&
            (obj.revealFee = message.revealFee
                ? coin_1.Coin.toJSON(message.revealFee)
                : undefined);
        message.minimumBid !== undefined &&
            (obj.minimumBid = message.minimumBid
                ? coin_1.Coin.toJSON(message.minimumBid)
                : undefined);
        message.winnerAddress !== undefined &&
            (obj.winnerAddress = message.winnerAddress);
        message.winningBid !== undefined &&
            (obj.winningBid = message.winningBid
                ? coin_1.Coin.toJSON(message.winningBid)
                : undefined);
        message.winningPrice !== undefined &&
            (obj.winningPrice = message.winningPrice
                ? coin_1.Coin.toJSON(message.winningPrice)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g;
        const message = createBaseAuction();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : "";
        message.status = (_b = object.status) !== null && _b !== void 0 ? _b : "";
        message.ownerAddress = (_c = object.ownerAddress) !== null && _c !== void 0 ? _c : "";
        message.createTime = (_d = object.createTime) !== null && _d !== void 0 ? _d : undefined;
        message.commitsEndTime = (_e = object.commitsEndTime) !== null && _e !== void 0 ? _e : undefined;
        message.revealsEndTime = (_f = object.revealsEndTime) !== null && _f !== void 0 ? _f : undefined;
        message.commitFee =
            object.commitFee !== undefined && object.commitFee !== null
                ? coin_1.Coin.fromPartial(object.commitFee)
                : undefined;
        message.revealFee =
            object.revealFee !== undefined && object.revealFee !== null
                ? coin_1.Coin.fromPartial(object.revealFee)
                : undefined;
        message.minimumBid =
            object.minimumBid !== undefined && object.minimumBid !== null
                ? coin_1.Coin.fromPartial(object.minimumBid)
                : undefined;
        message.winnerAddress = (_g = object.winnerAddress) !== null && _g !== void 0 ? _g : "";
        message.winningBid =
            object.winningBid !== undefined && object.winningBid !== null
                ? coin_1.Coin.fromPartial(object.winningBid)
                : undefined;
        message.winningPrice =
            object.winningPrice !== undefined && object.winningPrice !== null
                ? coin_1.Coin.fromPartial(object.winningPrice)
                : undefined;
        return message;
    },
};
function createBaseAuctions() {
    return { auctions: [] };
}
exports.Auctions = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        for (const v of message.auctions) {
            exports.Auction.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAuctions();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auctions.push(exports.Auction.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            auctions: Array.isArray(object === null || object === void 0 ? void 0 : object.auctions)
                ? object.auctions.map((e) => exports.Auction.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.auctions) {
            obj.auctions = message.auctions.map((e) => e ? exports.Auction.toJSON(e) : undefined);
        }
        else {
            obj.auctions = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseAuctions();
        message.auctions =
            ((_a = object.auctions) === null || _a === void 0 ? void 0 : _a.map((e) => exports.Auction.fromPartial(e))) || [];
        return message;
    },
};
function createBaseBid() {
    return {
        auctionId: "",
        bidderAddress: "",
        status: "",
        commitHash: "",
        commitTime: undefined,
        commitFee: undefined,
        revealTime: undefined,
        revealFee: undefined,
        bidAmount: undefined,
    };
}
exports.Bid = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.auctionId !== "") {
            writer.uint32(10).string(message.auctionId);
        }
        if (message.bidderAddress !== "") {
            writer.uint32(18).string(message.bidderAddress);
        }
        if (message.status !== "") {
            writer.uint32(26).string(message.status);
        }
        if (message.commitHash !== "") {
            writer.uint32(34).string(message.commitHash);
        }
        if (message.commitTime !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.commitTime), writer.uint32(42).fork()).ldelim();
        }
        if (message.commitFee !== undefined) {
            coin_1.Coin.encode(message.commitFee, writer.uint32(50).fork()).ldelim();
        }
        if (message.revealTime !== undefined) {
            timestamp_1.Timestamp.encode(toTimestamp(message.revealTime), writer.uint32(58).fork()).ldelim();
        }
        if (message.revealFee !== undefined) {
            coin_1.Coin.encode(message.revealFee, writer.uint32(66).fork()).ldelim();
        }
        if (message.bidAmount !== undefined) {
            coin_1.Coin.encode(message.bidAmount, writer.uint32(74).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseBid();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auctionId = reader.string();
                    break;
                case 2:
                    message.bidderAddress = reader.string();
                    break;
                case 3:
                    message.status = reader.string();
                    break;
                case 4:
                    message.commitHash = reader.string();
                    break;
                case 5:
                    message.commitTime = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                case 6:
                    message.commitFee = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 7:
                    message.revealTime = fromTimestamp(timestamp_1.Timestamp.decode(reader, reader.uint32()));
                    break;
                case 8:
                    message.revealFee = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 9:
                    message.bidAmount = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            auctionId: isSet(object.auctionId) ? String(object.auctionId) : "",
            bidderAddress: isSet(object.bidderAddress)
                ? String(object.bidderAddress)
                : "",
            status: isSet(object.status) ? String(object.status) : "",
            commitHash: isSet(object.commitHash) ? String(object.commitHash) : "",
            commitTime: isSet(object.commitTime)
                ? fromJsonTimestamp(object.commitTime)
                : undefined,
            commitFee: isSet(object.commitFee)
                ? coin_1.Coin.fromJSON(object.commitFee)
                : undefined,
            revealTime: isSet(object.revealTime)
                ? fromJsonTimestamp(object.revealTime)
                : undefined,
            revealFee: isSet(object.revealFee)
                ? coin_1.Coin.fromJSON(object.revealFee)
                : undefined,
            bidAmount: isSet(object.bidAmount)
                ? coin_1.Coin.fromJSON(object.bidAmount)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.auctionId !== undefined && (obj.auctionId = message.auctionId);
        message.bidderAddress !== undefined &&
            (obj.bidderAddress = message.bidderAddress);
        message.status !== undefined && (obj.status = message.status);
        message.commitHash !== undefined && (obj.commitHash = message.commitHash);
        message.commitTime !== undefined &&
            (obj.commitTime = message.commitTime.toISOString());
        message.commitFee !== undefined &&
            (obj.commitFee = message.commitFee
                ? coin_1.Coin.toJSON(message.commitFee)
                : undefined);
        message.revealTime !== undefined &&
            (obj.revealTime = message.revealTime.toISOString());
        message.revealFee !== undefined &&
            (obj.revealFee = message.revealFee
                ? coin_1.Coin.toJSON(message.revealFee)
                : undefined);
        message.bidAmount !== undefined &&
            (obj.bidAmount = message.bidAmount
                ? coin_1.Coin.toJSON(message.bidAmount)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f;
        const message = createBaseBid();
        message.auctionId = (_a = object.auctionId) !== null && _a !== void 0 ? _a : "";
        message.bidderAddress = (_b = object.bidderAddress) !== null && _b !== void 0 ? _b : "";
        message.status = (_c = object.status) !== null && _c !== void 0 ? _c : "";
        message.commitHash = (_d = object.commitHash) !== null && _d !== void 0 ? _d : "";
        message.commitTime = (_e = object.commitTime) !== null && _e !== void 0 ? _e : undefined;
        message.commitFee =
            object.commitFee !== undefined && object.commitFee !== null
                ? coin_1.Coin.fromPartial(object.commitFee)
                : undefined;
        message.revealTime = (_f = object.revealTime) !== null && _f !== void 0 ? _f : undefined;
        message.revealFee =
            object.revealFee !== undefined && object.revealFee !== null
                ? coin_1.Coin.fromPartial(object.revealFee)
                : undefined;
        message.bidAmount =
            object.bidAmount !== undefined && object.bidAmount !== null
                ? coin_1.Coin.fromPartial(object.bidAmount)
                : undefined;
        return message;
    },
};
function toTimestamp(date) {
    const seconds = numberToLong(date.getTime() / 1000);
    const nanos = (date.getTime() % 1000) * 1000000;
    return { seconds, nanos };
}
function fromTimestamp(t) {
    let millis = t.seconds.toNumber() * 1000;
    millis += t.nanos / 1000000;
    return new Date(millis);
}
function fromJsonTimestamp(o) {
    if (o instanceof Date) {
        return o;
    }
    else if (typeof o === "string") {
        return new Date(o);
    }
    else {
        return fromTimestamp(timestamp_1.Timestamp.fromJSON(o));
    }
}
function numberToLong(number) {
    return long_1.default.fromNumber(number);
}
if (minimal_1.default.util.Long !== long_1.default) {
    minimal_1.default.util.Long = long_1.default;
    minimal_1.default.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
