import { Params, Auctions } from "./auction";
import Long from "long";
import _m0 from "protobufjs/minimal";
export declare const protobufPackage = "cerc.auction.v1";
/** GenesisState defines the genesis state of the auction module */
export interface GenesisState {
    params?: Params;
    auctions?: Auctions;
}
export declare const GenesisState: {
    encode(message: GenesisState, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GenesisState;
    fromJSON(object: any): GenesisState;
    toJSON(message: GenesisState): unknown;
    fromPartial<I extends {
        params?: {
            commitsDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            revealsDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            commitFee?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            revealFee?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            minimumBid?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
        } | undefined;
        auctions?: {
            auctions?: {
                id?: string | undefined;
                status?: string | undefined;
                ownerAddress?: string | undefined;
                createTime?: Date | undefined;
                commitsEndTime?: Date | undefined;
                revealsEndTime?: Date | undefined;
                commitFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                revealFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                minimumBid?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                winnerAddress?: string | undefined;
                winningBid?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                winningPrice?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
            }[] | undefined;
        } | undefined;
    } & {
        params?: ({
            commitsDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            revealsDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            commitFee?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            revealFee?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            minimumBid?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
        } & {
            commitsDuration?: ({
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } & {
                seconds?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K in Exclude<keyof I["params"]["commitsDuration"]["seconds"], keyof Long.Long>]: never; }) | undefined;
                nanos?: number | undefined;
            } & { [K_1 in Exclude<keyof I["params"]["commitsDuration"], keyof import("../../../google/protobuf/duration").Duration>]: never; }) | undefined;
            revealsDuration?: ({
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } & {
                seconds?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_2 in Exclude<keyof I["params"]["revealsDuration"]["seconds"], keyof Long.Long>]: never; }) | undefined;
                nanos?: number | undefined;
            } & { [K_3 in Exclude<keyof I["params"]["revealsDuration"], keyof import("../../../google/protobuf/duration").Duration>]: never; }) | undefined;
            commitFee?: ({
                denom?: string | undefined;
                amount?: string | undefined;
            } & {
                denom?: string | undefined;
                amount?: string | undefined;
            } & { [K_4 in Exclude<keyof I["params"]["commitFee"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
            revealFee?: ({
                denom?: string | undefined;
                amount?: string | undefined;
            } & {
                denom?: string | undefined;
                amount?: string | undefined;
            } & { [K_5 in Exclude<keyof I["params"]["revealFee"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
            minimumBid?: ({
                denom?: string | undefined;
                amount?: string | undefined;
            } & {
                denom?: string | undefined;
                amount?: string | undefined;
            } & { [K_6 in Exclude<keyof I["params"]["minimumBid"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
        } & { [K_7 in Exclude<keyof I["params"], keyof Params>]: never; }) | undefined;
        auctions?: ({
            auctions?: {
                id?: string | undefined;
                status?: string | undefined;
                ownerAddress?: string | undefined;
                createTime?: Date | undefined;
                commitsEndTime?: Date | undefined;
                revealsEndTime?: Date | undefined;
                commitFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                revealFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                minimumBid?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                winnerAddress?: string | undefined;
                winningBid?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                winningPrice?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
            }[] | undefined;
        } & {
            auctions?: ({
                id?: string | undefined;
                status?: string | undefined;
                ownerAddress?: string | undefined;
                createTime?: Date | undefined;
                commitsEndTime?: Date | undefined;
                revealsEndTime?: Date | undefined;
                commitFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                revealFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                minimumBid?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                winnerAddress?: string | undefined;
                winningBid?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                winningPrice?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
            }[] & ({
                id?: string | undefined;
                status?: string | undefined;
                ownerAddress?: string | undefined;
                createTime?: Date | undefined;
                commitsEndTime?: Date | undefined;
                revealsEndTime?: Date | undefined;
                commitFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                revealFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                minimumBid?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                winnerAddress?: string | undefined;
                winningBid?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                winningPrice?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
            } & {
                id?: string | undefined;
                status?: string | undefined;
                ownerAddress?: string | undefined;
                createTime?: Date | undefined;
                commitsEndTime?: Date | undefined;
                revealsEndTime?: Date | undefined;
                commitFee?: ({
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & { [K_8 in Exclude<keyof I["auctions"]["auctions"][number]["commitFee"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
                revealFee?: ({
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & { [K_9 in Exclude<keyof I["auctions"]["auctions"][number]["revealFee"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
                minimumBid?: ({
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & { [K_10 in Exclude<keyof I["auctions"]["auctions"][number]["minimumBid"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
                winnerAddress?: string | undefined;
                winningBid?: ({
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & { [K_11 in Exclude<keyof I["auctions"]["auctions"][number]["winningBid"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
                winningPrice?: ({
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } & { [K_12 in Exclude<keyof I["auctions"]["auctions"][number]["winningPrice"], keyof import("../../../cosmos/base/v1beta1/coin").Coin>]: never; }) | undefined;
            } & { [K_13 in Exclude<keyof I["auctions"]["auctions"][number], keyof import("./auction").Auction>]: never; })[] & { [K_14 in Exclude<keyof I["auctions"]["auctions"], keyof {
                id?: string | undefined;
                status?: string | undefined;
                ownerAddress?: string | undefined;
                createTime?: Date | undefined;
                commitsEndTime?: Date | undefined;
                revealsEndTime?: Date | undefined;
                commitFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                revealFee?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                minimumBid?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                winnerAddress?: string | undefined;
                winningBid?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
                winningPrice?: {
                    denom?: string | undefined;
                    amount?: string | undefined;
                } | undefined;
            }[]>]: never; }) | undefined;
        } & { [K_15 in Exclude<keyof I["auctions"], "auctions">]: never; }) | undefined;
    } & { [K_16 in Exclude<keyof I, keyof GenesisState>]: never; }>(object: I): GenesisState;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export {};
