"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryClientImpl = exports.QueryGetAuctionModuleBalanceResponse = exports.QueryGetAuctionModuleBalanceRequest = exports.QueryAuctionsByOwnerResponse = exports.QueryAuctionsByOwnerRequest = exports.QueryAuctionsByBidderResponse = exports.QueryAuctionsByBidderRequest = exports.QueryGetBidsResponse = exports.QueryGetBidsRequest = exports.QueryGetBidResponse = exports.QueryGetBidRequest = exports.QueryGetAuctionResponse = exports.QueryGetAuctionRequest = exports.QueryAuctionsResponse = exports.QueryAuctionsRequest = exports.QueryParamsResponse = exports.QueryParamsRequest = exports.protobufPackage = void 0;
/* eslint-disable */
const auction_1 = require("./auction");
const pagination_1 = require("../../../cosmos/base/query/v1beta1/pagination");
const long_1 = __importDefault(require("long"));
const coin_1 = require("../../../cosmos/base/v1beta1/coin");
const minimal_1 = __importDefault(require("protobufjs/minimal"));
exports.protobufPackage = "cerc.auction.v1";
function createBaseQueryParamsRequest() {
    return {};
}
exports.QueryParamsRequest = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParamsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseQueryParamsRequest();
        return message;
    },
};
function createBaseQueryParamsResponse() {
    return { params: undefined };
}
exports.QueryParamsResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.params !== undefined) {
            auction_1.Params.encode(message.params, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParamsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.params = auction_1.Params.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            params: isSet(object.params) ? auction_1.Params.fromJSON(object.params) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.params !== undefined &&
            (obj.params = message.params ? auction_1.Params.toJSON(message.params) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryParamsResponse();
        message.params =
            object.params !== undefined && object.params !== null
                ? auction_1.Params.fromPartial(object.params)
                : undefined;
        return message;
    },
};
function createBaseQueryAuctionsRequest() {
    return { pagination: undefined };
}
exports.QueryAuctionsRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.pagination !== undefined) {
            pagination_1.PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryAuctionsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.pagination = pagination_1.PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            pagination: isSet(object.pagination)
                ? pagination_1.PageRequest.fromJSON(object.pagination)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? pagination_1.PageRequest.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryAuctionsRequest();
        message.pagination =
            object.pagination !== undefined && object.pagination !== null
                ? pagination_1.PageRequest.fromPartial(object.pagination)
                : undefined;
        return message;
    },
};
function createBaseQueryAuctionsResponse() {
    return { auctions: undefined, pagination: undefined };
}
exports.QueryAuctionsResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.auctions !== undefined) {
            auction_1.Auctions.encode(message.auctions, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            pagination_1.PageRequest.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryAuctionsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auctions = auction_1.Auctions.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.pagination = pagination_1.PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            auctions: isSet(object.auctions)
                ? auction_1.Auctions.fromJSON(object.auctions)
                : undefined,
            pagination: isSet(object.pagination)
                ? pagination_1.PageRequest.fromJSON(object.pagination)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.auctions !== undefined &&
            (obj.auctions = message.auctions
                ? auction_1.Auctions.toJSON(message.auctions)
                : undefined);
        message.pagination !== undefined &&
            (obj.pagination = message.pagination
                ? pagination_1.PageRequest.toJSON(message.pagination)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryAuctionsResponse();
        message.auctions =
            object.auctions !== undefined && object.auctions !== null
                ? auction_1.Auctions.fromPartial(object.auctions)
                : undefined;
        message.pagination =
            object.pagination !== undefined && object.pagination !== null
                ? pagination_1.PageRequest.fromPartial(object.pagination)
                : undefined;
        return message;
    },
};
function createBaseQueryGetAuctionRequest() {
    return { id: "" };
}
exports.QueryGetAuctionRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.id !== "") {
            writer.uint32(10).string(message.id);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetAuctionRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? String(object.id) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryGetAuctionRequest();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseQueryGetAuctionResponse() {
    return { auction: undefined };
}
exports.QueryGetAuctionResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.auction !== undefined) {
            auction_1.Auction.encode(message.auction, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetAuctionResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auction = auction_1.Auction.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            auction: isSet(object.auction)
                ? auction_1.Auction.fromJSON(object.auction)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.auction !== undefined &&
            (obj.auction = message.auction
                ? auction_1.Auction.toJSON(message.auction)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryGetAuctionResponse();
        message.auction =
            object.auction !== undefined && object.auction !== null
                ? auction_1.Auction.fromPartial(object.auction)
                : undefined;
        return message;
    },
};
function createBaseQueryGetBidRequest() {
    return { auctionId: "", bidder: "" };
}
exports.QueryGetBidRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.auctionId !== "") {
            writer.uint32(10).string(message.auctionId);
        }
        if (message.bidder !== "") {
            writer.uint32(18).string(message.bidder);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetBidRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auctionId = reader.string();
                    break;
                case 2:
                    message.bidder = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            auctionId: isSet(object.auctionId) ? String(object.auctionId) : "",
            bidder: isSet(object.bidder) ? String(object.bidder) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.auctionId !== undefined && (obj.auctionId = message.auctionId);
        message.bidder !== undefined && (obj.bidder = message.bidder);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseQueryGetBidRequest();
        message.auctionId = (_a = object.auctionId) !== null && _a !== void 0 ? _a : "";
        message.bidder = (_b = object.bidder) !== null && _b !== void 0 ? _b : "";
        return message;
    },
};
function createBaseQueryGetBidResponse() {
    return { bid: undefined };
}
exports.QueryGetBidResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.bid !== undefined) {
            auction_1.Bid.encode(message.bid, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetBidResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.bid = auction_1.Bid.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            bid: isSet(object.bid) ? auction_1.Bid.fromJSON(object.bid) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.bid !== undefined &&
            (obj.bid = message.bid ? auction_1.Bid.toJSON(message.bid) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryGetBidResponse();
        message.bid =
            object.bid !== undefined && object.bid !== null
                ? auction_1.Bid.fromPartial(object.bid)
                : undefined;
        return message;
    },
};
function createBaseQueryGetBidsRequest() {
    return { auctionId: "" };
}
exports.QueryGetBidsRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.auctionId !== "") {
            writer.uint32(10).string(message.auctionId);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetBidsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auctionId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            auctionId: isSet(object.auctionId) ? String(object.auctionId) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.auctionId !== undefined && (obj.auctionId = message.auctionId);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryGetBidsRequest();
        message.auctionId = (_a = object.auctionId) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseQueryGetBidsResponse() {
    return { bids: [] };
}
exports.QueryGetBidsResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        for (const v of message.bids) {
            auction_1.Bid.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetBidsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.bids.push(auction_1.Bid.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            bids: Array.isArray(object === null || object === void 0 ? void 0 : object.bids)
                ? object.bids.map((e) => auction_1.Bid.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.bids) {
            obj.bids = message.bids.map((e) => (e ? auction_1.Bid.toJSON(e) : undefined));
        }
        else {
            obj.bids = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryGetBidsResponse();
        message.bids = ((_a = object.bids) === null || _a === void 0 ? void 0 : _a.map((e) => auction_1.Bid.fromPartial(e))) || [];
        return message;
    },
};
function createBaseQueryAuctionsByBidderRequest() {
    return { bidderAddress: "" };
}
exports.QueryAuctionsByBidderRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.bidderAddress !== "") {
            writer.uint32(10).string(message.bidderAddress);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryAuctionsByBidderRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.bidderAddress = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            bidderAddress: isSet(object.bidderAddress)
                ? String(object.bidderAddress)
                : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.bidderAddress !== undefined &&
            (obj.bidderAddress = message.bidderAddress);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryAuctionsByBidderRequest();
        message.bidderAddress = (_a = object.bidderAddress) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseQueryAuctionsByBidderResponse() {
    return { auctions: undefined };
}
exports.QueryAuctionsByBidderResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.auctions !== undefined) {
            auction_1.Auctions.encode(message.auctions, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryAuctionsByBidderResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auctions = auction_1.Auctions.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            auctions: isSet(object.auctions)
                ? auction_1.Auctions.fromJSON(object.auctions)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.auctions !== undefined &&
            (obj.auctions = message.auctions
                ? auction_1.Auctions.toJSON(message.auctions)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryAuctionsByBidderResponse();
        message.auctions =
            object.auctions !== undefined && object.auctions !== null
                ? auction_1.Auctions.fromPartial(object.auctions)
                : undefined;
        return message;
    },
};
function createBaseQueryAuctionsByOwnerRequest() {
    return { ownerAddress: "" };
}
exports.QueryAuctionsByOwnerRequest = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.ownerAddress !== "") {
            writer.uint32(10).string(message.ownerAddress);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryAuctionsByOwnerRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.ownerAddress = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            ownerAddress: isSet(object.ownerAddress)
                ? String(object.ownerAddress)
                : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.ownerAddress !== undefined &&
            (obj.ownerAddress = message.ownerAddress);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryAuctionsByOwnerRequest();
        message.ownerAddress = (_a = object.ownerAddress) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseQueryAuctionsByOwnerResponse() {
    return { auctions: undefined };
}
exports.QueryAuctionsByOwnerResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.auctions !== undefined) {
            auction_1.Auctions.encode(message.auctions, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryAuctionsByOwnerResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auctions = auction_1.Auctions.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            auctions: isSet(object.auctions)
                ? auction_1.Auctions.fromJSON(object.auctions)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.auctions !== undefined &&
            (obj.auctions = message.auctions
                ? auction_1.Auctions.toJSON(message.auctions)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryAuctionsByOwnerResponse();
        message.auctions =
            object.auctions !== undefined && object.auctions !== null
                ? auction_1.Auctions.fromPartial(object.auctions)
                : undefined;
        return message;
    },
};
function createBaseQueryGetAuctionModuleBalanceRequest() {
    return {};
}
exports.QueryGetAuctionModuleBalanceRequest = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetAuctionModuleBalanceRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseQueryGetAuctionModuleBalanceRequest();
        return message;
    },
};
function createBaseQueryGetAuctionModuleBalanceResponse() {
    return { balance: [] };
}
exports.QueryGetAuctionModuleBalanceResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        for (const v of message.balance) {
            coin_1.Coin.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGetAuctionModuleBalanceResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.balance.push(coin_1.Coin.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            balance: Array.isArray(object === null || object === void 0 ? void 0 : object.balance)
                ? object.balance.map((e) => coin_1.Coin.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.balance) {
            obj.balance = message.balance.map((e) => e ? coin_1.Coin.toJSON(e) : undefined);
        }
        else {
            obj.balance = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseQueryGetAuctionModuleBalanceResponse();
        message.balance = ((_a = object.balance) === null || _a === void 0 ? void 0 : _a.map((e) => coin_1.Coin.fromPartial(e))) || [];
        return message;
    },
};
class QueryClientImpl {
    constructor(rpc) {
        this.rpc = rpc;
        this.Params = this.Params.bind(this);
        this.Auctions = this.Auctions.bind(this);
        this.GetAuction = this.GetAuction.bind(this);
        this.GetBid = this.GetBid.bind(this);
        this.GetBids = this.GetBids.bind(this);
        this.AuctionsByBidder = this.AuctionsByBidder.bind(this);
        this.AuctionsByOwner = this.AuctionsByOwner.bind(this);
        this.GetAuctionModuleBalance = this.GetAuctionModuleBalance.bind(this);
    }
    Params(request) {
        const data = exports.QueryParamsRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.auction.v1.Query", "Params", data);
        return promise.then((data) => exports.QueryParamsResponse.decode(new minimal_1.default.Reader(data)));
    }
    Auctions(request) {
        const data = exports.QueryAuctionsRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.auction.v1.Query", "Auctions", data);
        return promise.then((data) => exports.QueryAuctionsResponse.decode(new minimal_1.default.Reader(data)));
    }
    GetAuction(request) {
        const data = exports.QueryGetAuctionRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.auction.v1.Query", "GetAuction", data);
        return promise.then((data) => exports.QueryGetAuctionResponse.decode(new minimal_1.default.Reader(data)));
    }
    GetBid(request) {
        const data = exports.QueryGetBidRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.auction.v1.Query", "GetBid", data);
        return promise.then((data) => exports.QueryGetBidResponse.decode(new minimal_1.default.Reader(data)));
    }
    GetBids(request) {
        const data = exports.QueryGetBidsRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.auction.v1.Query", "GetBids", data);
        return promise.then((data) => exports.QueryGetBidsResponse.decode(new minimal_1.default.Reader(data)));
    }
    AuctionsByBidder(request) {
        const data = exports.QueryAuctionsByBidderRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.auction.v1.Query", "AuctionsByBidder", data);
        return promise.then((data) => exports.QueryAuctionsByBidderResponse.decode(new minimal_1.default.Reader(data)));
    }
    AuctionsByOwner(request) {
        const data = exports.QueryAuctionsByOwnerRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.auction.v1.Query", "AuctionsByOwner", data);
        return promise.then((data) => exports.QueryAuctionsByOwnerResponse.decode(new minimal_1.default.Reader(data)));
    }
    GetAuctionModuleBalance(request) {
        const data = exports.QueryGetAuctionModuleBalanceRequest.encode(request).finish();
        const promise = this.rpc.request("cerc.auction.v1.Query", "GetAuctionModuleBalance", data);
        return promise.then((data) => exports.QueryGetAuctionModuleBalanceResponse.decode(new minimal_1.default.Reader(data)));
    }
}
exports.QueryClientImpl = QueryClientImpl;
if (minimal_1.default.util.Long !== long_1.default) {
    minimal_1.default.util.Long = long_1.default;
    minimal_1.default.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
