"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MsgClientImpl = exports.MsgRevealBidResponse = exports.MsgRevealBid = exports.MsgCommitBidResponse = exports.MsgCommitBid = exports.MsgCreateAuctionResponse = exports.MsgCreateAuction = exports.protobufPackage = void 0;
/* eslint-disable */
const duration_1 = require("../../../google/protobuf/duration");
const coin_1 = require("../../../cosmos/base/v1beta1/coin");
const auction_1 = require("./auction");
const long_1 = __importDefault(require("long"));
const minimal_1 = __importDefault(require("protobufjs/minimal"));
exports.protobufPackage = "cerc.auction.v1";
function createBaseMsgCreateAuction() {
    return {
        commitsDuration: undefined,
        revealsDuration: undefined,
        commitFee: undefined,
        revealFee: undefined,
        minimumBid: undefined,
        signer: "",
    };
}
exports.MsgCreateAuction = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.commitsDuration !== undefined) {
            duration_1.Duration.encode(message.commitsDuration, writer.uint32(10).fork()).ldelim();
        }
        if (message.revealsDuration !== undefined) {
            duration_1.Duration.encode(message.revealsDuration, writer.uint32(18).fork()).ldelim();
        }
        if (message.commitFee !== undefined) {
            coin_1.Coin.encode(message.commitFee, writer.uint32(26).fork()).ldelim();
        }
        if (message.revealFee !== undefined) {
            coin_1.Coin.encode(message.revealFee, writer.uint32(34).fork()).ldelim();
        }
        if (message.minimumBid !== undefined) {
            coin_1.Coin.encode(message.minimumBid, writer.uint32(42).fork()).ldelim();
        }
        if (message.signer !== "") {
            writer.uint32(50).string(message.signer);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCreateAuction();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.commitsDuration = duration_1.Duration.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.revealsDuration = duration_1.Duration.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.commitFee = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.revealFee = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.minimumBid = coin_1.Coin.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.signer = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            commitsDuration: isSet(object.commitsDuration)
                ? duration_1.Duration.fromJSON(object.commitsDuration)
                : undefined,
            revealsDuration: isSet(object.revealsDuration)
                ? duration_1.Duration.fromJSON(object.revealsDuration)
                : undefined,
            commitFee: isSet(object.commitFee)
                ? coin_1.Coin.fromJSON(object.commitFee)
                : undefined,
            revealFee: isSet(object.revealFee)
                ? coin_1.Coin.fromJSON(object.revealFee)
                : undefined,
            minimumBid: isSet(object.minimumBid)
                ? coin_1.Coin.fromJSON(object.minimumBid)
                : undefined,
            signer: isSet(object.signer) ? String(object.signer) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.commitsDuration !== undefined &&
            (obj.commitsDuration = message.commitsDuration
                ? duration_1.Duration.toJSON(message.commitsDuration)
                : undefined);
        message.revealsDuration !== undefined &&
            (obj.revealsDuration = message.revealsDuration
                ? duration_1.Duration.toJSON(message.revealsDuration)
                : undefined);
        message.commitFee !== undefined &&
            (obj.commitFee = message.commitFee
                ? coin_1.Coin.toJSON(message.commitFee)
                : undefined);
        message.revealFee !== undefined &&
            (obj.revealFee = message.revealFee
                ? coin_1.Coin.toJSON(message.revealFee)
                : undefined);
        message.minimumBid !== undefined &&
            (obj.minimumBid = message.minimumBid
                ? coin_1.Coin.toJSON(message.minimumBid)
                : undefined);
        message.signer !== undefined && (obj.signer = message.signer);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseMsgCreateAuction();
        message.commitsDuration =
            object.commitsDuration !== undefined && object.commitsDuration !== null
                ? duration_1.Duration.fromPartial(object.commitsDuration)
                : undefined;
        message.revealsDuration =
            object.revealsDuration !== undefined && object.revealsDuration !== null
                ? duration_1.Duration.fromPartial(object.revealsDuration)
                : undefined;
        message.commitFee =
            object.commitFee !== undefined && object.commitFee !== null
                ? coin_1.Coin.fromPartial(object.commitFee)
                : undefined;
        message.revealFee =
            object.revealFee !== undefined && object.revealFee !== null
                ? coin_1.Coin.fromPartial(object.revealFee)
                : undefined;
        message.minimumBid =
            object.minimumBid !== undefined && object.minimumBid !== null
                ? coin_1.Coin.fromPartial(object.minimumBid)
                : undefined;
        message.signer = (_a = object.signer) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseMsgCreateAuctionResponse() {
    return { auction: undefined };
}
exports.MsgCreateAuctionResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.auction !== undefined) {
            auction_1.Auction.encode(message.auction, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCreateAuctionResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auction = auction_1.Auction.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            auction: isSet(object.auction)
                ? auction_1.Auction.fromJSON(object.auction)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.auction !== undefined &&
            (obj.auction = message.auction
                ? auction_1.Auction.toJSON(message.auction)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgCreateAuctionResponse();
        message.auction =
            object.auction !== undefined && object.auction !== null
                ? auction_1.Auction.fromPartial(object.auction)
                : undefined;
        return message;
    },
};
function createBaseMsgCommitBid() {
    return { auctionId: "", commitHash: "", signer: "" };
}
exports.MsgCommitBid = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.auctionId !== "") {
            writer.uint32(10).string(message.auctionId);
        }
        if (message.commitHash !== "") {
            writer.uint32(18).string(message.commitHash);
        }
        if (message.signer !== "") {
            writer.uint32(26).string(message.signer);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCommitBid();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auctionId = reader.string();
                    break;
                case 2:
                    message.commitHash = reader.string();
                    break;
                case 3:
                    message.signer = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            auctionId: isSet(object.auctionId) ? String(object.auctionId) : "",
            commitHash: isSet(object.commitHash) ? String(object.commitHash) : "",
            signer: isSet(object.signer) ? String(object.signer) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.auctionId !== undefined && (obj.auctionId = message.auctionId);
        message.commitHash !== undefined && (obj.commitHash = message.commitHash);
        message.signer !== undefined && (obj.signer = message.signer);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBaseMsgCommitBid();
        message.auctionId = (_a = object.auctionId) !== null && _a !== void 0 ? _a : "";
        message.commitHash = (_b = object.commitHash) !== null && _b !== void 0 ? _b : "";
        message.signer = (_c = object.signer) !== null && _c !== void 0 ? _c : "";
        return message;
    },
};
function createBaseMsgCommitBidResponse() {
    return { bid: undefined };
}
exports.MsgCommitBidResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.bid !== undefined) {
            auction_1.Bid.encode(message.bid, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCommitBidResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.bid = auction_1.Bid.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            bid: isSet(object.bid) ? auction_1.Bid.fromJSON(object.bid) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.bid !== undefined &&
            (obj.bid = message.bid ? auction_1.Bid.toJSON(message.bid) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgCommitBidResponse();
        message.bid =
            object.bid !== undefined && object.bid !== null
                ? auction_1.Bid.fromPartial(object.bid)
                : undefined;
        return message;
    },
};
function createBaseMsgRevealBid() {
    return { auctionId: "", reveal: "", signer: "" };
}
exports.MsgRevealBid = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.auctionId !== "") {
            writer.uint32(10).string(message.auctionId);
        }
        if (message.reveal !== "") {
            writer.uint32(18).string(message.reveal);
        }
        if (message.signer !== "") {
            writer.uint32(26).string(message.signer);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgRevealBid();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auctionId = reader.string();
                    break;
                case 2:
                    message.reveal = reader.string();
                    break;
                case 3:
                    message.signer = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            auctionId: isSet(object.auctionId) ? String(object.auctionId) : "",
            reveal: isSet(object.reveal) ? String(object.reveal) : "",
            signer: isSet(object.signer) ? String(object.signer) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.auctionId !== undefined && (obj.auctionId = message.auctionId);
        message.reveal !== undefined && (obj.reveal = message.reveal);
        message.signer !== undefined && (obj.signer = message.signer);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBaseMsgRevealBid();
        message.auctionId = (_a = object.auctionId) !== null && _a !== void 0 ? _a : "";
        message.reveal = (_b = object.reveal) !== null && _b !== void 0 ? _b : "";
        message.signer = (_c = object.signer) !== null && _c !== void 0 ? _c : "";
        return message;
    },
};
function createBaseMsgRevealBidResponse() {
    return { auction: undefined };
}
exports.MsgRevealBidResponse = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.auction !== undefined) {
            auction_1.Auction.encode(message.auction, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgRevealBidResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auction = auction_1.Auction.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            auction: isSet(object.auction)
                ? auction_1.Auction.fromJSON(object.auction)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.auction !== undefined &&
            (obj.auction = message.auction
                ? auction_1.Auction.toJSON(message.auction)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgRevealBidResponse();
        message.auction =
            object.auction !== undefined && object.auction !== null
                ? auction_1.Auction.fromPartial(object.auction)
                : undefined;
        return message;
    },
};
class MsgClientImpl {
    constructor(rpc) {
        this.rpc = rpc;
        this.CreateAuction = this.CreateAuction.bind(this);
        this.CommitBid = this.CommitBid.bind(this);
        this.RevealBid = this.RevealBid.bind(this);
    }
    CreateAuction(request) {
        const data = exports.MsgCreateAuction.encode(request).finish();
        const promise = this.rpc.request("cerc.auction.v1.Msg", "CreateAuction", data);
        return promise.then((data) => exports.MsgCreateAuctionResponse.decode(new minimal_1.default.Reader(data)));
    }
    CommitBid(request) {
        const data = exports.MsgCommitBid.encode(request).finish();
        const promise = this.rpc.request("cerc.auction.v1.Msg", "CommitBid", data);
        return promise.then((data) => exports.MsgCommitBidResponse.decode(new minimal_1.default.Reader(data)));
    }
    RevealBid(request) {
        const data = exports.MsgRevealBid.encode(request).finish();
        const promise = this.rpc.request("cerc.auction.v1.Msg", "RevealBid", data);
        return promise.then((data) => exports.MsgRevealBidResponse.decode(new minimal_1.default.Reader(data)));
    }
}
exports.MsgClientImpl = MsgClientImpl;
if (minimal_1.default.util.Long !== long_1.default) {
    minimal_1.default.util.Long = long_1.default;
    minimal_1.default.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
