import { Coin } from "../../../cosmos/base/v1beta1/coin";
import Long from "long";
import _m0 from "protobufjs/minimal";
export declare const protobufPackage = "cerc.bond.v1";
/** Params defines the parameters of the bond module. */
export interface Params {
    /** max_bond_amount is maximum amount to bond */
    maxBondAmount?: Coin;
}
/** Bond represents funds deposited by an account for record rent payments. */
export interface Bond {
    /** id is unique identifier of the bond */
    id: string;
    /** owner of the bond */
    owner: string;
    /** balance of the bond */
    balance: Coin[];
}
export declare const Params: {
    encode(message: Params, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): Params;
    fromJSON(object: any): Params;
    toJSON(message: Params): unknown;
    fromPartial<I extends {
        maxBondAmount?: {
            denom?: string | undefined;
            amount?: string | undefined;
        } | undefined;
    } & {
        maxBondAmount?: ({
            denom?: string | undefined;
            amount?: string | undefined;
        } & {
            denom?: string | undefined;
            amount?: string | undefined;
        } & { [K in Exclude<keyof I["maxBondAmount"], keyof Coin>]: never; }) | undefined;
    } & { [K_1 in Exclude<keyof I, "maxBondAmount">]: never; }>(object: I): Params;
};
export declare const Bond: {
    encode(message: Bond, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): Bond;
    fromJSON(object: any): Bond;
    toJSON(message: Bond): unknown;
    fromPartial<I extends {
        id?: string | undefined;
        owner?: string | undefined;
        balance?: {
            denom?: string | undefined;
            amount?: string | undefined;
        }[] | undefined;
    } & {
        id?: string | undefined;
        owner?: string | undefined;
        balance?: ({
            denom?: string | undefined;
            amount?: string | undefined;
        }[] & ({
            denom?: string | undefined;
            amount?: string | undefined;
        } & {
            denom?: string | undefined;
            amount?: string | undefined;
        } & { [K in Exclude<keyof I["balance"][number], keyof Coin>]: never; })[] & { [K_1 in Exclude<keyof I["balance"], keyof {
            denom?: string | undefined;
            amount?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_2 in Exclude<keyof I, keyof Bond>]: never; }>(object: I): Bond;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export {};
