/**
 * Registry
 */
export declare class RegistryClient {
    _rpcEndpoint: string;
    _graph: any;
    /**
     * Get query result.
     */
    static getResult(query: any, key: string, modifier?: (rows: any[]) => {}): Promise<any>;
    /**
     * Prepare response attributes.
     */
    static prepareAttributes(path: string): (rows: any[]) => any[];
    /**
     * New Client.
     */
    constructor(gqlEndpoint: string, rpcEndpoint: string);
    /**
     * Get server status.
     */
    getStatus(): Promise<any>;
    /**
     * Fetch Accounts.
     */
    getAccounts(addresses: string[]): Promise<any>;
    /**
     * Get records by ids.
     */
    getRecordsByIds(ids: string[], refs?: boolean): Promise<any>;
    /**
     * Get records by attributes.
     */
    queryRecords(attributes: {
        [key: string]: any;
    }, all?: boolean, refs?: boolean, limit?: number, offset?: number): Promise<any>;
    /**
     * List authorities by owner.
     */
    getAuthorities(owner?: string, auction?: boolean): Promise<any>;
    /**
     * Lookup authorities by names.
     */
    lookupAuthorities(names: string[], auction?: boolean): Promise<any>;
    /**
     * Get auctions by ids.
     */
    getAuctionsByIds(ids: string[]): Promise<any>;
    /**
     * Lookup names.
     */
    lookupNames(names: string[], history?: boolean): Promise<any>;
    /**
     * Resolve names to records.
     */
    resolveNames(names: string[], refs?: boolean): Promise<any>;
    /**
     * Get bonds by ids.
     */
    getBondsByIds(ids: string[]): Promise<any>;
    /**
     * Get bonds.
     */
    queryBonds(): Promise<any>;
    /**
     * Get bonds by owner(s).
     */
    queryBondsByOwner(ownerAddresses: string[]): Promise<any>;
    /**
    * Get participants.
    */
    getParticipants(): Promise<any>;
    /**
    * Get participant by cosmos address.
    */
    getParticipantByAddress(address: string): Promise<any>;
    /**
    * Get participant by nitro address.
    */
    getParticipantByNitroAddress(nitroAddress: string): Promise<any>;
}
