/**
 * Utils
 */
export declare class Util {
    /**
     * Sorts JSON object.
     */
    static sortJSON(obj: any): any;
    /**
     * Marshal object into gql 'attributes' variable.
     */
    static toGQLAttributes(obj: any): any[];
    static toGQLValue(obj: any): {
        [x: string]: any;
        string?: undefined;
        boolean?: undefined;
        link?: undefined;
        array?: undefined;
        map?: undefined;
    } | {
        string: any;
        boolean?: undefined;
        link?: undefined;
        array?: undefined;
        map?: undefined;
    } | {
        boolean: any;
        string?: undefined;
        link?: undefined;
        array?: undefined;
        map?: undefined;
    } | {
        link: any;
        string?: undefined;
        boolean?: undefined;
        array?: undefined;
        map?: undefined;
    } | {
        array: any[];
        string?: undefined;
        boolean?: undefined;
        link?: undefined;
        map?: undefined;
    } | {
        map: any;
        string?: undefined;
        boolean?: undefined;
        link?: undefined;
        array?: undefined;
    } | null | undefined;
    /**
     * Unmarshal attributes array to object.
     */
    static fromGQLAttributes(attributes?: any[]): {
        [key: string]: any;
    };
    static fromGQLValue(obj: any): any;
    /**
     * Get record content ID.
     */
    static getContentId(record: any): Promise<string>;
}
