import { Params, Record, NameAuthority, NameRecord, NameEntry, AuthorityEntry } from "./registry";
import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import Long from "long";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import _m0 from "protobufjs/minimal";
export declare const protobufPackage = "cerc.registry.v1";
/** QueryParamsRequest is request type for registry params */
export interface QueryParamsRequest {
}
/** QueryParamsResponse is response type for registry params */
export interface QueryParamsResponse {
    params?: Params;
}
/** QueryRecordsRequest is request type for registry records list */
export interface QueryRecordsRequest {
    attributes: QueryRecordsRequest_KeyValueInput[];
    all: boolean;
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequest;
}
/** Array type attribute */
export interface QueryRecordsRequest_ArrayInput {
    values: QueryRecordsRequest_ValueInput[];
}
/** Map type attribute */
export interface QueryRecordsRequest_MapInput {
    values: {
        [key: string]: QueryRecordsRequest_ValueInput;
    };
}
export interface QueryRecordsRequest_MapInput_ValuesEntry {
    key: string;
    value?: QueryRecordsRequest_ValueInput;
}
/** Type for record attribute value */
export interface QueryRecordsRequest_ValueInput {
    string: string | undefined;
    int: Long | undefined;
    float: number | undefined;
    boolean: boolean | undefined;
    link: string | undefined;
    array?: QueryRecordsRequest_ArrayInput | undefined;
    map?: QueryRecordsRequest_MapInput | undefined;
}
/** Type for record attribute key */
export interface QueryRecordsRequest_KeyValueInput {
    key: string;
    value?: QueryRecordsRequest_ValueInput;
}
/** QueryRecordsResponse is response type for registry records list */
export interface QueryRecordsResponse {
    records: Record[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponse;
}
/** QueryGetRecordRequest is request type for registry records by id */
export interface QueryGetRecordRequest {
    id: string;
}
/** QueryGetRecordResponse is response type for registry records by id */
export interface QueryGetRecordResponse {
    record?: Record;
}
/** QueryGetRecordsByBondIdRequest is request type for get the records by bond-id */
export interface QueryGetRecordsByBondIdRequest {
    id: string;
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequest;
}
/** QueryGetRecordsByBondIdResponse is response type for records list by bond-id */
export interface QueryGetRecordsByBondIdResponse {
    records: Record[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponse;
}
/** QueryNameRecordsRequest is request type for registry names records */
export interface QueryNameRecordsRequest {
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequest;
}
/** QueryNameRecordsResponse is response type for registry names records */
export interface QueryNameRecordsResponse {
    names: NameEntry[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponse;
}
/** QueryWhoisRequest is request type for Get NameAuthority */
export interface QueryWhoisRequest {
    name: string;
}
/** QueryWhoisResponse is response type for whois request */
export interface QueryWhoisResponse {
    nameAuthority?: NameAuthority;
}
/** QueryAuthoritiesRequest is request type to get all authorities */
export interface QueryAuthoritiesRequest {
    owner: string;
}
/** QueryAuthoritiesResponse is response type for authorities request */
export interface QueryAuthoritiesResponse {
    authorities: AuthorityEntry[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponse;
}
/** QueryLookupLrnRequest is request type for LookupLrn */
export interface QueryLookupLrnRequest {
    lrn: string;
}
/** QueryLookupLrnResponse is response type for QueryLookupLrnRequest */
export interface QueryLookupLrnResponse {
    name?: NameRecord;
}
/** QueryResolveLrnRequest is request type for ResolveLrn */
export interface QueryResolveLrnRequest {
    lrn: string;
}
/** QueryResolveLrnResponse is response type for QueryResolveLrnRequest */
export interface QueryResolveLrnResponse {
    record?: Record;
}
/**
 * QueryGetRegistryModuleBalanceRequest is request type for registry module
 * accounts balance
 */
export interface QueryGetRegistryModuleBalanceRequest {
}
/**
 * QueryGetRegistryModuleBalanceResponse is response type for registry module
 * accounts balance
 */
export interface QueryGetRegistryModuleBalanceResponse {
    balances: AccountBalance[];
}
/** AccountBalance is registry module account balance */
export interface AccountBalance {
    accountName: string;
    balance: Coin[];
}
export declare const QueryParamsRequest: {
    encode(_: QueryParamsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsRequest;
    fromJSON(_: any): QueryParamsRequest;
    toJSON(_: QueryParamsRequest): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): QueryParamsRequest;
};
export declare const QueryParamsResponse: {
    encode(message: QueryParamsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsResponse;
    fromJSON(object: any): QueryParamsResponse;
    toJSON(message: QueryParamsResponse): unknown;
    fromPartial<I extends {
        params?: {
            recordRent?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            recordRentDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityRent?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            authorityRentDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityGracePeriod?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityAuctionEnabled?: boolean | undefined;
            authorityAuctionCommitsDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityAuctionRevealsDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityAuctionCommitFee?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            authorityAuctionRevealFee?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            authorityAuctionMinimumBid?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
        } | undefined;
    } & {
        params?: ({
            recordRent?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            recordRentDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityRent?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            authorityRentDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityGracePeriod?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityAuctionEnabled?: boolean | undefined;
            authorityAuctionCommitsDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityAuctionRevealsDuration?: {
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } | undefined;
            authorityAuctionCommitFee?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            authorityAuctionRevealFee?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
            authorityAuctionMinimumBid?: {
                denom?: string | undefined;
                amount?: string | undefined;
            } | undefined;
        } & {
            recordRent?: ({
                denom?: string | undefined;
                amount?: string | undefined;
            } & {
                denom?: string | undefined;
                amount?: string | undefined;
            } & { [K in Exclude<keyof I["params"]["recordRent"], keyof Coin>]: never; }) | undefined;
            recordRentDuration?: ({
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } & {
                seconds?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_1 in Exclude<keyof I["params"]["recordRentDuration"]["seconds"], keyof Long.Long>]: never; }) | undefined;
                nanos?: number | undefined;
            } & { [K_2 in Exclude<keyof I["params"]["recordRentDuration"], keyof import("../../../google/protobuf/duration").Duration>]: never; }) | undefined;
            authorityRent?: ({
                denom?: string | undefined;
                amount?: string | undefined;
            } & {
                denom?: string | undefined;
                amount?: string | undefined;
            } & { [K_3 in Exclude<keyof I["params"]["authorityRent"], keyof Coin>]: never; }) | undefined;
            authorityRentDuration?: ({
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } & {
                seconds?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_4 in Exclude<keyof I["params"]["authorityRentDuration"]["seconds"], keyof Long.Long>]: never; }) | undefined;
                nanos?: number | undefined;
            } & { [K_5 in Exclude<keyof I["params"]["authorityRentDuration"], keyof import("../../../google/protobuf/duration").Duration>]: never; }) | undefined;
            authorityGracePeriod?: ({
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } & {
                seconds?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_6 in Exclude<keyof I["params"]["authorityGracePeriod"]["seconds"], keyof Long.Long>]: never; }) | undefined;
                nanos?: number | undefined;
            } & { [K_7 in Exclude<keyof I["params"]["authorityGracePeriod"], keyof import("../../../google/protobuf/duration").Duration>]: never; }) | undefined;
            authorityAuctionEnabled?: boolean | undefined;
            authorityAuctionCommitsDuration?: ({
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } & {
                seconds?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_8 in Exclude<keyof I["params"]["authorityAuctionCommitsDuration"]["seconds"], keyof Long.Long>]: never; }) | undefined;
                nanos?: number | undefined;
            } & { [K_9 in Exclude<keyof I["params"]["authorityAuctionCommitsDuration"], keyof import("../../../google/protobuf/duration").Duration>]: never; }) | undefined;
            authorityAuctionRevealsDuration?: ({
                seconds?: string | number | Long.Long | undefined;
                nanos?: number | undefined;
            } & {
                seconds?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_10 in Exclude<keyof I["params"]["authorityAuctionRevealsDuration"]["seconds"], keyof Long.Long>]: never; }) | undefined;
                nanos?: number | undefined;
            } & { [K_11 in Exclude<keyof I["params"]["authorityAuctionRevealsDuration"], keyof import("../../../google/protobuf/duration").Duration>]: never; }) | undefined;
            authorityAuctionCommitFee?: ({
                denom?: string | undefined;
                amount?: string | undefined;
            } & {
                denom?: string | undefined;
                amount?: string | undefined;
            } & { [K_12 in Exclude<keyof I["params"]["authorityAuctionCommitFee"], keyof Coin>]: never; }) | undefined;
            authorityAuctionRevealFee?: ({
                denom?: string | undefined;
                amount?: string | undefined;
            } & {
                denom?: string | undefined;
                amount?: string | undefined;
            } & { [K_13 in Exclude<keyof I["params"]["authorityAuctionRevealFee"], keyof Coin>]: never; }) | undefined;
            authorityAuctionMinimumBid?: ({
                denom?: string | undefined;
                amount?: string | undefined;
            } & {
                denom?: string | undefined;
                amount?: string | undefined;
            } & { [K_14 in Exclude<keyof I["params"]["authorityAuctionMinimumBid"], keyof Coin>]: never; }) | undefined;
        } & { [K_15 in Exclude<keyof I["params"], keyof Params>]: never; }) | undefined;
    } & { [K_16 in Exclude<keyof I, "params">]: never; }>(object: I): QueryParamsResponse;
};
export declare const QueryRecordsRequest: {
    encode(message: QueryRecordsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryRecordsRequest;
    fromJSON(object: any): QueryRecordsRequest;
    toJSON(message: QueryRecordsRequest): unknown;
    fromPartial<I extends {
        attributes?: {
            key?: string | undefined;
            value?: {
                string?: string | undefined;
                int?: string | number | Long.Long | undefined;
                float?: number | undefined;
                boolean?: boolean | undefined;
                link?: string | undefined;
                array?: {
                    values?: any[] | undefined;
                } | undefined;
                map?: {
                    values?: {
                        [x: string]: any | undefined;
                    } | undefined;
                } | undefined;
            } | undefined;
        }[] | undefined;
        all?: boolean | undefined;
        pagination?: {
            key?: Uint8Array | undefined;
            offset?: string | number | Long.Long | undefined;
            limit?: string | number | Long.Long | undefined;
            countTotal?: boolean | undefined;
            reverse?: boolean | undefined;
        } | undefined;
    } & {
        attributes?: ({
            key?: string | undefined;
            value?: {
                string?: string | undefined;
                int?: string | number | Long.Long | undefined;
                float?: number | undefined;
                boolean?: boolean | undefined;
                link?: string | undefined;
                array?: {
                    values?: any[] | undefined;
                } | undefined;
                map?: {
                    values?: {
                        [x: string]: any | undefined;
                    } | undefined;
                } | undefined;
            } | undefined;
        }[] & ({
            key?: string | undefined;
            value?: {
                string?: string | undefined;
                int?: string | number | Long.Long | undefined;
                float?: number | undefined;
                boolean?: boolean | undefined;
                link?: string | undefined;
                array?: {
                    values?: any[] | undefined;
                } | undefined;
                map?: {
                    values?: {
                        [x: string]: any | undefined;
                    } | undefined;
                } | undefined;
            } | undefined;
        } & {
            key?: string | undefined;
            value?: ({
                string?: string | undefined;
                int?: string | number | Long.Long | undefined;
                float?: number | undefined;
                boolean?: boolean | undefined;
                link?: string | undefined;
                array?: {
                    values?: any[] | undefined;
                } | undefined;
                map?: {
                    values?: {
                        [x: string]: any | undefined;
                    } | undefined;
                } | undefined;
            } & {
                string?: string | undefined;
                int?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K in Exclude<keyof I["attributes"][number]["value"]["int"], keyof Long.Long>]: never; }) | undefined;
                float?: number | undefined;
                boolean?: boolean | undefined;
                link?: string | undefined;
                array?: ({
                    values?: any[] | undefined;
                } & {
                    values?: (any[] & ({
                        string?: string | undefined;
                        int?: string | number | Long.Long | undefined;
                        float?: number | undefined;
                        boolean?: boolean | undefined;
                        link?: string | undefined;
                        array?: {
                            values?: any[] | undefined;
                        } | undefined;
                        map?: {
                            values?: {
                                [x: string]: any | undefined;
                            } | undefined;
                        } | undefined;
                    } & {
                        string?: string | undefined;
                        int?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_1 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                        float?: number | undefined;
                        boolean?: boolean | undefined;
                        link?: string | undefined;
                        array?: ({
                            values?: any[] | undefined;
                        } & {
                            values?: (any[] & ({
                                string?: string | undefined;
                                int?: string | number | Long.Long | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: {
                                    values?: any[] | undefined;
                                } | undefined;
                                map?: {
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } | undefined;
                            } & {
                                string?: string | undefined;
                                int?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_2 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: ({
                                    values?: any[] | undefined;
                                } & {
                                    values?: (any[] & ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_3 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_4 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_5 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_6 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_7 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_8 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_9 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_10 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_11 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_12 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                    } & { [K_13 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_14 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                } & { [K_15 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                map?: ({
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } & {
                                    values?: ({
                                        [x: string]: any | undefined;
                                    } & {
                                        [x: string]: ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_16 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_17 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_18 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_19 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_20 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_21 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                        } & { [K_22 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                    } & { [K_23 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                } & { [K_24 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                            } & { [K_25 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_26 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                        } & { [K_27 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                        map?: ({
                            values?: {
                                [x: string]: any | undefined;
                            } | undefined;
                        } & {
                            values?: ({
                                [x: string]: any | undefined;
                            } & {
                                [x: string]: ({
                                    string?: string | undefined;
                                    int?: string | number | Long.Long | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: {
                                        values?: any[] | undefined;
                                    } | undefined;
                                    map?: {
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } | undefined;
                                } & {
                                    string?: string | undefined;
                                    int?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_28 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: ({
                                        values?: any[] | undefined;
                                    } & {
                                        values?: (any[] & ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_29 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_30 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_31 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_32 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_33 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_34 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                        } & { [K_35 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_36 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                    } & { [K_37 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                    map?: ({
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } & {
                                        values?: ({
                                            [x: string]: any | undefined;
                                        } & {
                                            [x: string]: ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_38 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_39 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_40 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                            } & { [K_41 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                        } & { [K_42 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                    } & { [K_43 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                } & { [K_44 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                            } & { [K_45 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                        } & { [K_46 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                    } & { [K_47 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_48 in Exclude<keyof I["attributes"][number]["value"]["array"]["values"], keyof any[]>]: never; }) | undefined;
                } & { [K_49 in Exclude<keyof I["attributes"][number]["value"]["array"], "values">]: never; }) | undefined;
                map?: ({
                    values?: {
                        [x: string]: any | undefined;
                    } | undefined;
                } & {
                    values?: ({
                        [x: string]: any | undefined;
                    } & {
                        [x: string]: ({
                            string?: string | undefined;
                            int?: string | number | Long.Long | undefined;
                            float?: number | undefined;
                            boolean?: boolean | undefined;
                            link?: string | undefined;
                            array?: {
                                values?: any[] | undefined;
                            } | undefined;
                            map?: {
                                values?: {
                                    [x: string]: any | undefined;
                                } | undefined;
                            } | undefined;
                        } & {
                            string?: string | undefined;
                            int?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_50 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                            float?: number | undefined;
                            boolean?: boolean | undefined;
                            link?: string | undefined;
                            array?: ({
                                values?: any[] | undefined;
                            } & {
                                values?: (any[] & ({
                                    string?: string | undefined;
                                    int?: string | number | Long.Long | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: {
                                        values?: any[] | undefined;
                                    } | undefined;
                                    map?: {
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } | undefined;
                                } & {
                                    string?: string | undefined;
                                    int?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_51 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: ({
                                        values?: any[] | undefined;
                                    } & {
                                        values?: (any[] & ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_52 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_53 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_54 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_55 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_56 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_57 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                        } & { [K_58 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_59 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                    } & { [K_60 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                    map?: ({
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } & {
                                        values?: ({
                                            [x: string]: any | undefined;
                                        } & {
                                            [x: string]: ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_61 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_62 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_63 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                            } & { [K_64 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                        } & { [K_65 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                    } & { [K_66 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                } & { [K_67 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_68 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                            } & { [K_69 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                            map?: ({
                                values?: {
                                    [x: string]: any | undefined;
                                } | undefined;
                            } & {
                                values?: ({
                                    [x: string]: any | undefined;
                                } & {
                                    [x: string]: ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_70 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_71 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_72 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_73 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_74 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_75 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_76 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_77 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_78 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_79 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                    } & { [K_80 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                } & { [K_81 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                            } & { [K_82 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                        } & { [K_83 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                    } & { [K_84 in Exclude<keyof I["attributes"][number]["value"]["map"]["values"], string | number>]: never; }) | undefined;
                } & { [K_85 in Exclude<keyof I["attributes"][number]["value"]["map"], "values">]: never; }) | undefined;
            } & { [K_86 in Exclude<keyof I["attributes"][number]["value"], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
        } & { [K_87 in Exclude<keyof I["attributes"][number], keyof QueryRecordsRequest_KeyValueInput>]: never; })[] & { [K_88 in Exclude<keyof I["attributes"], keyof {
            key?: string | undefined;
            value?: {
                string?: string | undefined;
                int?: string | number | Long.Long | undefined;
                float?: number | undefined;
                boolean?: boolean | undefined;
                link?: string | undefined;
                array?: {
                    values?: any[] | undefined;
                } | undefined;
                map?: {
                    values?: {
                        [x: string]: any | undefined;
                    } | undefined;
                } | undefined;
            } | undefined;
        }[]>]: never; }) | undefined;
        all?: boolean | undefined;
        pagination?: ({
            key?: Uint8Array | undefined;
            offset?: string | number | Long.Long | undefined;
            limit?: string | number | Long.Long | undefined;
            countTotal?: boolean | undefined;
            reverse?: boolean | undefined;
        } & {
            key?: Uint8Array | undefined;
            offset?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_89 in Exclude<keyof I["pagination"]["offset"], keyof Long.Long>]: never; }) | undefined;
            limit?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_90 in Exclude<keyof I["pagination"]["limit"], keyof Long.Long>]: never; }) | undefined;
            countTotal?: boolean | undefined;
            reverse?: boolean | undefined;
        } & { [K_91 in Exclude<keyof I["pagination"], keyof PageRequest>]: never; }) | undefined;
    } & { [K_92 in Exclude<keyof I, keyof QueryRecordsRequest>]: never; }>(object: I): QueryRecordsRequest;
};
export declare const QueryRecordsRequest_ArrayInput: {
    encode(message: QueryRecordsRequest_ArrayInput, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryRecordsRequest_ArrayInput;
    fromJSON(object: any): QueryRecordsRequest_ArrayInput;
    toJSON(message: QueryRecordsRequest_ArrayInput): unknown;
    fromPartial<I extends {
        values?: any[] | undefined;
    } & {
        values?: (any[] & ({
            string?: string | undefined;
            int?: string | number | Long.Long | undefined;
            float?: number | undefined;
            boolean?: boolean | undefined;
            link?: string | undefined;
            array?: {
                values?: any[] | undefined;
            } | undefined;
            map?: {
                values?: {
                    [x: string]: any | undefined;
                } | undefined;
            } | undefined;
        } & {
            string?: string | undefined;
            int?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K in Exclude<keyof I["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
            float?: number | undefined;
            boolean?: boolean | undefined;
            link?: string | undefined;
            array?: ({
                values?: any[] | undefined;
            } & {
                values?: (any[] & ({
                    string?: string | undefined;
                    int?: string | number | Long.Long | undefined;
                    float?: number | undefined;
                    boolean?: boolean | undefined;
                    link?: string | undefined;
                    array?: {
                        values?: any[] | undefined;
                    } | undefined;
                    map?: {
                        values?: {
                            [x: string]: any | undefined;
                        } | undefined;
                    } | undefined;
                } & {
                    string?: string | undefined;
                    int?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_1 in Exclude<keyof I["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                    float?: number | undefined;
                    boolean?: boolean | undefined;
                    link?: string | undefined;
                    array?: ({
                        values?: any[] | undefined;
                    } & {
                        values?: (any[] & ({
                            string?: string | undefined;
                            int?: string | number | Long.Long | undefined;
                            float?: number | undefined;
                            boolean?: boolean | undefined;
                            link?: string | undefined;
                            array?: {
                                values?: any[] | undefined;
                            } | undefined;
                            map?: {
                                values?: {
                                    [x: string]: any | undefined;
                                } | undefined;
                            } | undefined;
                        } & {
                            string?: string | undefined;
                            int?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_2 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                            float?: number | undefined;
                            boolean?: boolean | undefined;
                            link?: string | undefined;
                            array?: ({
                                values?: any[] | undefined;
                            } & {
                                values?: (any[] & ({
                                    string?: string | undefined;
                                    int?: string | number | Long.Long | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: {
                                        values?: any[] | undefined;
                                    } | undefined;
                                    map?: {
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } | undefined;
                                } & {
                                    string?: string | undefined;
                                    int?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_3 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: ({
                                        values?: any[] | undefined;
                                    } & {
                                        values?: (any[] & ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_4 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_5 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_6 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_7 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_8 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_9 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                        } & { [K_10 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_11 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                    } & { [K_12 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                    map?: ({
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } & {
                                        values?: ({
                                            [x: string]: any | undefined;
                                        } & {
                                            [x: string]: ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_13 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_14 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_15 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                            } & { [K_16 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                        } & { [K_17 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                    } & { [K_18 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                } & { [K_19 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_20 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                            } & { [K_21 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                            map?: ({
                                values?: {
                                    [x: string]: any | undefined;
                                } | undefined;
                            } & {
                                values?: ({
                                    [x: string]: any | undefined;
                                } & {
                                    [x: string]: ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_22 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_23 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_24 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_25 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_26 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_27 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_28 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_29 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_30 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_31 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                    } & { [K_32 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                } & { [K_33 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                            } & { [K_34 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                        } & { [K_35 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_36 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                    } & { [K_37 in Exclude<keyof I["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                    map?: ({
                        values?: {
                            [x: string]: any | undefined;
                        } | undefined;
                    } & {
                        values?: ({
                            [x: string]: any | undefined;
                        } & {
                            [x: string]: ({
                                string?: string | undefined;
                                int?: string | number | Long.Long | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: {
                                    values?: any[] | undefined;
                                } | undefined;
                                map?: {
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } | undefined;
                            } & {
                                string?: string | undefined;
                                int?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_38 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: ({
                                    values?: any[] | undefined;
                                } & {
                                    values?: (any[] & ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_39 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_40 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_41 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_42 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_43 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_44 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_45 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_46 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_47 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_48 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                    } & { [K_49 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_50 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                } & { [K_51 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                map?: ({
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } & {
                                    values?: ({
                                        [x: string]: any | undefined;
                                    } & {
                                        [x: string]: ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_52 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_53 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_54 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_55 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_56 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_57 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                        } & { [K_58 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                    } & { [K_59 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                } & { [K_60 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                            } & { [K_61 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                        } & { [K_62 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                    } & { [K_63 in Exclude<keyof I["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                } & { [K_64 in Exclude<keyof I["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_65 in Exclude<keyof I["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
            } & { [K_66 in Exclude<keyof I["values"][number]["array"], "values">]: never; }) | undefined;
            map?: ({
                values?: {
                    [x: string]: any | undefined;
                } | undefined;
            } & {
                values?: ({
                    [x: string]: any | undefined;
                } & {
                    [x: string]: ({
                        string?: string | undefined;
                        int?: string | number | Long.Long | undefined;
                        float?: number | undefined;
                        boolean?: boolean | undefined;
                        link?: string | undefined;
                        array?: {
                            values?: any[] | undefined;
                        } | undefined;
                        map?: {
                            values?: {
                                [x: string]: any | undefined;
                            } | undefined;
                        } | undefined;
                    } & {
                        string?: string | undefined;
                        int?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_67 in Exclude<keyof I["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                        float?: number | undefined;
                        boolean?: boolean | undefined;
                        link?: string | undefined;
                        array?: ({
                            values?: any[] | undefined;
                        } & {
                            values?: (any[] & ({
                                string?: string | undefined;
                                int?: string | number | Long.Long | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: {
                                    values?: any[] | undefined;
                                } | undefined;
                                map?: {
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } | undefined;
                            } & {
                                string?: string | undefined;
                                int?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_68 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: ({
                                    values?: any[] | undefined;
                                } & {
                                    values?: (any[] & ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_69 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_70 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_71 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_72 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_73 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_74 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_75 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_76 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_77 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_78 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                    } & { [K_79 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_80 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                } & { [K_81 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                map?: ({
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } & {
                                    values?: ({
                                        [x: string]: any | undefined;
                                    } & {
                                        [x: string]: ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_82 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_83 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_84 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_85 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_86 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_87 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                        } & { [K_88 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                    } & { [K_89 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                } & { [K_90 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                            } & { [K_91 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_92 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                        } & { [K_93 in Exclude<keyof I["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                        map?: ({
                            values?: {
                                [x: string]: any | undefined;
                            } | undefined;
                        } & {
                            values?: ({
                                [x: string]: any | undefined;
                            } & {
                                [x: string]: ({
                                    string?: string | undefined;
                                    int?: string | number | Long.Long | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: {
                                        values?: any[] | undefined;
                                    } | undefined;
                                    map?: {
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } | undefined;
                                } & {
                                    string?: string | undefined;
                                    int?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_94 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: ({
                                        values?: any[] | undefined;
                                    } & {
                                        values?: (any[] & ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_95 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_96 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_97 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_98 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_99 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_100 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                        } & { [K_101 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_102 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                    } & { [K_103 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                    map?: ({
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } & {
                                        values?: ({
                                            [x: string]: any | undefined;
                                        } & {
                                            [x: string]: ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_104 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_105 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_106 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                            } & { [K_107 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                        } & { [K_108 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                    } & { [K_109 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                } & { [K_110 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                            } & { [K_111 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                        } & { [K_112 in Exclude<keyof I["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                    } & { [K_113 in Exclude<keyof I["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                } & { [K_114 in Exclude<keyof I["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
            } & { [K_115 in Exclude<keyof I["values"][number]["map"], "values">]: never; }) | undefined;
        } & { [K_116 in Exclude<keyof I["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_117 in Exclude<keyof I["values"], keyof any[]>]: never; }) | undefined;
    } & { [K_118 in Exclude<keyof I, "values">]: never; }>(object: I): QueryRecordsRequest_ArrayInput;
};
export declare const QueryRecordsRequest_MapInput: {
    encode(message: QueryRecordsRequest_MapInput, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryRecordsRequest_MapInput;
    fromJSON(object: any): QueryRecordsRequest_MapInput;
    toJSON(message: QueryRecordsRequest_MapInput): unknown;
    fromPartial<I extends {
        values?: {
            [x: string]: any | undefined;
        } | undefined;
    } & {
        values?: ({
            [x: string]: any | undefined;
        } & {
            [x: string]: ({
                string?: string | undefined;
                int?: string | number | Long.Long | undefined;
                float?: number | undefined;
                boolean?: boolean | undefined;
                link?: string | undefined;
                array?: {
                    values?: any[] | undefined;
                } | undefined;
                map?: {
                    values?: {
                        [x: string]: any | undefined;
                    } | undefined;
                } | undefined;
            } & {
                string?: string | undefined;
                int?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K in Exclude<keyof I["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                float?: number | undefined;
                boolean?: boolean | undefined;
                link?: string | undefined;
                array?: ({
                    values?: any[] | undefined;
                } & {
                    values?: (any[] & ({
                        string?: string | undefined;
                        int?: string | number | Long.Long | undefined;
                        float?: number | undefined;
                        boolean?: boolean | undefined;
                        link?: string | undefined;
                        array?: {
                            values?: any[] | undefined;
                        } | undefined;
                        map?: {
                            values?: {
                                [x: string]: any | undefined;
                            } | undefined;
                        } | undefined;
                    } & {
                        string?: string | undefined;
                        int?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_1 in Exclude<keyof I["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                        float?: number | undefined;
                        boolean?: boolean | undefined;
                        link?: string | undefined;
                        array?: ({
                            values?: any[] | undefined;
                        } & {
                            values?: (any[] & ({
                                string?: string | undefined;
                                int?: string | number | Long.Long | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: {
                                    values?: any[] | undefined;
                                } | undefined;
                                map?: {
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } | undefined;
                            } & {
                                string?: string | undefined;
                                int?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_2 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: ({
                                    values?: any[] | undefined;
                                } & {
                                    values?: (any[] & ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_3 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_4 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_5 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_6 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_7 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_8 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_9 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_10 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_11 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_12 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                    } & { [K_13 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_14 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                } & { [K_15 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                map?: ({
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } & {
                                    values?: ({
                                        [x: string]: any | undefined;
                                    } & {
                                        [x: string]: ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_16 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_17 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_18 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_19 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_20 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_21 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                        } & { [K_22 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                    } & { [K_23 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                } & { [K_24 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                            } & { [K_25 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_26 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                        } & { [K_27 in Exclude<keyof I["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                        map?: ({
                            values?: {
                                [x: string]: any | undefined;
                            } | undefined;
                        } & {
                            values?: ({
                                [x: string]: any | undefined;
                            } & {
                                [x: string]: ({
                                    string?: string | undefined;
                                    int?: string | number | Long.Long | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: {
                                        values?: any[] | undefined;
                                    } | undefined;
                                    map?: {
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } | undefined;
                                } & {
                                    string?: string | undefined;
                                    int?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_28 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: ({
                                        values?: any[] | undefined;
                                    } & {
                                        values?: (any[] & ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_29 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_30 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_31 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_32 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_33 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_34 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                        } & { [K_35 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_36 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                    } & { [K_37 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                    map?: ({
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } & {
                                        values?: ({
                                            [x: string]: any | undefined;
                                        } & {
                                            [x: string]: ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_38 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_39 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_40 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                            } & { [K_41 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                        } & { [K_42 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                    } & { [K_43 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                } & { [K_44 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                            } & { [K_45 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                        } & { [K_46 in Exclude<keyof I["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                    } & { [K_47 in Exclude<keyof I["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_48 in Exclude<keyof I["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                } & { [K_49 in Exclude<keyof I["values"][string]["array"], "values">]: never; }) | undefined;
                map?: ({
                    values?: {
                        [x: string]: any | undefined;
                    } | undefined;
                } & {
                    values?: ({
                        [x: string]: any | undefined;
                    } & {
                        [x: string]: ({
                            string?: string | undefined;
                            int?: string | number | Long.Long | undefined;
                            float?: number | undefined;
                            boolean?: boolean | undefined;
                            link?: string | undefined;
                            array?: {
                                values?: any[] | undefined;
                            } | undefined;
                            map?: {
                                values?: {
                                    [x: string]: any | undefined;
                                } | undefined;
                            } | undefined;
                        } & {
                            string?: string | undefined;
                            int?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_50 in Exclude<keyof I["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                            float?: number | undefined;
                            boolean?: boolean | undefined;
                            link?: string | undefined;
                            array?: ({
                                values?: any[] | undefined;
                            } & {
                                values?: (any[] & ({
                                    string?: string | undefined;
                                    int?: string | number | Long.Long | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: {
                                        values?: any[] | undefined;
                                    } | undefined;
                                    map?: {
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } | undefined;
                                } & {
                                    string?: string | undefined;
                                    int?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_51 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: ({
                                        values?: any[] | undefined;
                                    } & {
                                        values?: (any[] & ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_52 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_53 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_54 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_55 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_56 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_57 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                        } & { [K_58 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_59 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                    } & { [K_60 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                    map?: ({
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } & {
                                        values?: ({
                                            [x: string]: any | undefined;
                                        } & {
                                            [x: string]: ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_61 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_62 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_63 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                            } & { [K_64 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                        } & { [K_65 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                    } & { [K_66 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                } & { [K_67 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_68 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                            } & { [K_69 in Exclude<keyof I["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                            map?: ({
                                values?: {
                                    [x: string]: any | undefined;
                                } | undefined;
                            } & {
                                values?: ({
                                    [x: string]: any | undefined;
                                } & {
                                    [x: string]: ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_70 in Exclude<keyof I["values"][string]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_71 in Exclude<keyof I["values"][string]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_72 in Exclude<keyof I["values"][string]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_73 in Exclude<keyof I["values"][string]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_74 in Exclude<keyof I["values"][string]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_75 in Exclude<keyof I["values"][string]["map"]["values"][string]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_76 in Exclude<keyof I["values"][string]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_77 in Exclude<keyof I["values"][string]["map"]["values"][string]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_78 in Exclude<keyof I["values"][string]["map"]["values"][string]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_79 in Exclude<keyof I["values"][string]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                    } & { [K_80 in Exclude<keyof I["values"][string]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                } & { [K_81 in Exclude<keyof I["values"][string]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                            } & { [K_82 in Exclude<keyof I["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                        } & { [K_83 in Exclude<keyof I["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                    } & { [K_84 in Exclude<keyof I["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                } & { [K_85 in Exclude<keyof I["values"][string]["map"], "values">]: never; }) | undefined;
            } & { [K_86 in Exclude<keyof I["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
        } & { [K_87 in Exclude<keyof I["values"], string | number>]: never; }) | undefined;
    } & { [K_88 in Exclude<keyof I, "values">]: never; }>(object: I): QueryRecordsRequest_MapInput;
};
export declare const QueryRecordsRequest_MapInput_ValuesEntry: {
    encode(message: QueryRecordsRequest_MapInput_ValuesEntry, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryRecordsRequest_MapInput_ValuesEntry;
    fromJSON(object: any): QueryRecordsRequest_MapInput_ValuesEntry;
    toJSON(message: QueryRecordsRequest_MapInput_ValuesEntry): unknown;
    fromPartial<I extends {
        key?: string | undefined;
        value?: {
            string?: string | undefined;
            int?: string | number | Long.Long | undefined;
            float?: number | undefined;
            boolean?: boolean | undefined;
            link?: string | undefined;
            array?: {
                values?: any[] | undefined;
            } | undefined;
            map?: {
                values?: {
                    [x: string]: any | undefined;
                } | undefined;
            } | undefined;
        } | undefined;
    } & {
        key?: string | undefined;
        value?: ({
            string?: string | undefined;
            int?: string | number | Long.Long | undefined;
            float?: number | undefined;
            boolean?: boolean | undefined;
            link?: string | undefined;
            array?: {
                values?: any[] | undefined;
            } | undefined;
            map?: {
                values?: {
                    [x: string]: any | undefined;
                } | undefined;
            } | undefined;
        } & {
            string?: string | undefined;
            int?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K in Exclude<keyof I["value"]["int"], keyof Long.Long>]: never; }) | undefined;
            float?: number | undefined;
            boolean?: boolean | undefined;
            link?: string | undefined;
            array?: ({
                values?: any[] | undefined;
            } & {
                values?: (any[] & ({
                    string?: string | undefined;
                    int?: string | number | Long.Long | undefined;
                    float?: number | undefined;
                    boolean?: boolean | undefined;
                    link?: string | undefined;
                    array?: {
                        values?: any[] | undefined;
                    } | undefined;
                    map?: {
                        values?: {
                            [x: string]: any | undefined;
                        } | undefined;
                    } | undefined;
                } & {
                    string?: string | undefined;
                    int?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_1 in Exclude<keyof I["value"]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                    float?: number | undefined;
                    boolean?: boolean | undefined;
                    link?: string | undefined;
                    array?: ({
                        values?: any[] | undefined;
                    } & {
                        values?: (any[] & ({
                            string?: string | undefined;
                            int?: string | number | Long.Long | undefined;
                            float?: number | undefined;
                            boolean?: boolean | undefined;
                            link?: string | undefined;
                            array?: {
                                values?: any[] | undefined;
                            } | undefined;
                            map?: {
                                values?: {
                                    [x: string]: any | undefined;
                                } | undefined;
                            } | undefined;
                        } & {
                            string?: string | undefined;
                            int?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_2 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                            float?: number | undefined;
                            boolean?: boolean | undefined;
                            link?: string | undefined;
                            array?: ({
                                values?: any[] | undefined;
                            } & {
                                values?: (any[] & ({
                                    string?: string | undefined;
                                    int?: string | number | Long.Long | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: {
                                        values?: any[] | undefined;
                                    } | undefined;
                                    map?: {
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } | undefined;
                                } & {
                                    string?: string | undefined;
                                    int?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_3 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: ({
                                        values?: any[] | undefined;
                                    } & {
                                        values?: (any[] & ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_4 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_5 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_6 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_7 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_8 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_9 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                        } & { [K_10 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_11 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                    } & { [K_12 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                    map?: ({
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } & {
                                        values?: ({
                                            [x: string]: any | undefined;
                                        } & {
                                            [x: string]: ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_13 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_14 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_15 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                            } & { [K_16 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                        } & { [K_17 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                    } & { [K_18 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                } & { [K_19 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_20 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                            } & { [K_21 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                            map?: ({
                                values?: {
                                    [x: string]: any | undefined;
                                } | undefined;
                            } & {
                                values?: ({
                                    [x: string]: any | undefined;
                                } & {
                                    [x: string]: ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_22 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_23 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_24 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_25 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_26 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_27 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_28 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_29 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_30 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_31 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                    } & { [K_32 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                } & { [K_33 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                            } & { [K_34 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                        } & { [K_35 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_36 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                    } & { [K_37 in Exclude<keyof I["value"]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                    map?: ({
                        values?: {
                            [x: string]: any | undefined;
                        } | undefined;
                    } & {
                        values?: ({
                            [x: string]: any | undefined;
                        } & {
                            [x: string]: ({
                                string?: string | undefined;
                                int?: string | number | Long.Long | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: {
                                    values?: any[] | undefined;
                                } | undefined;
                                map?: {
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } | undefined;
                            } & {
                                string?: string | undefined;
                                int?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_38 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: ({
                                    values?: any[] | undefined;
                                } & {
                                    values?: (any[] & ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_39 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_40 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_41 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_42 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_43 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_44 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_45 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_46 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_47 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_48 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                    } & { [K_49 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_50 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                } & { [K_51 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                map?: ({
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } & {
                                    values?: ({
                                        [x: string]: any | undefined;
                                    } & {
                                        [x: string]: ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_52 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_53 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_54 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_55 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_56 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_57 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                        } & { [K_58 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                    } & { [K_59 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                } & { [K_60 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                            } & { [K_61 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                        } & { [K_62 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                    } & { [K_63 in Exclude<keyof I["value"]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                } & { [K_64 in Exclude<keyof I["value"]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_65 in Exclude<keyof I["value"]["array"]["values"], keyof any[]>]: never; }) | undefined;
            } & { [K_66 in Exclude<keyof I["value"]["array"], "values">]: never; }) | undefined;
            map?: ({
                values?: {
                    [x: string]: any | undefined;
                } | undefined;
            } & {
                values?: ({
                    [x: string]: any | undefined;
                } & {
                    [x: string]: ({
                        string?: string | undefined;
                        int?: string | number | Long.Long | undefined;
                        float?: number | undefined;
                        boolean?: boolean | undefined;
                        link?: string | undefined;
                        array?: {
                            values?: any[] | undefined;
                        } | undefined;
                        map?: {
                            values?: {
                                [x: string]: any | undefined;
                            } | undefined;
                        } | undefined;
                    } & {
                        string?: string | undefined;
                        int?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_67 in Exclude<keyof I["value"]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                        float?: number | undefined;
                        boolean?: boolean | undefined;
                        link?: string | undefined;
                        array?: ({
                            values?: any[] | undefined;
                        } & {
                            values?: (any[] & ({
                                string?: string | undefined;
                                int?: string | number | Long.Long | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: {
                                    values?: any[] | undefined;
                                } | undefined;
                                map?: {
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } | undefined;
                            } & {
                                string?: string | undefined;
                                int?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_68 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: ({
                                    values?: any[] | undefined;
                                } & {
                                    values?: (any[] & ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_69 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_70 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_71 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_72 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_73 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_74 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_75 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_76 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_77 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_78 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                    } & { [K_79 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_80 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                } & { [K_81 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                map?: ({
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } & {
                                    values?: ({
                                        [x: string]: any | undefined;
                                    } & {
                                        [x: string]: ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_82 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_83 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_84 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_85 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_86 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_87 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                        } & { [K_88 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                    } & { [K_89 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                } & { [K_90 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                            } & { [K_91 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_92 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                        } & { [K_93 in Exclude<keyof I["value"]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                        map?: ({
                            values?: {
                                [x: string]: any | undefined;
                            } | undefined;
                        } & {
                            values?: ({
                                [x: string]: any | undefined;
                            } & {
                                [x: string]: ({
                                    string?: string | undefined;
                                    int?: string | number | Long.Long | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: {
                                        values?: any[] | undefined;
                                    } | undefined;
                                    map?: {
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } | undefined;
                                } & {
                                    string?: string | undefined;
                                    int?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_94 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: ({
                                        values?: any[] | undefined;
                                    } & {
                                        values?: (any[] & ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_95 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_96 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_97 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_98 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_99 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_100 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                        } & { [K_101 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_102 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                    } & { [K_103 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                    map?: ({
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } & {
                                        values?: ({
                                            [x: string]: any | undefined;
                                        } & {
                                            [x: string]: ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_104 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_105 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_106 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                            } & { [K_107 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                        } & { [K_108 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                    } & { [K_109 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                } & { [K_110 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                            } & { [K_111 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                        } & { [K_112 in Exclude<keyof I["value"]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                    } & { [K_113 in Exclude<keyof I["value"]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                } & { [K_114 in Exclude<keyof I["value"]["map"]["values"], string | number>]: never; }) | undefined;
            } & { [K_115 in Exclude<keyof I["value"]["map"], "values">]: never; }) | undefined;
        } & { [K_116 in Exclude<keyof I["value"], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
    } & { [K_117 in Exclude<keyof I, keyof QueryRecordsRequest_MapInput_ValuesEntry>]: never; }>(object: I): QueryRecordsRequest_MapInput_ValuesEntry;
};
export declare const QueryRecordsRequest_ValueInput: {
    encode(message: QueryRecordsRequest_ValueInput, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryRecordsRequest_ValueInput;
    fromJSON(object: any): QueryRecordsRequest_ValueInput;
    toJSON(message: QueryRecordsRequest_ValueInput): unknown;
    fromPartial<I extends {
        string?: string | undefined;
        int?: string | number | Long.Long | undefined;
        float?: number | undefined;
        boolean?: boolean | undefined;
        link?: string | undefined;
        array?: {
            values?: any[] | undefined;
        } | undefined;
        map?: {
            values?: {
                [x: string]: any | undefined;
            } | undefined;
        } | undefined;
    } & {
        string?: string | undefined;
        int?: string | number | (Long.Long & {
            high: number;
            low: number;
            unsigned: boolean;
            add: (addend: string | number | Long.Long) => Long.Long;
            and: (other: string | number | Long.Long) => Long.Long;
            compare: (other: string | number | Long.Long) => number;
            comp: (other: string | number | Long.Long) => number;
            divide: (divisor: string | number | Long.Long) => Long.Long;
            div: (divisor: string | number | Long.Long) => Long.Long;
            equals: (other: string | number | Long.Long) => boolean;
            eq: (other: string | number | Long.Long) => boolean;
            getHighBits: () => number;
            getHighBitsUnsigned: () => number;
            getLowBits: () => number;
            getLowBitsUnsigned: () => number;
            getNumBitsAbs: () => number;
            greaterThan: (other: string | number | Long.Long) => boolean;
            gt: (other: string | number | Long.Long) => boolean;
            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
            gte: (other: string | number | Long.Long) => boolean;
            isEven: () => boolean;
            isNegative: () => boolean;
            isOdd: () => boolean;
            isPositive: () => boolean;
            isZero: () => boolean;
            lessThan: (other: string | number | Long.Long) => boolean;
            lt: (other: string | number | Long.Long) => boolean;
            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
            lte: (other: string | number | Long.Long) => boolean;
            modulo: (other: string | number | Long.Long) => Long.Long;
            mod: (other: string | number | Long.Long) => Long.Long;
            multiply: (multiplier: string | number | Long.Long) => Long.Long;
            mul: (multiplier: string | number | Long.Long) => Long.Long;
            negate: () => Long.Long;
            neg: () => Long.Long;
            not: () => Long.Long;
            notEquals: (other: string | number | Long.Long) => boolean;
            neq: (other: string | number | Long.Long) => boolean;
            or: (other: string | number | Long.Long) => Long.Long;
            shiftLeft: (numBits: number | Long.Long) => Long.Long;
            shl: (numBits: number | Long.Long) => Long.Long;
            shiftRight: (numBits: number | Long.Long) => Long.Long;
            shr: (numBits: number | Long.Long) => Long.Long;
            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
            shru: (numBits: number | Long.Long) => Long.Long;
            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
            sub: (subtrahend: string | number | Long.Long) => Long.Long;
            toInt: () => number;
            toNumber: () => number;
            toBytes: (le?: boolean | undefined) => number[];
            toBytesLE: () => number[];
            toBytesBE: () => number[];
            toSigned: () => Long.Long;
            toString: (radix?: number | undefined) => string;
            toUnsigned: () => Long.Long;
            xor: (other: string | number | Long.Long) => Long.Long;
        } & { [K in Exclude<keyof I["int"], keyof Long.Long>]: never; }) | undefined;
        float?: number | undefined;
        boolean?: boolean | undefined;
        link?: string | undefined;
        array?: ({
            values?: any[] | undefined;
        } & {
            values?: (any[] & ({
                string?: string | undefined;
                int?: string | number | Long.Long | undefined;
                float?: number | undefined;
                boolean?: boolean | undefined;
                link?: string | undefined;
                array?: {
                    values?: any[] | undefined;
                } | undefined;
                map?: {
                    values?: {
                        [x: string]: any | undefined;
                    } | undefined;
                } | undefined;
            } & {
                string?: string | undefined;
                int?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_1 in Exclude<keyof I["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                float?: number | undefined;
                boolean?: boolean | undefined;
                link?: string | undefined;
                array?: ({
                    values?: any[] | undefined;
                } & {
                    values?: (any[] & ({
                        string?: string | undefined;
                        int?: string | number | Long.Long | undefined;
                        float?: number | undefined;
                        boolean?: boolean | undefined;
                        link?: string | undefined;
                        array?: {
                            values?: any[] | undefined;
                        } | undefined;
                        map?: {
                            values?: {
                                [x: string]: any | undefined;
                            } | undefined;
                        } | undefined;
                    } & {
                        string?: string | undefined;
                        int?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_2 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                        float?: number | undefined;
                        boolean?: boolean | undefined;
                        link?: string | undefined;
                        array?: ({
                            values?: any[] | undefined;
                        } & {
                            values?: (any[] & ({
                                string?: string | undefined;
                                int?: string | number | Long.Long | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: {
                                    values?: any[] | undefined;
                                } | undefined;
                                map?: {
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } | undefined;
                            } & {
                                string?: string | undefined;
                                int?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_3 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: ({
                                    values?: any[] | undefined;
                                } & {
                                    values?: (any[] & ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_4 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_5 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_6 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_7 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_8 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_9 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_10 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_11 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_12 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_13 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                    } & { [K_14 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_15 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                } & { [K_16 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                map?: ({
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } & {
                                    values?: ({
                                        [x: string]: any | undefined;
                                    } & {
                                        [x: string]: ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_17 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_18 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_19 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_20 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_21 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_22 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                        } & { [K_23 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                    } & { [K_24 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                } & { [K_25 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                            } & { [K_26 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_27 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                        } & { [K_28 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                        map?: ({
                            values?: {
                                [x: string]: any | undefined;
                            } | undefined;
                        } & {
                            values?: ({
                                [x: string]: any | undefined;
                            } & {
                                [x: string]: ({
                                    string?: string | undefined;
                                    int?: string | number | Long.Long | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: {
                                        values?: any[] | undefined;
                                    } | undefined;
                                    map?: {
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } | undefined;
                                } & {
                                    string?: string | undefined;
                                    int?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_29 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: ({
                                        values?: any[] | undefined;
                                    } & {
                                        values?: (any[] & ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_30 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_31 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_32 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_33 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_34 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_35 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                        } & { [K_36 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_37 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                    } & { [K_38 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                    map?: ({
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } & {
                                        values?: ({
                                            [x: string]: any | undefined;
                                        } & {
                                            [x: string]: ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_39 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_40 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_41 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                            } & { [K_42 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                        } & { [K_43 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                    } & { [K_44 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                } & { [K_45 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                            } & { [K_46 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                        } & { [K_47 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                    } & { [K_48 in Exclude<keyof I["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_49 in Exclude<keyof I["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                } & { [K_50 in Exclude<keyof I["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                map?: ({
                    values?: {
                        [x: string]: any | undefined;
                    } | undefined;
                } & {
                    values?: ({
                        [x: string]: any | undefined;
                    } & {
                        [x: string]: ({
                            string?: string | undefined;
                            int?: string | number | Long.Long | undefined;
                            float?: number | undefined;
                            boolean?: boolean | undefined;
                            link?: string | undefined;
                            array?: {
                                values?: any[] | undefined;
                            } | undefined;
                            map?: {
                                values?: {
                                    [x: string]: any | undefined;
                                } | undefined;
                            } | undefined;
                        } & {
                            string?: string | undefined;
                            int?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_51 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                            float?: number | undefined;
                            boolean?: boolean | undefined;
                            link?: string | undefined;
                            array?: ({
                                values?: any[] | undefined;
                            } & {
                                values?: (any[] & ({
                                    string?: string | undefined;
                                    int?: string | number | Long.Long | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: {
                                        values?: any[] | undefined;
                                    } | undefined;
                                    map?: {
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } | undefined;
                                } & {
                                    string?: string | undefined;
                                    int?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_52 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: ({
                                        values?: any[] | undefined;
                                    } & {
                                        values?: (any[] & ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_53 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_54 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_55 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_56 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_57 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_58 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                        } & { [K_59 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_60 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                    } & { [K_61 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                    map?: ({
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } & {
                                        values?: ({
                                            [x: string]: any | undefined;
                                        } & {
                                            [x: string]: ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_62 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_63 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_64 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                            } & { [K_65 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                        } & { [K_66 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                    } & { [K_67 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                } & { [K_68 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_69 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                            } & { [K_70 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                            map?: ({
                                values?: {
                                    [x: string]: any | undefined;
                                } | undefined;
                            } & {
                                values?: ({
                                    [x: string]: any | undefined;
                                } & {
                                    [x: string]: ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_71 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_72 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_73 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_74 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_75 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_76 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_77 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_78 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_79 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_80 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                    } & { [K_81 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                } & { [K_82 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                            } & { [K_83 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                        } & { [K_84 in Exclude<keyof I["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                    } & { [K_85 in Exclude<keyof I["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                } & { [K_86 in Exclude<keyof I["array"]["values"][number]["map"], "values">]: never; }) | undefined;
            } & { [K_87 in Exclude<keyof I["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_88 in Exclude<keyof I["array"]["values"], keyof any[]>]: never; }) | undefined;
        } & { [K_89 in Exclude<keyof I["array"], "values">]: never; }) | undefined;
        map?: ({
            values?: {
                [x: string]: any | undefined;
            } | undefined;
        } & {
            values?: ({
                [x: string]: any | undefined;
            } & {
                [x: string]: ({
                    string?: string | undefined;
                    int?: string | number | Long.Long | undefined;
                    float?: number | undefined;
                    boolean?: boolean | undefined;
                    link?: string | undefined;
                    array?: {
                        values?: any[] | undefined;
                    } | undefined;
                    map?: {
                        values?: {
                            [x: string]: any | undefined;
                        } | undefined;
                    } | undefined;
                } & {
                    string?: string | undefined;
                    int?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_90 in Exclude<keyof I["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                    float?: number | undefined;
                    boolean?: boolean | undefined;
                    link?: string | undefined;
                    array?: ({
                        values?: any[] | undefined;
                    } & {
                        values?: (any[] & ({
                            string?: string | undefined;
                            int?: string | number | Long.Long | undefined;
                            float?: number | undefined;
                            boolean?: boolean | undefined;
                            link?: string | undefined;
                            array?: {
                                values?: any[] | undefined;
                            } | undefined;
                            map?: {
                                values?: {
                                    [x: string]: any | undefined;
                                } | undefined;
                            } | undefined;
                        } & {
                            string?: string | undefined;
                            int?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_91 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                            float?: number | undefined;
                            boolean?: boolean | undefined;
                            link?: string | undefined;
                            array?: ({
                                values?: any[] | undefined;
                            } & {
                                values?: (any[] & ({
                                    string?: string | undefined;
                                    int?: string | number | Long.Long | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: {
                                        values?: any[] | undefined;
                                    } | undefined;
                                    map?: {
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } | undefined;
                                } & {
                                    string?: string | undefined;
                                    int?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_92 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: ({
                                        values?: any[] | undefined;
                                    } & {
                                        values?: (any[] & ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_93 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_94 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_95 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_96 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_97 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_98 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                        } & { [K_99 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_100 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                    } & { [K_101 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                    map?: ({
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } & {
                                        values?: ({
                                            [x: string]: any | undefined;
                                        } & {
                                            [x: string]: ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_102 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_103 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_104 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                            } & { [K_105 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                        } & { [K_106 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                    } & { [K_107 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                } & { [K_108 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_109 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                            } & { [K_110 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                            map?: ({
                                values?: {
                                    [x: string]: any | undefined;
                                } | undefined;
                            } & {
                                values?: ({
                                    [x: string]: any | undefined;
                                } & {
                                    [x: string]: ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_111 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_112 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_113 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_114 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_115 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_116 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_117 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_118 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_119 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_120 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                    } & { [K_121 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                } & { [K_122 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                            } & { [K_123 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                        } & { [K_124 in Exclude<keyof I["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_125 in Exclude<keyof I["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                    } & { [K_126 in Exclude<keyof I["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                    map?: ({
                        values?: {
                            [x: string]: any | undefined;
                        } | undefined;
                    } & {
                        values?: ({
                            [x: string]: any | undefined;
                        } & {
                            [x: string]: ({
                                string?: string | undefined;
                                int?: string | number | Long.Long | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: {
                                    values?: any[] | undefined;
                                } | undefined;
                                map?: {
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } | undefined;
                            } & {
                                string?: string | undefined;
                                int?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_127 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: ({
                                    values?: any[] | undefined;
                                } & {
                                    values?: (any[] & ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_128 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_129 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_130 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_131 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_132 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_133 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_134 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_135 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_136 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_137 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                    } & { [K_138 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_139 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                } & { [K_140 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                map?: ({
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } & {
                                    values?: ({
                                        [x: string]: any | undefined;
                                    } & {
                                        [x: string]: ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_141 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_142 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_143 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_144 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_145 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_146 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                        } & { [K_147 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                    } & { [K_148 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                } & { [K_149 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                            } & { [K_150 in Exclude<keyof I["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                        } & { [K_151 in Exclude<keyof I["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                    } & { [K_152 in Exclude<keyof I["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                } & { [K_153 in Exclude<keyof I["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
            } & { [K_154 in Exclude<keyof I["map"]["values"], string | number>]: never; }) | undefined;
        } & { [K_155 in Exclude<keyof I["map"], "values">]: never; }) | undefined;
    } & { [K_156 in Exclude<keyof I, keyof QueryRecordsRequest_ValueInput>]: never; }>(object: I): QueryRecordsRequest_ValueInput;
};
export declare const QueryRecordsRequest_KeyValueInput: {
    encode(message: QueryRecordsRequest_KeyValueInput, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryRecordsRequest_KeyValueInput;
    fromJSON(object: any): QueryRecordsRequest_KeyValueInput;
    toJSON(message: QueryRecordsRequest_KeyValueInput): unknown;
    fromPartial<I extends {
        key?: string | undefined;
        value?: {
            string?: string | undefined;
            int?: string | number | Long.Long | undefined;
            float?: number | undefined;
            boolean?: boolean | undefined;
            link?: string | undefined;
            array?: {
                values?: any[] | undefined;
            } | undefined;
            map?: {
                values?: {
                    [x: string]: any | undefined;
                } | undefined;
            } | undefined;
        } | undefined;
    } & {
        key?: string | undefined;
        value?: ({
            string?: string | undefined;
            int?: string | number | Long.Long | undefined;
            float?: number | undefined;
            boolean?: boolean | undefined;
            link?: string | undefined;
            array?: {
                values?: any[] | undefined;
            } | undefined;
            map?: {
                values?: {
                    [x: string]: any | undefined;
                } | undefined;
            } | undefined;
        } & {
            string?: string | undefined;
            int?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K in Exclude<keyof I["value"]["int"], keyof Long.Long>]: never; }) | undefined;
            float?: number | undefined;
            boolean?: boolean | undefined;
            link?: string | undefined;
            array?: ({
                values?: any[] | undefined;
            } & {
                values?: (any[] & ({
                    string?: string | undefined;
                    int?: string | number | Long.Long | undefined;
                    float?: number | undefined;
                    boolean?: boolean | undefined;
                    link?: string | undefined;
                    array?: {
                        values?: any[] | undefined;
                    } | undefined;
                    map?: {
                        values?: {
                            [x: string]: any | undefined;
                        } | undefined;
                    } | undefined;
                } & {
                    string?: string | undefined;
                    int?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_1 in Exclude<keyof I["value"]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                    float?: number | undefined;
                    boolean?: boolean | undefined;
                    link?: string | undefined;
                    array?: ({
                        values?: any[] | undefined;
                    } & {
                        values?: (any[] & ({
                            string?: string | undefined;
                            int?: string | number | Long.Long | undefined;
                            float?: number | undefined;
                            boolean?: boolean | undefined;
                            link?: string | undefined;
                            array?: {
                                values?: any[] | undefined;
                            } | undefined;
                            map?: {
                                values?: {
                                    [x: string]: any | undefined;
                                } | undefined;
                            } | undefined;
                        } & {
                            string?: string | undefined;
                            int?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_2 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                            float?: number | undefined;
                            boolean?: boolean | undefined;
                            link?: string | undefined;
                            array?: ({
                                values?: any[] | undefined;
                            } & {
                                values?: (any[] & ({
                                    string?: string | undefined;
                                    int?: string | number | Long.Long | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: {
                                        values?: any[] | undefined;
                                    } | undefined;
                                    map?: {
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } | undefined;
                                } & {
                                    string?: string | undefined;
                                    int?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_3 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: ({
                                        values?: any[] | undefined;
                                    } & {
                                        values?: (any[] & ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_4 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_5 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_6 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_7 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_8 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_9 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                        } & { [K_10 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_11 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                    } & { [K_12 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                    map?: ({
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } & {
                                        values?: ({
                                            [x: string]: any | undefined;
                                        } & {
                                            [x: string]: ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_13 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_14 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_15 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                            } & { [K_16 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                        } & { [K_17 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                    } & { [K_18 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                } & { [K_19 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_20 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                            } & { [K_21 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                            map?: ({
                                values?: {
                                    [x: string]: any | undefined;
                                } | undefined;
                            } & {
                                values?: ({
                                    [x: string]: any | undefined;
                                } & {
                                    [x: string]: ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_22 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_23 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_24 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_25 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_26 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_27 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_28 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_29 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_30 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_31 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                    } & { [K_32 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                } & { [K_33 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                            } & { [K_34 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                        } & { [K_35 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_36 in Exclude<keyof I["value"]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                    } & { [K_37 in Exclude<keyof I["value"]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                    map?: ({
                        values?: {
                            [x: string]: any | undefined;
                        } | undefined;
                    } & {
                        values?: ({
                            [x: string]: any | undefined;
                        } & {
                            [x: string]: ({
                                string?: string | undefined;
                                int?: string | number | Long.Long | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: {
                                    values?: any[] | undefined;
                                } | undefined;
                                map?: {
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } | undefined;
                            } & {
                                string?: string | undefined;
                                int?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_38 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: ({
                                    values?: any[] | undefined;
                                } & {
                                    values?: (any[] & ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_39 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_40 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_41 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_42 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_43 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_44 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_45 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_46 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_47 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_48 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                    } & { [K_49 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_50 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                } & { [K_51 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                map?: ({
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } & {
                                    values?: ({
                                        [x: string]: any | undefined;
                                    } & {
                                        [x: string]: ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_52 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_53 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_54 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_55 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_56 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_57 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                        } & { [K_58 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                    } & { [K_59 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                } & { [K_60 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                            } & { [K_61 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                        } & { [K_62 in Exclude<keyof I["value"]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                    } & { [K_63 in Exclude<keyof I["value"]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                } & { [K_64 in Exclude<keyof I["value"]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_65 in Exclude<keyof I["value"]["array"]["values"], keyof any[]>]: never; }) | undefined;
            } & { [K_66 in Exclude<keyof I["value"]["array"], "values">]: never; }) | undefined;
            map?: ({
                values?: {
                    [x: string]: any | undefined;
                } | undefined;
            } & {
                values?: ({
                    [x: string]: any | undefined;
                } & {
                    [x: string]: ({
                        string?: string | undefined;
                        int?: string | number | Long.Long | undefined;
                        float?: number | undefined;
                        boolean?: boolean | undefined;
                        link?: string | undefined;
                        array?: {
                            values?: any[] | undefined;
                        } | undefined;
                        map?: {
                            values?: {
                                [x: string]: any | undefined;
                            } | undefined;
                        } | undefined;
                    } & {
                        string?: string | undefined;
                        int?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_67 in Exclude<keyof I["value"]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                        float?: number | undefined;
                        boolean?: boolean | undefined;
                        link?: string | undefined;
                        array?: ({
                            values?: any[] | undefined;
                        } & {
                            values?: (any[] & ({
                                string?: string | undefined;
                                int?: string | number | Long.Long | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: {
                                    values?: any[] | undefined;
                                } | undefined;
                                map?: {
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } | undefined;
                            } & {
                                string?: string | undefined;
                                int?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_68 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                float?: number | undefined;
                                boolean?: boolean | undefined;
                                link?: string | undefined;
                                array?: ({
                                    values?: any[] | undefined;
                                } & {
                                    values?: (any[] & ({
                                        string?: string | undefined;
                                        int?: string | number | Long.Long | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: {
                                            values?: any[] | undefined;
                                        } | undefined;
                                        map?: {
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } | undefined;
                                    } & {
                                        string?: string | undefined;
                                        int?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_69 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                        float?: number | undefined;
                                        boolean?: boolean | undefined;
                                        link?: string | undefined;
                                        array?: ({
                                            values?: any[] | undefined;
                                        } & {
                                            values?: (any[] & ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_70 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_71 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_72 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                            } & { [K_73 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_74 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                        } & { [K_75 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                        map?: ({
                                            values?: {
                                                [x: string]: any | undefined;
                                            } | undefined;
                                        } & {
                                            values?: ({
                                                [x: string]: any | undefined;
                                            } & {
                                                [x: string]: ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_76 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                            } & { [K_77 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                        } & { [K_78 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                    } & { [K_79 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_80 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                } & { [K_81 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                map?: ({
                                    values?: {
                                        [x: string]: any | undefined;
                                    } | undefined;
                                } & {
                                    values?: ({
                                        [x: string]: any | undefined;
                                    } & {
                                        [x: string]: ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_82 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_83 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_84 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_85 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_86 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_87 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                        } & { [K_88 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                    } & { [K_89 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                } & { [K_90 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                            } & { [K_91 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_92 in Exclude<keyof I["value"]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                        } & { [K_93 in Exclude<keyof I["value"]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                        map?: ({
                            values?: {
                                [x: string]: any | undefined;
                            } | undefined;
                        } & {
                            values?: ({
                                [x: string]: any | undefined;
                            } & {
                                [x: string]: ({
                                    string?: string | undefined;
                                    int?: string | number | Long.Long | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: {
                                        values?: any[] | undefined;
                                    } | undefined;
                                    map?: {
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } | undefined;
                                } & {
                                    string?: string | undefined;
                                    int?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_94 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                    float?: number | undefined;
                                    boolean?: boolean | undefined;
                                    link?: string | undefined;
                                    array?: ({
                                        values?: any[] | undefined;
                                    } & {
                                        values?: (any[] & ({
                                            string?: string | undefined;
                                            int?: string | number | Long.Long | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: {
                                                values?: any[] | undefined;
                                            } | undefined;
                                            map?: {
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } | undefined;
                                        } & {
                                            string?: string | undefined;
                                            int?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_95 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["int"], keyof Long.Long>]: never; }) | undefined;
                                            float?: number | undefined;
                                            boolean?: boolean | undefined;
                                            link?: string | undefined;
                                            array?: ({
                                                values?: any[] | undefined;
                                            } & {
                                                values?: (any[] & ({
                                                    string?: string | undefined;
                                                    int?: string | number | Long.Long | undefined;
                                                    float?: number | undefined;
                                                    boolean?: boolean | undefined;
                                                    link?: string | undefined;
                                                    array?: {
                                                        values?: any[] | undefined;
                                                    } | undefined;
                                                    map?: {
                                                        values?: {
                                                            [x: string]: any | undefined;
                                                        } | undefined;
                                                    } | undefined;
                                                } & any & { [K_96 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_97 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                            } & { [K_98 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["array"], "values">]: never; }) | undefined;
                                            map?: ({
                                                values?: {
                                                    [x: string]: any | undefined;
                                                } | undefined;
                                            } & {
                                                values?: ({
                                                    [x: string]: any | undefined;
                                                } & any & { [K_99 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["map"]["values"], string | number>]: never; }) | undefined;
                                            } & { [K_100 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number]["map"], "values">]: never; }) | undefined;
                                        } & { [K_101 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"][number], keyof QueryRecordsRequest_ValueInput>]: never; })[] & { [K_102 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"]["values"], keyof any[]>]: never; }) | undefined;
                                    } & { [K_103 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                    map?: ({
                                        values?: {
                                            [x: string]: any | undefined;
                                        } | undefined;
                                    } & {
                                        values?: ({
                                            [x: string]: any | undefined;
                                        } & {
                                            [x: string]: ({
                                                string?: string | undefined;
                                                int?: string | number | Long.Long | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: {
                                                    values?: any[] | undefined;
                                                } | undefined;
                                                map?: {
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } | undefined;
                                            } & {
                                                string?: string | undefined;
                                                int?: string | number | (Long.Long & any & { [K_104 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["map"]["values"][string]["int"], keyof Long.Long>]: never; }) | undefined;
                                                float?: number | undefined;
                                                boolean?: boolean | undefined;
                                                link?: string | undefined;
                                                array?: ({
                                                    values?: any[] | undefined;
                                                } & any & { [K_105 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["map"]["values"][string]["array"], "values">]: never; }) | undefined;
                                                map?: ({
                                                    values?: {
                                                        [x: string]: any | undefined;
                                                    } | undefined;
                                                } & any & { [K_106 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                            } & { [K_107 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                                        } & { [K_108 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                                    } & { [K_109 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                                } & { [K_110 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                            } & { [K_111 in Exclude<keyof I["value"]["map"]["values"][string]["map"]["values"], string | number>]: never; }) | undefined;
                        } & { [K_112 in Exclude<keyof I["value"]["map"]["values"][string]["map"], "values">]: never; }) | undefined;
                    } & { [K_113 in Exclude<keyof I["value"]["map"]["values"][string], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
                } & { [K_114 in Exclude<keyof I["value"]["map"]["values"], string | number>]: never; }) | undefined;
            } & { [K_115 in Exclude<keyof I["value"]["map"], "values">]: never; }) | undefined;
        } & { [K_116 in Exclude<keyof I["value"], keyof QueryRecordsRequest_ValueInput>]: never; }) | undefined;
    } & { [K_117 in Exclude<keyof I, keyof QueryRecordsRequest_KeyValueInput>]: never; }>(object: I): QueryRecordsRequest_KeyValueInput;
};
export declare const QueryRecordsResponse: {
    encode(message: QueryRecordsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryRecordsResponse;
    fromJSON(object: any): QueryRecordsResponse;
    toJSON(message: QueryRecordsResponse): unknown;
    fromPartial<I extends {
        records?: {
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: string[] | undefined;
            attributes?: Uint8Array | undefined;
            names?: string[] | undefined;
            type?: string | undefined;
        }[] | undefined;
        pagination?: {
            nextKey?: Uint8Array | undefined;
            total?: string | number | Long.Long | undefined;
        } | undefined;
    } & {
        records?: ({
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: string[] | undefined;
            attributes?: Uint8Array | undefined;
            names?: string[] | undefined;
            type?: string | undefined;
        }[] & ({
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: string[] | undefined;
            attributes?: Uint8Array | undefined;
            names?: string[] | undefined;
            type?: string | undefined;
        } & {
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: (string[] & string[] & { [K in Exclude<keyof I["records"][number]["owners"], keyof string[]>]: never; }) | undefined;
            attributes?: Uint8Array | undefined;
            names?: (string[] & string[] & { [K_1 in Exclude<keyof I["records"][number]["names"], keyof string[]>]: never; }) | undefined;
            type?: string | undefined;
        } & { [K_2 in Exclude<keyof I["records"][number], keyof Record>]: never; })[] & { [K_3 in Exclude<keyof I["records"], keyof {
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: string[] | undefined;
            attributes?: Uint8Array | undefined;
            names?: string[] | undefined;
            type?: string | undefined;
        }[]>]: never; }) | undefined;
        pagination?: ({
            nextKey?: Uint8Array | undefined;
            total?: string | number | Long.Long | undefined;
        } & {
            nextKey?: Uint8Array | undefined;
            total?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_4 in Exclude<keyof I["pagination"]["total"], keyof Long.Long>]: never; }) | undefined;
        } & { [K_5 in Exclude<keyof I["pagination"], keyof PageResponse>]: never; }) | undefined;
    } & { [K_6 in Exclude<keyof I, keyof QueryRecordsResponse>]: never; }>(object: I): QueryRecordsResponse;
};
export declare const QueryGetRecordRequest: {
    encode(message: QueryGetRecordRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryGetRecordRequest;
    fromJSON(object: any): QueryGetRecordRequest;
    toJSON(message: QueryGetRecordRequest): unknown;
    fromPartial<I extends {
        id?: string | undefined;
    } & {
        id?: string | undefined;
    } & { [K in Exclude<keyof I, "id">]: never; }>(object: I): QueryGetRecordRequest;
};
export declare const QueryGetRecordResponse: {
    encode(message: QueryGetRecordResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryGetRecordResponse;
    fromJSON(object: any): QueryGetRecordResponse;
    toJSON(message: QueryGetRecordResponse): unknown;
    fromPartial<I extends {
        record?: {
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: string[] | undefined;
            attributes?: Uint8Array | undefined;
            names?: string[] | undefined;
            type?: string | undefined;
        } | undefined;
    } & {
        record?: ({
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: string[] | undefined;
            attributes?: Uint8Array | undefined;
            names?: string[] | undefined;
            type?: string | undefined;
        } & {
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: (string[] & string[] & { [K in Exclude<keyof I["record"]["owners"], keyof string[]>]: never; }) | undefined;
            attributes?: Uint8Array | undefined;
            names?: (string[] & string[] & { [K_1 in Exclude<keyof I["record"]["names"], keyof string[]>]: never; }) | undefined;
            type?: string | undefined;
        } & { [K_2 in Exclude<keyof I["record"], keyof Record>]: never; }) | undefined;
    } & { [K_3 in Exclude<keyof I, "record">]: never; }>(object: I): QueryGetRecordResponse;
};
export declare const QueryGetRecordsByBondIdRequest: {
    encode(message: QueryGetRecordsByBondIdRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryGetRecordsByBondIdRequest;
    fromJSON(object: any): QueryGetRecordsByBondIdRequest;
    toJSON(message: QueryGetRecordsByBondIdRequest): unknown;
    fromPartial<I extends {
        id?: string | undefined;
        pagination?: {
            key?: Uint8Array | undefined;
            offset?: string | number | Long.Long | undefined;
            limit?: string | number | Long.Long | undefined;
            countTotal?: boolean | undefined;
            reverse?: boolean | undefined;
        } | undefined;
    } & {
        id?: string | undefined;
        pagination?: ({
            key?: Uint8Array | undefined;
            offset?: string | number | Long.Long | undefined;
            limit?: string | number | Long.Long | undefined;
            countTotal?: boolean | undefined;
            reverse?: boolean | undefined;
        } & {
            key?: Uint8Array | undefined;
            offset?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K in Exclude<keyof I["pagination"]["offset"], keyof Long.Long>]: never; }) | undefined;
            limit?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_1 in Exclude<keyof I["pagination"]["limit"], keyof Long.Long>]: never; }) | undefined;
            countTotal?: boolean | undefined;
            reverse?: boolean | undefined;
        } & { [K_2 in Exclude<keyof I["pagination"], keyof PageRequest>]: never; }) | undefined;
    } & { [K_3 in Exclude<keyof I, keyof QueryGetRecordsByBondIdRequest>]: never; }>(object: I): QueryGetRecordsByBondIdRequest;
};
export declare const QueryGetRecordsByBondIdResponse: {
    encode(message: QueryGetRecordsByBondIdResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryGetRecordsByBondIdResponse;
    fromJSON(object: any): QueryGetRecordsByBondIdResponse;
    toJSON(message: QueryGetRecordsByBondIdResponse): unknown;
    fromPartial<I extends {
        records?: {
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: string[] | undefined;
            attributes?: Uint8Array | undefined;
            names?: string[] | undefined;
            type?: string | undefined;
        }[] | undefined;
        pagination?: {
            nextKey?: Uint8Array | undefined;
            total?: string | number | Long.Long | undefined;
        } | undefined;
    } & {
        records?: ({
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: string[] | undefined;
            attributes?: Uint8Array | undefined;
            names?: string[] | undefined;
            type?: string | undefined;
        }[] & ({
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: string[] | undefined;
            attributes?: Uint8Array | undefined;
            names?: string[] | undefined;
            type?: string | undefined;
        } & {
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: (string[] & string[] & { [K in Exclude<keyof I["records"][number]["owners"], keyof string[]>]: never; }) | undefined;
            attributes?: Uint8Array | undefined;
            names?: (string[] & string[] & { [K_1 in Exclude<keyof I["records"][number]["names"], keyof string[]>]: never; }) | undefined;
            type?: string | undefined;
        } & { [K_2 in Exclude<keyof I["records"][number], keyof Record>]: never; })[] & { [K_3 in Exclude<keyof I["records"], keyof {
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: string[] | undefined;
            attributes?: Uint8Array | undefined;
            names?: string[] | undefined;
            type?: string | undefined;
        }[]>]: never; }) | undefined;
        pagination?: ({
            nextKey?: Uint8Array | undefined;
            total?: string | number | Long.Long | undefined;
        } & {
            nextKey?: Uint8Array | undefined;
            total?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_4 in Exclude<keyof I["pagination"]["total"], keyof Long.Long>]: never; }) | undefined;
        } & { [K_5 in Exclude<keyof I["pagination"], keyof PageResponse>]: never; }) | undefined;
    } & { [K_6 in Exclude<keyof I, keyof QueryGetRecordsByBondIdResponse>]: never; }>(object: I): QueryGetRecordsByBondIdResponse;
};
export declare const QueryNameRecordsRequest: {
    encode(message: QueryNameRecordsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryNameRecordsRequest;
    fromJSON(object: any): QueryNameRecordsRequest;
    toJSON(message: QueryNameRecordsRequest): unknown;
    fromPartial<I extends {
        pagination?: {
            key?: Uint8Array | undefined;
            offset?: string | number | Long.Long | undefined;
            limit?: string | number | Long.Long | undefined;
            countTotal?: boolean | undefined;
            reverse?: boolean | undefined;
        } | undefined;
    } & {
        pagination?: ({
            key?: Uint8Array | undefined;
            offset?: string | number | Long.Long | undefined;
            limit?: string | number | Long.Long | undefined;
            countTotal?: boolean | undefined;
            reverse?: boolean | undefined;
        } & {
            key?: Uint8Array | undefined;
            offset?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K in Exclude<keyof I["pagination"]["offset"], keyof Long.Long>]: never; }) | undefined;
            limit?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_1 in Exclude<keyof I["pagination"]["limit"], keyof Long.Long>]: never; }) | undefined;
            countTotal?: boolean | undefined;
            reverse?: boolean | undefined;
        } & { [K_2 in Exclude<keyof I["pagination"], keyof PageRequest>]: never; }) | undefined;
    } & { [K_3 in Exclude<keyof I, "pagination">]: never; }>(object: I): QueryNameRecordsRequest;
};
export declare const QueryNameRecordsResponse: {
    encode(message: QueryNameRecordsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryNameRecordsResponse;
    fromJSON(object: any): QueryNameRecordsResponse;
    toJSON(message: QueryNameRecordsResponse): unknown;
    fromPartial<I extends {
        names?: {
            name?: string | undefined;
            entry?: {
                latest?: {
                    id?: string | undefined;
                    height?: string | number | Long.Long | undefined;
                } | undefined;
                history?: {
                    id?: string | undefined;
                    height?: string | number | Long.Long | undefined;
                }[] | undefined;
            } | undefined;
        }[] | undefined;
        pagination?: {
            nextKey?: Uint8Array | undefined;
            total?: string | number | Long.Long | undefined;
        } | undefined;
    } & {
        names?: ({
            name?: string | undefined;
            entry?: {
                latest?: {
                    id?: string | undefined;
                    height?: string | number | Long.Long | undefined;
                } | undefined;
                history?: {
                    id?: string | undefined;
                    height?: string | number | Long.Long | undefined;
                }[] | undefined;
            } | undefined;
        }[] & ({
            name?: string | undefined;
            entry?: {
                latest?: {
                    id?: string | undefined;
                    height?: string | number | Long.Long | undefined;
                } | undefined;
                history?: {
                    id?: string | undefined;
                    height?: string | number | Long.Long | undefined;
                }[] | undefined;
            } | undefined;
        } & {
            name?: string | undefined;
            entry?: ({
                latest?: {
                    id?: string | undefined;
                    height?: string | number | Long.Long | undefined;
                } | undefined;
                history?: {
                    id?: string | undefined;
                    height?: string | number | Long.Long | undefined;
                }[] | undefined;
            } & {
                latest?: ({
                    id?: string | undefined;
                    height?: string | number | Long.Long | undefined;
                } & {
                    id?: string | undefined;
                    height?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K in Exclude<keyof I["names"][number]["entry"]["latest"]["height"], keyof Long.Long>]: never; }) | undefined;
                } & { [K_1 in Exclude<keyof I["names"][number]["entry"]["latest"], keyof import("./registry").NameRecordEntry>]: never; }) | undefined;
                history?: ({
                    id?: string | undefined;
                    height?: string | number | Long.Long | undefined;
                }[] & ({
                    id?: string | undefined;
                    height?: string | number | Long.Long | undefined;
                } & {
                    id?: string | undefined;
                    height?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_2 in Exclude<keyof I["names"][number]["entry"]["history"][number]["height"], keyof Long.Long>]: never; }) | undefined;
                } & { [K_3 in Exclude<keyof I["names"][number]["entry"]["history"][number], keyof import("./registry").NameRecordEntry>]: never; })[] & { [K_4 in Exclude<keyof I["names"][number]["entry"]["history"], keyof {
                    id?: string | undefined;
                    height?: string | number | Long.Long | undefined;
                }[]>]: never; }) | undefined;
            } & { [K_5 in Exclude<keyof I["names"][number]["entry"], keyof NameRecord>]: never; }) | undefined;
        } & { [K_6 in Exclude<keyof I["names"][number], keyof NameEntry>]: never; })[] & { [K_7 in Exclude<keyof I["names"], keyof {
            name?: string | undefined;
            entry?: {
                latest?: {
                    id?: string | undefined;
                    height?: string | number | Long.Long | undefined;
                } | undefined;
                history?: {
                    id?: string | undefined;
                    height?: string | number | Long.Long | undefined;
                }[] | undefined;
            } | undefined;
        }[]>]: never; }) | undefined;
        pagination?: ({
            nextKey?: Uint8Array | undefined;
            total?: string | number | Long.Long | undefined;
        } & {
            nextKey?: Uint8Array | undefined;
            total?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_8 in Exclude<keyof I["pagination"]["total"], keyof Long.Long>]: never; }) | undefined;
        } & { [K_9 in Exclude<keyof I["pagination"], keyof PageResponse>]: never; }) | undefined;
    } & { [K_10 in Exclude<keyof I, keyof QueryNameRecordsResponse>]: never; }>(object: I): QueryNameRecordsResponse;
};
export declare const QueryWhoisRequest: {
    encode(message: QueryWhoisRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryWhoisRequest;
    fromJSON(object: any): QueryWhoisRequest;
    toJSON(message: QueryWhoisRequest): unknown;
    fromPartial<I extends {
        name?: string | undefined;
    } & {
        name?: string | undefined;
    } & { [K in Exclude<keyof I, "name">]: never; }>(object: I): QueryWhoisRequest;
};
export declare const QueryWhoisResponse: {
    encode(message: QueryWhoisResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryWhoisResponse;
    fromJSON(object: any): QueryWhoisResponse;
    toJSON(message: QueryWhoisResponse): unknown;
    fromPartial<I extends {
        nameAuthority?: {
            ownerPublicKey?: string | undefined;
            ownerAddress?: string | undefined;
            height?: string | number | Long.Long | undefined;
            status?: string | undefined;
            auctionId?: string | undefined;
            bondId?: string | undefined;
            expiryTime?: Date | undefined;
        } | undefined;
    } & {
        nameAuthority?: ({
            ownerPublicKey?: string | undefined;
            ownerAddress?: string | undefined;
            height?: string | number | Long.Long | undefined;
            status?: string | undefined;
            auctionId?: string | undefined;
            bondId?: string | undefined;
            expiryTime?: Date | undefined;
        } & {
            ownerPublicKey?: string | undefined;
            ownerAddress?: string | undefined;
            height?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K in Exclude<keyof I["nameAuthority"]["height"], keyof Long.Long>]: never; }) | undefined;
            status?: string | undefined;
            auctionId?: string | undefined;
            bondId?: string | undefined;
            expiryTime?: Date | undefined;
        } & { [K_1 in Exclude<keyof I["nameAuthority"], keyof NameAuthority>]: never; }) | undefined;
    } & { [K_2 in Exclude<keyof I, "nameAuthority">]: never; }>(object: I): QueryWhoisResponse;
};
export declare const QueryAuthoritiesRequest: {
    encode(message: QueryAuthoritiesRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryAuthoritiesRequest;
    fromJSON(object: any): QueryAuthoritiesRequest;
    toJSON(message: QueryAuthoritiesRequest): unknown;
    fromPartial<I extends {
        owner?: string | undefined;
    } & {
        owner?: string | undefined;
    } & { [K in Exclude<keyof I, "owner">]: never; }>(object: I): QueryAuthoritiesRequest;
};
export declare const QueryAuthoritiesResponse: {
    encode(message: QueryAuthoritiesResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryAuthoritiesResponse;
    fromJSON(object: any): QueryAuthoritiesResponse;
    toJSON(message: QueryAuthoritiesResponse): unknown;
    fromPartial<I extends {
        authorities?: {
            name?: string | undefined;
            entry?: {
                ownerPublicKey?: string | undefined;
                ownerAddress?: string | undefined;
                height?: string | number | Long.Long | undefined;
                status?: string | undefined;
                auctionId?: string | undefined;
                bondId?: string | undefined;
                expiryTime?: Date | undefined;
            } | undefined;
        }[] | undefined;
        pagination?: {
            nextKey?: Uint8Array | undefined;
            total?: string | number | Long.Long | undefined;
        } | undefined;
    } & {
        authorities?: ({
            name?: string | undefined;
            entry?: {
                ownerPublicKey?: string | undefined;
                ownerAddress?: string | undefined;
                height?: string | number | Long.Long | undefined;
                status?: string | undefined;
                auctionId?: string | undefined;
                bondId?: string | undefined;
                expiryTime?: Date | undefined;
            } | undefined;
        }[] & ({
            name?: string | undefined;
            entry?: {
                ownerPublicKey?: string | undefined;
                ownerAddress?: string | undefined;
                height?: string | number | Long.Long | undefined;
                status?: string | undefined;
                auctionId?: string | undefined;
                bondId?: string | undefined;
                expiryTime?: Date | undefined;
            } | undefined;
        } & {
            name?: string | undefined;
            entry?: ({
                ownerPublicKey?: string | undefined;
                ownerAddress?: string | undefined;
                height?: string | number | Long.Long | undefined;
                status?: string | undefined;
                auctionId?: string | undefined;
                bondId?: string | undefined;
                expiryTime?: Date | undefined;
            } & {
                ownerPublicKey?: string | undefined;
                ownerAddress?: string | undefined;
                height?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K in Exclude<keyof I["authorities"][number]["entry"]["height"], keyof Long.Long>]: never; }) | undefined;
                status?: string | undefined;
                auctionId?: string | undefined;
                bondId?: string | undefined;
                expiryTime?: Date | undefined;
            } & { [K_1 in Exclude<keyof I["authorities"][number]["entry"], keyof NameAuthority>]: never; }) | undefined;
        } & { [K_2 in Exclude<keyof I["authorities"][number], keyof AuthorityEntry>]: never; })[] & { [K_3 in Exclude<keyof I["authorities"], keyof {
            name?: string | undefined;
            entry?: {
                ownerPublicKey?: string | undefined;
                ownerAddress?: string | undefined;
                height?: string | number | Long.Long | undefined;
                status?: string | undefined;
                auctionId?: string | undefined;
                bondId?: string | undefined;
                expiryTime?: Date | undefined;
            } | undefined;
        }[]>]: never; }) | undefined;
        pagination?: ({
            nextKey?: Uint8Array | undefined;
            total?: string | number | Long.Long | undefined;
        } & {
            nextKey?: Uint8Array | undefined;
            total?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_4 in Exclude<keyof I["pagination"]["total"], keyof Long.Long>]: never; }) | undefined;
        } & { [K_5 in Exclude<keyof I["pagination"], keyof PageResponse>]: never; }) | undefined;
    } & { [K_6 in Exclude<keyof I, keyof QueryAuthoritiesResponse>]: never; }>(object: I): QueryAuthoritiesResponse;
};
export declare const QueryLookupLrnRequest: {
    encode(message: QueryLookupLrnRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryLookupLrnRequest;
    fromJSON(object: any): QueryLookupLrnRequest;
    toJSON(message: QueryLookupLrnRequest): unknown;
    fromPartial<I extends {
        lrn?: string | undefined;
    } & {
        lrn?: string | undefined;
    } & { [K in Exclude<keyof I, "lrn">]: never; }>(object: I): QueryLookupLrnRequest;
};
export declare const QueryLookupLrnResponse: {
    encode(message: QueryLookupLrnResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryLookupLrnResponse;
    fromJSON(object: any): QueryLookupLrnResponse;
    toJSON(message: QueryLookupLrnResponse): unknown;
    fromPartial<I extends {
        name?: {
            latest?: {
                id?: string | undefined;
                height?: string | number | Long.Long | undefined;
            } | undefined;
            history?: {
                id?: string | undefined;
                height?: string | number | Long.Long | undefined;
            }[] | undefined;
        } | undefined;
    } & {
        name?: ({
            latest?: {
                id?: string | undefined;
                height?: string | number | Long.Long | undefined;
            } | undefined;
            history?: {
                id?: string | undefined;
                height?: string | number | Long.Long | undefined;
            }[] | undefined;
        } & {
            latest?: ({
                id?: string | undefined;
                height?: string | number | Long.Long | undefined;
            } & {
                id?: string | undefined;
                height?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K in Exclude<keyof I["name"]["latest"]["height"], keyof Long.Long>]: never; }) | undefined;
            } & { [K_1 in Exclude<keyof I["name"]["latest"], keyof import("./registry").NameRecordEntry>]: never; }) | undefined;
            history?: ({
                id?: string | undefined;
                height?: string | number | Long.Long | undefined;
            }[] & ({
                id?: string | undefined;
                height?: string | number | Long.Long | undefined;
            } & {
                id?: string | undefined;
                height?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_2 in Exclude<keyof I["name"]["history"][number]["height"], keyof Long.Long>]: never; }) | undefined;
            } & { [K_3 in Exclude<keyof I["name"]["history"][number], keyof import("./registry").NameRecordEntry>]: never; })[] & { [K_4 in Exclude<keyof I["name"]["history"], keyof {
                id?: string | undefined;
                height?: string | number | Long.Long | undefined;
            }[]>]: never; }) | undefined;
        } & { [K_5 in Exclude<keyof I["name"], keyof NameRecord>]: never; }) | undefined;
    } & { [K_6 in Exclude<keyof I, "name">]: never; }>(object: I): QueryLookupLrnResponse;
};
export declare const QueryResolveLrnRequest: {
    encode(message: QueryResolveLrnRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryResolveLrnRequest;
    fromJSON(object: any): QueryResolveLrnRequest;
    toJSON(message: QueryResolveLrnRequest): unknown;
    fromPartial<I extends {
        lrn?: string | undefined;
    } & {
        lrn?: string | undefined;
    } & { [K in Exclude<keyof I, "lrn">]: never; }>(object: I): QueryResolveLrnRequest;
};
export declare const QueryResolveLrnResponse: {
    encode(message: QueryResolveLrnResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryResolveLrnResponse;
    fromJSON(object: any): QueryResolveLrnResponse;
    toJSON(message: QueryResolveLrnResponse): unknown;
    fromPartial<I extends {
        record?: {
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: string[] | undefined;
            attributes?: Uint8Array | undefined;
            names?: string[] | undefined;
            type?: string | undefined;
        } | undefined;
    } & {
        record?: ({
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: string[] | undefined;
            attributes?: Uint8Array | undefined;
            names?: string[] | undefined;
            type?: string | undefined;
        } & {
            id?: string | undefined;
            bondId?: string | undefined;
            createTime?: string | undefined;
            expiryTime?: string | undefined;
            deleted?: boolean | undefined;
            owners?: (string[] & string[] & { [K in Exclude<keyof I["record"]["owners"], keyof string[]>]: never; }) | undefined;
            attributes?: Uint8Array | undefined;
            names?: (string[] & string[] & { [K_1 in Exclude<keyof I["record"]["names"], keyof string[]>]: never; }) | undefined;
            type?: string | undefined;
        } & { [K_2 in Exclude<keyof I["record"], keyof Record>]: never; }) | undefined;
    } & { [K_3 in Exclude<keyof I, "record">]: never; }>(object: I): QueryResolveLrnResponse;
};
export declare const QueryGetRegistryModuleBalanceRequest: {
    encode(_: QueryGetRegistryModuleBalanceRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryGetRegistryModuleBalanceRequest;
    fromJSON(_: any): QueryGetRegistryModuleBalanceRequest;
    toJSON(_: QueryGetRegistryModuleBalanceRequest): unknown;
    fromPartial<I extends {} & {} & { [K in Exclude<keyof I, never>]: never; }>(_: I): QueryGetRegistryModuleBalanceRequest;
};
export declare const QueryGetRegistryModuleBalanceResponse: {
    encode(message: QueryGetRegistryModuleBalanceResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryGetRegistryModuleBalanceResponse;
    fromJSON(object: any): QueryGetRegistryModuleBalanceResponse;
    toJSON(message: QueryGetRegistryModuleBalanceResponse): unknown;
    fromPartial<I extends {
        balances?: {
            accountName?: string | undefined;
            balance?: {
                denom?: string | undefined;
                amount?: string | undefined;
            }[] | undefined;
        }[] | undefined;
    } & {
        balances?: ({
            accountName?: string | undefined;
            balance?: {
                denom?: string | undefined;
                amount?: string | undefined;
            }[] | undefined;
        }[] & ({
            accountName?: string | undefined;
            balance?: {
                denom?: string | undefined;
                amount?: string | undefined;
            }[] | undefined;
        } & {
            accountName?: string | undefined;
            balance?: ({
                denom?: string | undefined;
                amount?: string | undefined;
            }[] & ({
                denom?: string | undefined;
                amount?: string | undefined;
            } & {
                denom?: string | undefined;
                amount?: string | undefined;
            } & { [K in Exclude<keyof I["balances"][number]["balance"][number], keyof Coin>]: never; })[] & { [K_1 in Exclude<keyof I["balances"][number]["balance"], keyof {
                denom?: string | undefined;
                amount?: string | undefined;
            }[]>]: never; }) | undefined;
        } & { [K_2 in Exclude<keyof I["balances"][number], keyof AccountBalance>]: never; })[] & { [K_3 in Exclude<keyof I["balances"], keyof {
            accountName?: string | undefined;
            balance?: {
                denom?: string | undefined;
                amount?: string | undefined;
            }[] | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_4 in Exclude<keyof I, "balances">]: never; }>(object: I): QueryGetRegistryModuleBalanceResponse;
};
export declare const AccountBalance: {
    encode(message: AccountBalance, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AccountBalance;
    fromJSON(object: any): AccountBalance;
    toJSON(message: AccountBalance): unknown;
    fromPartial<I extends {
        accountName?: string | undefined;
        balance?: {
            denom?: string | undefined;
            amount?: string | undefined;
        }[] | undefined;
    } & {
        accountName?: string | undefined;
        balance?: ({
            denom?: string | undefined;
            amount?: string | undefined;
        }[] & ({
            denom?: string | undefined;
            amount?: string | undefined;
        } & {
            denom?: string | undefined;
            amount?: string | undefined;
        } & { [K in Exclude<keyof I["balance"][number], keyof Coin>]: never; })[] & { [K_1 in Exclude<keyof I["balance"], keyof {
            denom?: string | undefined;
            amount?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_2 in Exclude<keyof I, keyof AccountBalance>]: never; }>(object: I): AccountBalance;
};
/** Query defines the gRPC querier service for registry module */
export interface Query {
    /** Params queries the registry module params. */
    Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
    /** Records queries all records */
    Records(request: QueryRecordsRequest): Promise<QueryRecordsResponse>;
    /** Get record by id */
    GetRecord(request: QueryGetRecordRequest): Promise<QueryGetRecordResponse>;
    /** Get records by bond id */
    GetRecordsByBondId(request: QueryGetRecordsByBondIdRequest): Promise<QueryGetRecordsByBondIdResponse>;
    /** NameRecords queries all name records */
    NameRecords(request: QueryNameRecordsRequest): Promise<QueryNameRecordsResponse>;
    /** Whois method retrieve the name authority info */
    Whois(request: QueryWhoisRequest): Promise<QueryWhoisResponse>;
    /** LookupLrn */
    LookupLrn(request: QueryLookupLrnRequest): Promise<QueryLookupLrnResponse>;
    /** ResolveLrn */
    ResolveLrn(request: QueryResolveLrnRequest): Promise<QueryResolveLrnResponse>;
    /** Get registry module balance */
    GetRegistryModuleBalance(request: QueryGetRegistryModuleBalanceRequest): Promise<QueryGetRegistryModuleBalanceResponse>;
    /** Authorities queries all authorities */
    Authorities(request: QueryAuthoritiesRequest): Promise<QueryAuthoritiesResponse>;
}
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    constructor(rpc: Rpc);
    Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
    Records(request: QueryRecordsRequest): Promise<QueryRecordsResponse>;
    GetRecord(request: QueryGetRecordRequest): Promise<QueryGetRecordResponse>;
    GetRecordsByBondId(request: QueryGetRecordsByBondIdRequest): Promise<QueryGetRecordsByBondIdResponse>;
    NameRecords(request: QueryNameRecordsRequest): Promise<QueryNameRecordsResponse>;
    Whois(request: QueryWhoisRequest): Promise<QueryWhoisResponse>;
    LookupLrn(request: QueryLookupLrnRequest): Promise<QueryLookupLrnResponse>;
    ResolveLrn(request: QueryResolveLrnRequest): Promise<QueryResolveLrnResponse>;
    GetRegistryModuleBalance(request: QueryGetRegistryModuleBalanceRequest): Promise<QueryGetRegistryModuleBalanceResponse>;
    Authorities(request: QueryAuthoritiesRequest): Promise<QueryAuthoritiesResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export {};
