import Long from "long";
import _m0 from "protobufjs/minimal";
export declare const protobufPackage = "google.protobuf";
/**
 * The protocol compiler can output a FileDescriptorSet containing the .proto
 * files it parses.
 */
export interface FileDescriptorSet {
    file: FileDescriptorProto[];
}
/** Describes a complete .proto file. */
export interface FileDescriptorProto {
    /** file name, relative to root of source tree */
    name: string;
    /** e.g. "foo", "foo.bar", etc. */
    package: string;
    /** Names of files imported by this file. */
    dependency: string[];
    /** Indexes of the public imported files in the dependency list above. */
    publicDependency: number[];
    /**
     * Indexes of the weak imported files in the dependency list.
     * For Google-internal migration only. Do not use.
     */
    weakDependency: number[];
    /** All top-level definitions in this file. */
    messageType: DescriptorProto[];
    enumType: EnumDescriptorProto[];
    service: ServiceDescriptorProto[];
    extension: FieldDescriptorProto[];
    options?: FileOptions;
    /**
     * This field contains optional information about the original source code.
     * You may safely remove this entire field without harming runtime
     * functionality of the descriptors -- the information is needed only by
     * development tools.
     */
    sourceCodeInfo?: SourceCodeInfo;
    /**
     * The syntax of the proto file.
     * The supported values are "proto2" and "proto3".
     */
    syntax: string;
}
/** Describes a message type. */
export interface DescriptorProto {
    name: string;
    field: FieldDescriptorProto[];
    extension: FieldDescriptorProto[];
    nestedType: DescriptorProto[];
    enumType: EnumDescriptorProto[];
    extensionRange: DescriptorProto_ExtensionRange[];
    oneofDecl: OneofDescriptorProto[];
    options?: MessageOptions;
    reservedRange: DescriptorProto_ReservedRange[];
    /**
     * Reserved field names, which may not be used by fields in the same message.
     * A given name may only be reserved once.
     */
    reservedName: string[];
}
export interface DescriptorProto_ExtensionRange {
    /** Inclusive. */
    start: number;
    /** Exclusive. */
    end: number;
    options?: ExtensionRangeOptions;
}
/**
 * Range of reserved tag numbers. Reserved tag numbers may not be used by
 * fields or extension ranges in the same message. Reserved ranges may
 * not overlap.
 */
export interface DescriptorProto_ReservedRange {
    /** Inclusive. */
    start: number;
    /** Exclusive. */
    end: number;
}
export interface ExtensionRangeOptions {
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
/** Describes a field within a message. */
export interface FieldDescriptorProto {
    name: string;
    number: number;
    label: FieldDescriptorProto_Label;
    /**
     * If type_name is set, this need not be set.  If both this and type_name
     * are set, this must be one of TYPE_ENUM, TYPE_MESSAGE or TYPE_GROUP.
     */
    type: FieldDescriptorProto_Type;
    /**
     * For message and enum types, this is the name of the type.  If the name
     * starts with a '.', it is fully-qualified.  Otherwise, C++-like scoping
     * rules are used to find the type (i.e. first the nested types within this
     * message are searched, then within the parent, on up to the root
     * namespace).
     */
    typeName: string;
    /**
     * For extensions, this is the name of the type being extended.  It is
     * resolved in the same manner as type_name.
     */
    extendee: string;
    /**
     * For numeric types, contains the original text representation of the value.
     * For booleans, "true" or "false".
     * For strings, contains the default text contents (not escaped in any way).
     * For bytes, contains the C escaped value.  All bytes >= 128 are escaped.
     */
    defaultValue: string;
    /**
     * If set, gives the index of a oneof in the containing type's oneof_decl
     * list.  This field is a member of that oneof.
     */
    oneofIndex: number;
    /**
     * JSON name of this field. The value is set by protocol compiler. If the
     * user has set a "json_name" option on this field, that option's value
     * will be used. Otherwise, it's deduced from the field's name by converting
     * it to camelCase.
     */
    jsonName: string;
    options?: FieldOptions;
    /**
     * If true, this is a proto3 "optional". When a proto3 field is optional, it
     * tracks presence regardless of field type.
     *
     * When proto3_optional is true, this field must be belong to a oneof to
     * signal to old proto3 clients that presence is tracked for this field. This
     * oneof is known as a "synthetic" oneof, and this field must be its sole
     * member (each proto3 optional field gets its own synthetic oneof). Synthetic
     * oneofs exist in the descriptor only, and do not generate any API. Synthetic
     * oneofs must be ordered after all "real" oneofs.
     *
     * For message fields, proto3_optional doesn't create any semantic change,
     * since non-repeated message fields always track presence. However it still
     * indicates the semantic detail of whether the user wrote "optional" or not.
     * This can be useful for round-tripping the .proto file. For consistency we
     * give message fields a synthetic oneof also, even though it is not required
     * to track presence. This is especially important because the parser can't
     * tell if a field is a message or an enum, so it must always create a
     * synthetic oneof.
     *
     * Proto2 optional fields do not set this flag, because they already indicate
     * optional with `LABEL_OPTIONAL`.
     */
    proto3Optional: boolean;
}
export declare enum FieldDescriptorProto_Type {
    /**
     * TYPE_DOUBLE - 0 is reserved for errors.
     * Order is weird for historical reasons.
     */
    TYPE_DOUBLE = 1,
    TYPE_FLOAT = 2,
    /**
     * TYPE_INT64 - Not ZigZag encoded.  Negative numbers take 10 bytes.  Use TYPE_SINT64 if
     * negative values are likely.
     */
    TYPE_INT64 = 3,
    TYPE_UINT64 = 4,
    /**
     * TYPE_INT32 - Not ZigZag encoded.  Negative numbers take 10 bytes.  Use TYPE_SINT32 if
     * negative values are likely.
     */
    TYPE_INT32 = 5,
    TYPE_FIXED64 = 6,
    TYPE_FIXED32 = 7,
    TYPE_BOOL = 8,
    TYPE_STRING = 9,
    /**
     * TYPE_GROUP - Tag-delimited aggregate.
     * Group type is deprecated and not supported in proto3. However, Proto3
     * implementations should still be able to parse the group wire format and
     * treat group fields as unknown fields.
     */
    TYPE_GROUP = 10,
    /** TYPE_MESSAGE - Length-delimited aggregate. */
    TYPE_MESSAGE = 11,
    /** TYPE_BYTES - New in version 2. */
    TYPE_BYTES = 12,
    TYPE_UINT32 = 13,
    TYPE_ENUM = 14,
    TYPE_SFIXED32 = 15,
    TYPE_SFIXED64 = 16,
    /** TYPE_SINT32 - Uses ZigZag encoding. */
    TYPE_SINT32 = 17,
    /** TYPE_SINT64 - Uses ZigZag encoding. */
    TYPE_SINT64 = 18,
    UNRECOGNIZED = -1
}
export declare function fieldDescriptorProto_TypeFromJSON(object: any): FieldDescriptorProto_Type;
export declare function fieldDescriptorProto_TypeToJSON(object: FieldDescriptorProto_Type): string;
export declare enum FieldDescriptorProto_Label {
    /** LABEL_OPTIONAL - 0 is reserved for errors */
    LABEL_OPTIONAL = 1,
    LABEL_REQUIRED = 2,
    LABEL_REPEATED = 3,
    UNRECOGNIZED = -1
}
export declare function fieldDescriptorProto_LabelFromJSON(object: any): FieldDescriptorProto_Label;
export declare function fieldDescriptorProto_LabelToJSON(object: FieldDescriptorProto_Label): string;
/** Describes a oneof. */
export interface OneofDescriptorProto {
    name: string;
    options?: OneofOptions;
}
/** Describes an enum type. */
export interface EnumDescriptorProto {
    name: string;
    value: EnumValueDescriptorProto[];
    options?: EnumOptions;
    /**
     * Range of reserved numeric values. Reserved numeric values may not be used
     * by enum values in the same enum declaration. Reserved ranges may not
     * overlap.
     */
    reservedRange: EnumDescriptorProto_EnumReservedRange[];
    /**
     * Reserved enum value names, which may not be reused. A given name may only
     * be reserved once.
     */
    reservedName: string[];
}
/**
 * Range of reserved numeric values. Reserved values may not be used by
 * entries in the same enum. Reserved ranges may not overlap.
 *
 * Note that this is distinct from DescriptorProto.ReservedRange in that it
 * is inclusive such that it can appropriately represent the entire int32
 * domain.
 */
export interface EnumDescriptorProto_EnumReservedRange {
    /** Inclusive. */
    start: number;
    /** Inclusive. */
    end: number;
}
/** Describes a value within an enum. */
export interface EnumValueDescriptorProto {
    name: string;
    number: number;
    options?: EnumValueOptions;
}
/** Describes a service. */
export interface ServiceDescriptorProto {
    name: string;
    method: MethodDescriptorProto[];
    options?: ServiceOptions;
}
/** Describes a method of a service. */
export interface MethodDescriptorProto {
    name: string;
    /**
     * Input and output type names.  These are resolved in the same way as
     * FieldDescriptorProto.type_name, but must refer to a message type.
     */
    inputType: string;
    outputType: string;
    options?: MethodOptions;
    /** Identifies if client streams multiple client messages */
    clientStreaming: boolean;
    /** Identifies if server streams multiple server messages */
    serverStreaming: boolean;
}
export interface FileOptions {
    /**
     * Sets the Java package where classes generated from this .proto will be
     * placed.  By default, the proto package is used, but this is often
     * inappropriate because proto packages do not normally start with backwards
     * domain names.
     */
    javaPackage: string;
    /**
     * Controls the name of the wrapper Java class generated for the .proto file.
     * That class will always contain the .proto file's getDescriptor() method as
     * well as any top-level extensions defined in the .proto file.
     * If java_multiple_files is disabled, then all the other classes from the
     * .proto file will be nested inside the single wrapper outer class.
     */
    javaOuterClassname: string;
    /**
     * If enabled, then the Java code generator will generate a separate .java
     * file for each top-level message, enum, and service defined in the .proto
     * file.  Thus, these types will *not* be nested inside the wrapper class
     * named by java_outer_classname.  However, the wrapper class will still be
     * generated to contain the file's getDescriptor() method as well as any
     * top-level extensions defined in the file.
     */
    javaMultipleFiles: boolean;
    /**
     * This option does nothing.
     *
     * @deprecated
     */
    javaGenerateEqualsAndHash: boolean;
    /**
     * If set true, then the Java2 code generator will generate code that
     * throws an exception whenever an attempt is made to assign a non-UTF-8
     * byte sequence to a string field.
     * Message reflection will do the same.
     * However, an extension field still accepts non-UTF-8 byte sequences.
     * This option has no effect on when used with the lite runtime.
     */
    javaStringCheckUtf8: boolean;
    optimizeFor: FileOptions_OptimizeMode;
    /**
     * Sets the Go package where structs generated from this .proto will be
     * placed. If omitted, the Go package will be derived from the following:
     *   - The basename of the package import path, if provided.
     *   - Otherwise, the package statement in the .proto file, if present.
     *   - Otherwise, the basename of the .proto file, without extension.
     */
    goPackage: string;
    /**
     * Should generic services be generated in each language?  "Generic" services
     * are not specific to any particular RPC system.  They are generated by the
     * main code generators in each language (without additional plugins).
     * Generic services were the only kind of service generation supported by
     * early versions of google.protobuf.
     *
     * Generic services are now considered deprecated in favor of using plugins
     * that generate code specific to your particular RPC system.  Therefore,
     * these default to false.  Old code which depends on generic services should
     * explicitly set them to true.
     */
    ccGenericServices: boolean;
    javaGenericServices: boolean;
    pyGenericServices: boolean;
    phpGenericServices: boolean;
    /**
     * Is this file deprecated?
     * Depending on the target platform, this can emit Deprecated annotations
     * for everything in the file, or it will be completely ignored; in the very
     * least, this is a formalization for deprecating files.
     */
    deprecated: boolean;
    /**
     * Enables the use of arenas for the proto messages in this file. This applies
     * only to generated classes for C++.
     */
    ccEnableArenas: boolean;
    /**
     * Sets the objective c class prefix which is prepended to all objective c
     * generated classes from this .proto. There is no default.
     */
    objcClassPrefix: string;
    /** Namespace for generated classes; defaults to the package. */
    csharpNamespace: string;
    /**
     * By default Swift generators will take the proto package and CamelCase it
     * replacing '.' with underscore and use that to prefix the types/symbols
     * defined. When this options is provided, they will use this value instead
     * to prefix the types/symbols defined.
     */
    swiftPrefix: string;
    /**
     * Sets the php class prefix which is prepended to all php generated classes
     * from this .proto. Default is empty.
     */
    phpClassPrefix: string;
    /**
     * Use this option to change the namespace of php generated classes. Default
     * is empty. When this option is empty, the package name will be used for
     * determining the namespace.
     */
    phpNamespace: string;
    /**
     * Use this option to change the namespace of php generated metadata classes.
     * Default is empty. When this option is empty, the proto file name will be
     * used for determining the namespace.
     */
    phpMetadataNamespace: string;
    /**
     * Use this option to change the package of ruby generated classes. Default
     * is empty. When this option is not set, the package name will be used for
     * determining the ruby package.
     */
    rubyPackage: string;
    /**
     * The parser stores options it doesn't recognize here.
     * See the documentation for the "Options" section above.
     */
    uninterpretedOption: UninterpretedOption[];
}
/** Generated classes can be optimized for speed or code size. */
export declare enum FileOptions_OptimizeMode {
    /** SPEED - Generate complete code for parsing, serialization, */
    SPEED = 1,
    /** CODE_SIZE - etc. */
    CODE_SIZE = 2,
    /** LITE_RUNTIME - Generate code using MessageLite and the lite runtime. */
    LITE_RUNTIME = 3,
    UNRECOGNIZED = -1
}
export declare function fileOptions_OptimizeModeFromJSON(object: any): FileOptions_OptimizeMode;
export declare function fileOptions_OptimizeModeToJSON(object: FileOptions_OptimizeMode): string;
export interface MessageOptions {
    /**
     * Set true to use the old proto1 MessageSet wire format for extensions.
     * This is provided for backwards-compatibility with the MessageSet wire
     * format.  You should not use this for any other reason:  It's less
     * efficient, has fewer features, and is more complicated.
     *
     * The message must be defined exactly as follows:
     *   message Foo {
     *     option message_set_wire_format = true;
     *     extensions 4 to max;
     *   }
     * Note that the message cannot have any defined fields; MessageSets only
     * have extensions.
     *
     * All extensions of your type must be singular messages; e.g. they cannot
     * be int32s, enums, or repeated messages.
     *
     * Because this is an option, the above two restrictions are not enforced by
     * the protocol compiler.
     */
    messageSetWireFormat: boolean;
    /**
     * Disables the generation of the standard "descriptor()" accessor, which can
     * conflict with a field of the same name.  This is meant to make migration
     * from proto1 easier; new code should avoid fields named "descriptor".
     */
    noStandardDescriptorAccessor: boolean;
    /**
     * Is this message deprecated?
     * Depending on the target platform, this can emit Deprecated annotations
     * for the message, or it will be completely ignored; in the very least,
     * this is a formalization for deprecating messages.
     */
    deprecated: boolean;
    /**
     * Whether the message is an automatically generated map entry type for the
     * maps field.
     *
     * For maps fields:
     *     map<KeyType, ValueType> map_field = 1;
     * The parsed descriptor looks like:
     *     message MapFieldEntry {
     *         option map_entry = true;
     *         optional KeyType key = 1;
     *         optional ValueType value = 2;
     *     }
     *     repeated MapFieldEntry map_field = 1;
     *
     * Implementations may choose not to generate the map_entry=true message, but
     * use a native map in the target language to hold the keys and values.
     * The reflection APIs in such implementations still need to work as
     * if the field is a repeated message field.
     *
     * NOTE: Do not set the option in .proto files. Always use the maps syntax
     * instead. The option should only be implicitly set by the proto compiler
     * parser.
     */
    mapEntry: boolean;
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
export interface FieldOptions {
    /**
     * The ctype option instructs the C++ code generator to use a different
     * representation of the field than it normally would.  See the specific
     * options below.  This option is not yet implemented in the open source
     * release -- sorry, we'll try to include it in a future version!
     */
    ctype: FieldOptions_CType;
    /**
     * The packed option can be enabled for repeated primitive fields to enable
     * a more efficient representation on the wire. Rather than repeatedly
     * writing the tag and type for each element, the entire array is encoded as
     * a single length-delimited blob. In proto3, only explicit setting it to
     * false will avoid using packed encoding.
     */
    packed: boolean;
    /**
     * The jstype option determines the JavaScript type used for values of the
     * field.  The option is permitted only for 64 bit integral and fixed types
     * (int64, uint64, sint64, fixed64, sfixed64).  A field with jstype JS_STRING
     * is represented as JavaScript string, which avoids loss of precision that
     * can happen when a large value is converted to a floating point JavaScript.
     * Specifying JS_NUMBER for the jstype causes the generated JavaScript code to
     * use the JavaScript "number" type.  The behavior of the default option
     * JS_NORMAL is implementation dependent.
     *
     * This option is an enum to permit additional types to be added, e.g.
     * goog.math.Integer.
     */
    jstype: FieldOptions_JSType;
    /**
     * Should this field be parsed lazily?  Lazy applies only to message-type
     * fields.  It means that when the outer message is initially parsed, the
     * inner message's contents will not be parsed but instead stored in encoded
     * form.  The inner message will actually be parsed when it is first accessed.
     *
     * This is only a hint.  Implementations are free to choose whether to use
     * eager or lazy parsing regardless of the value of this option.  However,
     * setting this option true suggests that the protocol author believes that
     * using lazy parsing on this field is worth the additional bookkeeping
     * overhead typically needed to implement it.
     *
     * This option does not affect the public interface of any generated code;
     * all method signatures remain the same.  Furthermore, thread-safety of the
     * interface is not affected by this option; const methods remain safe to
     * call from multiple threads concurrently, while non-const methods continue
     * to require exclusive access.
     *
     *
     * Note that implementations may choose not to check required fields within
     * a lazy sub-message.  That is, calling IsInitialized() on the outer message
     * may return true even if the inner message has missing required fields.
     * This is necessary because otherwise the inner message would have to be
     * parsed in order to perform the check, defeating the purpose of lazy
     * parsing.  An implementation which chooses not to check required fields
     * must be consistent about it.  That is, for any particular sub-message, the
     * implementation must either *always* check its required fields, or *never*
     * check its required fields, regardless of whether or not the message has
     * been parsed.
     *
     * As of 2021, lazy does no correctness checks on the byte stream during
     * parsing.  This may lead to crashes if and when an invalid byte stream is
     * finally parsed upon access.
     *
     * TODO(b/211906113):  Enable validation on lazy fields.
     */
    lazy: boolean;
    /**
     * unverified_lazy does no correctness checks on the byte stream. This should
     * only be used where lazy with verification is prohibitive for performance
     * reasons.
     */
    unverifiedLazy: boolean;
    /**
     * Is this field deprecated?
     * Depending on the target platform, this can emit Deprecated annotations
     * for accessors, or it will be completely ignored; in the very least, this
     * is a formalization for deprecating fields.
     */
    deprecated: boolean;
    /** For Google-internal migration only. Do not use. */
    weak: boolean;
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
export declare enum FieldOptions_CType {
    /** STRING - Default mode. */
    STRING = 0,
    CORD = 1,
    STRING_PIECE = 2,
    UNRECOGNIZED = -1
}
export declare function fieldOptions_CTypeFromJSON(object: any): FieldOptions_CType;
export declare function fieldOptions_CTypeToJSON(object: FieldOptions_CType): string;
export declare enum FieldOptions_JSType {
    /** JS_NORMAL - Use the default type. */
    JS_NORMAL = 0,
    /** JS_STRING - Use JavaScript strings. */
    JS_STRING = 1,
    /** JS_NUMBER - Use JavaScript numbers. */
    JS_NUMBER = 2,
    UNRECOGNIZED = -1
}
export declare function fieldOptions_JSTypeFromJSON(object: any): FieldOptions_JSType;
export declare function fieldOptions_JSTypeToJSON(object: FieldOptions_JSType): string;
export interface OneofOptions {
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
export interface EnumOptions {
    /**
     * Set this option to true to allow mapping different tag names to the same
     * value.
     */
    allowAlias: boolean;
    /**
     * Is this enum deprecated?
     * Depending on the target platform, this can emit Deprecated annotations
     * for the enum, or it will be completely ignored; in the very least, this
     * is a formalization for deprecating enums.
     */
    deprecated: boolean;
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
export interface EnumValueOptions {
    /**
     * Is this enum value deprecated?
     * Depending on the target platform, this can emit Deprecated annotations
     * for the enum value, or it will be completely ignored; in the very least,
     * this is a formalization for deprecating enum values.
     */
    deprecated: boolean;
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
export interface ServiceOptions {
    /**
     * Is this service deprecated?
     * Depending on the target platform, this can emit Deprecated annotations
     * for the service, or it will be completely ignored; in the very least,
     * this is a formalization for deprecating services.
     */
    deprecated: boolean;
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
export interface MethodOptions {
    /**
     * Is this method deprecated?
     * Depending on the target platform, this can emit Deprecated annotations
     * for the method, or it will be completely ignored; in the very least,
     * this is a formalization for deprecating methods.
     */
    deprecated: boolean;
    idempotencyLevel: MethodOptions_IdempotencyLevel;
    /** The parser stores options it doesn't recognize here. See above. */
    uninterpretedOption: UninterpretedOption[];
}
/**
 * Is this method side-effect-free (or safe in HTTP parlance), or idempotent,
 * or neither? HTTP based RPC implementation may choose GET verb for safe
 * methods, and PUT verb for idempotent methods instead of the default POST.
 */
export declare enum MethodOptions_IdempotencyLevel {
    IDEMPOTENCY_UNKNOWN = 0,
    /** NO_SIDE_EFFECTS - implies idempotent */
    NO_SIDE_EFFECTS = 1,
    /** IDEMPOTENT - idempotent, but may have side effects */
    IDEMPOTENT = 2,
    UNRECOGNIZED = -1
}
export declare function methodOptions_IdempotencyLevelFromJSON(object: any): MethodOptions_IdempotencyLevel;
export declare function methodOptions_IdempotencyLevelToJSON(object: MethodOptions_IdempotencyLevel): string;
/**
 * A message representing a option the parser does not recognize. This only
 * appears in options protos created by the compiler::Parser class.
 * DescriptorPool resolves these when building Descriptor objects. Therefore,
 * options protos in descriptor objects (e.g. returned by Descriptor::options(),
 * or produced by Descriptor::CopyTo()) will never have UninterpretedOptions
 * in them.
 */
export interface UninterpretedOption {
    name: UninterpretedOption_NamePart[];
    /**
     * The value of the uninterpreted option, in whatever type the tokenizer
     * identified it as during parsing. Exactly one of these should be set.
     */
    identifierValue: string;
    positiveIntValue: Long;
    negativeIntValue: Long;
    doubleValue: number;
    stringValue: Uint8Array;
    aggregateValue: string;
}
/**
 * The name of the uninterpreted option.  Each string represents a segment in
 * a dot-separated name.  is_extension is true iff a segment represents an
 * extension (denoted with parentheses in options specs in .proto files).
 * E.g.,{ ["foo", false], ["bar.baz", true], ["moo", false] } represents
 * "foo.(bar.baz).moo".
 */
export interface UninterpretedOption_NamePart {
    namePart: string;
    isExtension: boolean;
}
/**
 * Encapsulates information about the original source file from which a
 * FileDescriptorProto was generated.
 */
export interface SourceCodeInfo {
    /**
     * A Location identifies a piece of source code in a .proto file which
     * corresponds to a particular definition.  This information is intended
     * to be useful to IDEs, code indexers, documentation generators, and similar
     * tools.
     *
     * For example, say we have a file like:
     *   message Foo {
     *     optional string foo = 1;
     *   }
     * Let's look at just the field definition:
     *   optional string foo = 1;
     *   ^       ^^     ^^  ^  ^^^
     *   a       bc     de  f  ghi
     * We have the following locations:
     *   span   path               represents
     *   [a,i)  [ 4, 0, 2, 0 ]     The whole field definition.
     *   [a,b)  [ 4, 0, 2, 0, 4 ]  The label (optional).
     *   [c,d)  [ 4, 0, 2, 0, 5 ]  The type (string).
     *   [e,f)  [ 4, 0, 2, 0, 1 ]  The name (foo).
     *   [g,h)  [ 4, 0, 2, 0, 3 ]  The number (1).
     *
     * Notes:
     * - A location may refer to a repeated field itself (i.e. not to any
     *   particular index within it).  This is used whenever a set of elements are
     *   logically enclosed in a single code segment.  For example, an entire
     *   extend block (possibly containing multiple extension definitions) will
     *   have an outer location whose path refers to the "extensions" repeated
     *   field without an index.
     * - Multiple locations may have the same path.  This happens when a single
     *   logical declaration is spread out across multiple places.  The most
     *   obvious example is the "extend" block again -- there may be multiple
     *   extend blocks in the same scope, each of which will have the same path.
     * - A location's span is not always a subset of its parent's span.  For
     *   example, the "extendee" of an extension declaration appears at the
     *   beginning of the "extend" block and is shared by all extensions within
     *   the block.
     * - Just because a location's span is a subset of some other location's span
     *   does not mean that it is a descendant.  For example, a "group" defines
     *   both a type and a field in a single declaration.  Thus, the locations
     *   corresponding to the type and field and their components will overlap.
     * - Code which tries to interpret locations should probably be designed to
     *   ignore those that it doesn't understand, as more types of locations could
     *   be recorded in the future.
     */
    location: SourceCodeInfo_Location[];
}
export interface SourceCodeInfo_Location {
    /**
     * Identifies which part of the FileDescriptorProto was defined at this
     * location.
     *
     * Each element is a field number or an index.  They form a path from
     * the root FileDescriptorProto to the place where the definition occurs.
     * For example, this path:
     *   [ 4, 3, 2, 7, 1 ]
     * refers to:
     *   file.message_type(3)  // 4, 3
     *       .field(7)         // 2, 7
     *       .name()           // 1
     * This is because FileDescriptorProto.message_type has field number 4:
     *   repeated DescriptorProto message_type = 4;
     * and DescriptorProto.field has field number 2:
     *   repeated FieldDescriptorProto field = 2;
     * and FieldDescriptorProto.name has field number 1:
     *   optional string name = 1;
     *
     * Thus, the above path gives the location of a field name.  If we removed
     * the last element:
     *   [ 4, 3, 2, 7 ]
     * this path refers to the whole field declaration (from the beginning
     * of the label to the terminating semicolon).
     */
    path: number[];
    /**
     * Always has exactly three or four elements: start line, start column,
     * end line (optional, otherwise assumed same as start line), end column.
     * These are packed into a single field for efficiency.  Note that line
     * and column numbers are zero-based -- typically you will want to add
     * 1 to each before displaying to a user.
     */
    span: number[];
    /**
     * If this SourceCodeInfo represents a complete declaration, these are any
     * comments appearing before and after the declaration which appear to be
     * attached to the declaration.
     *
     * A series of line comments appearing on consecutive lines, with no other
     * tokens appearing on those lines, will be treated as a single comment.
     *
     * leading_detached_comments will keep paragraphs of comments that appear
     * before (but not connected to) the current element. Each paragraph,
     * separated by empty lines, will be one comment element in the repeated
     * field.
     *
     * Only the comment content is provided; comment markers (e.g. //) are
     * stripped out.  For block comments, leading whitespace and an asterisk
     * will be stripped from the beginning of each line other than the first.
     * Newlines are included in the output.
     *
     * Examples:
     *
     *   optional int32 foo = 1;  // Comment attached to foo.
     *   // Comment attached to bar.
     *   optional int32 bar = 2;
     *
     *   optional string baz = 3;
     *   // Comment attached to baz.
     *   // Another line attached to baz.
     *
     *   // Comment attached to moo.
     *   //
     *   // Another line attached to moo.
     *   optional double moo = 4;
     *
     *   // Detached comment for corge. This is not leading or trailing comments
     *   // to moo or corge because there are blank lines separating it from
     *   // both.
     *
     *   // Detached comment for corge paragraph 2.
     *
     *   optional string corge = 5;
     *   /* Block comment attached
     *    * to corge.  Leading asterisks
     *    * will be removed. * /
     *   /* Block comment attached to
     *    * grault. * /
     *   optional int32 grault = 6;
     *
     *   // ignored detached comments.
     */
    leadingComments: string;
    trailingComments: string;
    leadingDetachedComments: string[];
}
/**
 * Describes the relationship between generated code and its original source
 * file. A GeneratedCodeInfo message is associated with only one generated
 * source file, but may contain references to different source .proto files.
 */
export interface GeneratedCodeInfo {
    /**
     * An Annotation connects some span of text in generated code to an element
     * of its generating .proto file.
     */
    annotation: GeneratedCodeInfo_Annotation[];
}
export interface GeneratedCodeInfo_Annotation {
    /**
     * Identifies the element in the original source .proto file. This field
     * is formatted the same as SourceCodeInfo.Location.path.
     */
    path: number[];
    /** Identifies the filesystem path to the original source .proto. */
    sourceFile: string;
    /**
     * Identifies the starting offset in bytes in the generated code
     * that relates to the identified object.
     */
    begin: number;
    /**
     * Identifies the ending offset in bytes in the generated code that
     * relates to the identified offset. The end offset should be one past
     * the last relevant byte (so the length of the text = end - begin).
     */
    end: number;
}
export declare const FileDescriptorSet: {
    encode(message: FileDescriptorSet, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): FileDescriptorSet;
    fromJSON(object: any): FileDescriptorSet;
    toJSON(message: FileDescriptorSet): unknown;
    fromPartial<I extends {
        file?: {
            name?: string | undefined;
            package?: string | undefined;
            dependency?: string[] | undefined;
            publicDependency?: number[] | undefined;
            weakDependency?: number[] | undefined;
            messageType?: {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            service?: {
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            options?: {
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            sourceCodeInfo?: {
                location?: {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] | undefined;
            } | undefined;
            syntax?: string | undefined;
        }[] | undefined;
    } & {
        file?: ({
            name?: string | undefined;
            package?: string | undefined;
            dependency?: string[] | undefined;
            publicDependency?: number[] | undefined;
            weakDependency?: number[] | undefined;
            messageType?: {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            service?: {
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            options?: {
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            sourceCodeInfo?: {
                location?: {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] | undefined;
            } | undefined;
            syntax?: string | undefined;
        }[] & ({
            name?: string | undefined;
            package?: string | undefined;
            dependency?: string[] | undefined;
            publicDependency?: number[] | undefined;
            weakDependency?: number[] | undefined;
            messageType?: {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            service?: {
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            options?: {
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            sourceCodeInfo?: {
                location?: {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] | undefined;
            } | undefined;
            syntax?: string | undefined;
        } & {
            name?: string | undefined;
            package?: string | undefined;
            dependency?: (string[] & string[] & { [K in Exclude<keyof I["file"][number]["dependency"], keyof string[]>]: never; }) | undefined;
            publicDependency?: (number[] & number[] & { [K_1 in Exclude<keyof I["file"][number]["publicDependency"], keyof number[]>]: never; }) | undefined;
            weakDependency?: (number[] & number[] & { [K_2 in Exclude<keyof I["file"][number]["weakDependency"], keyof number[]>]: never; }) | undefined;
            messageType?: ({
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] & ({
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            } & {
                name?: string | undefined;
                field?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: ({
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_3 in Exclude<keyof I["file"][number]["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_4 in Exclude<keyof I["file"][number]["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_5 in Exclude<keyof I["file"][number]["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_6 in Exclude<keyof I["file"][number]["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_7 in Exclude<keyof I["file"][number]["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_8 in Exclude<keyof I["file"][number]["messageType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_9 in Exclude<keyof I["file"][number]["messageType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                    proto3Optional?: boolean | undefined;
                } & { [K_10 in Exclude<keyof I["file"][number]["messageType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_11 in Exclude<keyof I["file"][number]["messageType"][number]["field"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[]>]: never; }) | undefined;
                extension?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: ({
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_12 in Exclude<keyof I["file"][number]["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_13 in Exclude<keyof I["file"][number]["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_14 in Exclude<keyof I["file"][number]["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_15 in Exclude<keyof I["file"][number]["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_16 in Exclude<keyof I["file"][number]["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_17 in Exclude<keyof I["file"][number]["messageType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_18 in Exclude<keyof I["file"][number]["messageType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                    proto3Optional?: boolean | undefined;
                } & { [K_19 in Exclude<keyof I["file"][number]["messageType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_20 in Exclude<keyof I["file"][number]["messageType"][number]["extension"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[]>]: never; }) | undefined;
                nestedType?: ({
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] & ({
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                } & {
                    name?: string | undefined;
                    field?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: ({
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_21 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_22 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_23 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_24 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_25 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_26 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_27 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                        proto3Optional?: boolean | undefined;
                    } & { [K_28 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_29 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["field"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    extension?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: ({
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_30 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_31 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_32 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_33 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_34 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_35 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_36 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                        proto3Optional?: boolean | undefined;
                    } & { [K_37 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_38 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extension"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    nestedType?: ({
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] & ({
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    } & {
                        name?: string | undefined;
                        field?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: ({
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_39 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_40 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_41 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_42 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_43 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_44 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_45 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                            proto3Optional?: boolean | undefined;
                        } & { [K_46 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_47 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        extension?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: ({
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_48 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_49 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_50 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_51 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_52 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_53 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_54 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                            proto3Optional?: boolean | undefined;
                        } & { [K_55 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_56 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        nestedType?: ({
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] & ({
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        } & {
                            name?: string | undefined;
                            field?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: ({
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_57 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_58 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_59 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_60 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_61 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_62 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_63 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                proto3Optional?: boolean | undefined;
                            } & { [K_64 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_65 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            extension?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: ({
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_66 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_67 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_68 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_69 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_70 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_71 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_72 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                proto3Optional?: boolean | undefined;
                            } & { [K_73 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_74 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            nestedType?: ({
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] & ({
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            } & {
                                name?: string | undefined;
                                field?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: ({
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_75 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_76 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_77 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_78 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_79 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_80 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_81 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                    proto3Optional?: boolean | undefined;
                                } & { [K_82 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_83 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                extension?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: ({
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_84 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_85 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_86 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_87 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_88 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_89 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_90 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                    proto3Optional?: boolean | undefined;
                                } & { [K_91 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_92 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                nestedType?: ({
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                } & {
                                    name?: string | undefined;
                                    field?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: ({
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_93 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_94 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_95 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_96 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_97 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_98 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_99 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                        proto3Optional?: boolean | undefined;
                                    } & { [K_100 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_101 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    extension?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: ({
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_102 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_103 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_104 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_105 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_106 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_107 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_108 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                        proto3Optional?: boolean | undefined;
                                    } & { [K_109 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_110 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    nestedType?: ({
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    } & {
                                        name?: string | undefined;
                                        field?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: ({
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_111 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_112 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_113 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                            proto3Optional?: boolean | undefined;
                                        } & { [K_114 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_115 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        extension?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: ({
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_116 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_117 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_118 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                            proto3Optional?: boolean | undefined;
                                        } & { [K_119 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_120 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        nestedType?: ({
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        } & {
                                            name?: string | undefined;
                                            field?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: ({
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_121 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                                proto3Optional?: boolean | undefined;
                                            } & { [K_122 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_123 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            extension?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: ({
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_124 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                                proto3Optional?: boolean | undefined;
                                            } & { [K_125 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_126 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            nestedType?: ({
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            } & {
                                                name?: string | undefined;
                                                field?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                } & any & { [K_127 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_128 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                extension?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                } & any & { [K_129 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_130 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                nestedType?: ({
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                } & any & { [K_131 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_132 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[]>]: never; }) | undefined;
                                                enumType?: ({
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                } & any & { [K_133 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_134 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[]>]: never; }) | undefined;
                                                extensionRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & { [K_135 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_136 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>]: never; }) | undefined;
                                                oneofDecl?: ({
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & { [K_137 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_138 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>]: never; }) | undefined;
                                                options?: ({
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_139 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                                                reservedRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                } & any & { [K_140 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_141 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[]>]: never; }) | undefined;
                                                reservedName?: (string[] & string[] & { [K_142 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                            } & { [K_143 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_144 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[]>]: never; }) | undefined;
                                            enumType?: ({
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            } & {
                                                name?: string | undefined;
                                                value?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & { [K_145 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_146 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>]: never; }) | undefined;
                                                options?: ({
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_147 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                                                reservedRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                } & any & { [K_148 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_149 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[]>]: never; }) | undefined;
                                                reservedName?: (string[] & string[] & { [K_150 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                            } & { [K_151 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_152 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[]>]: never; }) | undefined;
                                            extensionRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: ({
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_153 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                            } & { [K_154 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_155 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>]: never; }) | undefined;
                                            oneofDecl?: ({
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                options?: ({
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_156 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                            } & { [K_157 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_158 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>]: never; }) | undefined;
                                            options?: ({
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_159 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_160 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_161 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                                            reservedRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & { [K_162 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_163 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[]>]: never; }) | undefined;
                                            reservedName?: (string[] & string[] & { [K_164 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                        } & { [K_165 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_166 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[]>]: never; }) | undefined;
                                        enumType?: ({
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        } & {
                                            name?: string | undefined;
                                            value?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: ({
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_167 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                                            } & { [K_168 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_169 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>]: never; }) | undefined;
                                            options?: ({
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_170 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_171 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_172 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                                            reservedRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & { [K_173 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_174 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[]>]: never; }) | undefined;
                                            reservedName?: (string[] & string[] & { [K_175 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                        } & { [K_176 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_177 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[]>]: never; }) | undefined;
                                        extensionRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: ({
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_178 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_179 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_180 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                        } & { [K_181 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_182 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>]: never; }) | undefined;
                                        oneofDecl?: ({
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            options?: ({
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_183 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_184 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_185 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                        } & { [K_186 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_187 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>]: never; }) | undefined;
                                        options?: ({
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_188 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_189 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_190 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_191 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_192 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_193 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_194 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                                        reservedRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & { [K_195 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_196 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[]>]: never; }) | undefined;
                                        reservedName?: (string[] & string[] & { [K_197 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                    } & { [K_198 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_199 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[]>]: never; }) | undefined;
                                    enumType?: ({
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    } & {
                                        name?: string | undefined;
                                        value?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: ({
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_200 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_201 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_202 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                                        } & { [K_203 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_204 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>]: never; }) | undefined;
                                        options?: ({
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_205 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_206 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_207 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_208 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_209 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_210 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_211 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                                        reservedRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & { [K_212 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_213 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[]>]: never; }) | undefined;
                                        reservedName?: (string[] & string[] & { [K_214 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                    } & { [K_215 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_216 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[]>]: never; }) | undefined;
                                    extensionRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: ({
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_217 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_218 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_219 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_220 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_221 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_222 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_223 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                    } & { [K_224 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_225 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>]: never; }) | undefined;
                                    oneofDecl?: ({
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        options?: ({
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_226 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_227 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_228 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_229 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_230 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_231 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_232 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                    } & { [K_233 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_234 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>]: never; }) | undefined;
                                    options?: ({
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_235 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_236 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_237 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_238 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_239 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_240 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_241 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                                    reservedRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & { [K_242 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_243 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[]>]: never; }) | undefined;
                                    reservedName?: (string[] & string[] & { [K_244 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                } & { [K_245 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_246 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[]>]: never; }) | undefined;
                                enumType?: ({
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                } & {
                                    name?: string | undefined;
                                    value?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: ({
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_247 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_248 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_249 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_250 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_251 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_252 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_253 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                                    } & { [K_254 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_255 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>]: never; }) | undefined;
                                    options?: ({
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_256 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_257 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_258 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_259 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_260 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_261 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_262 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                                    reservedRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & { [K_263 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_264 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[]>]: never; }) | undefined;
                                    reservedName?: (string[] & string[] & { [K_265 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                } & { [K_266 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_267 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[]>]: never; }) | undefined;
                                extensionRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: ({
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_268 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_269 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_270 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_271 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_272 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_273 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_274 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                } & { [K_275 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_276 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>]: never; }) | undefined;
                                oneofDecl?: ({
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    options?: ({
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_277 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_278 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_279 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_280 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_281 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_282 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_283 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                } & { [K_284 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_285 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>]: never; }) | undefined;
                                options?: ({
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_286 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_287 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_288 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_289 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_290 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_291 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_292 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                                reservedRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & { [K_293 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_294 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[]>]: never; }) | undefined;
                                reservedName?: (string[] & string[] & { [K_295 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                            } & { [K_296 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_297 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[]>]: never; }) | undefined;
                            enumType?: ({
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] & ({
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            } & {
                                name?: string | undefined;
                                value?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: ({
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_298 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_299 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_300 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_301 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_302 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_303 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_304 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                                } & { [K_305 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_306 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>]: never; }) | undefined;
                                options?: ({
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_307 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_308 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_309 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_310 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_311 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_312 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_313 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                                reservedRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & { [K_314 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_315 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[]>]: never; }) | undefined;
                                reservedName?: (string[] & string[] & { [K_316 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                            } & { [K_317 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_318 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[]>]: never; }) | undefined;
                            extensionRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: ({
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_319 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_320 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_321 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_322 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_323 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_324 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_325 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                            } & { [K_326 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_327 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>]: never; }) | undefined;
                            oneofDecl?: ({
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                options?: ({
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_328 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_329 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_330 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_331 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_332 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_333 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_334 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                            } & { [K_335 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_336 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>]: never; }) | undefined;
                            options?: ({
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_337 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_338 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_339 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_340 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_341 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_342 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_343 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                            reservedRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                            } & { [K_344 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_345 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[]>]: never; }) | undefined;
                            reservedName?: (string[] & string[] & { [K_346 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                        } & { [K_347 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_348 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[]>]: never; }) | undefined;
                        enumType?: ({
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] & ({
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        } & {
                            name?: string | undefined;
                            value?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: ({
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_349 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_350 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_351 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_352 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_353 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_354 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_355 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                            } & { [K_356 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_357 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>]: never; }) | undefined;
                            options?: ({
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_358 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_359 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_360 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_361 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_362 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_363 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_364 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                            reservedRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                            } & { [K_365 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_366 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[]>]: never; }) | undefined;
                            reservedName?: (string[] & string[] & { [K_367 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                        } & { [K_368 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_369 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[]>]: never; }) | undefined;
                        extensionRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: ({
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_370 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_371 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_372 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_373 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_374 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_375 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_376 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                        } & { [K_377 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_378 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>]: never; }) | undefined;
                        oneofDecl?: ({
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            options?: ({
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_379 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_380 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_381 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_382 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_383 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_384 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_385 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                        } & { [K_386 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_387 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>]: never; }) | undefined;
                        options?: ({
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_388 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_389 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_390 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_391 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_392 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_393 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_394 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                        reservedRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                        } & { [K_395 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_396 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[]>]: never; }) | undefined;
                        reservedName?: (string[] & string[] & { [K_397 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                    } & { [K_398 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_399 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["nestedType"], keyof {
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[]>]: never; }) | undefined;
                    enumType?: ({
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] & ({
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    } & {
                        name?: string | undefined;
                        value?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: ({
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_400 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_401 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_402 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_403 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_404 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_405 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_406 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                        } & { [K_407 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_408 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>]: never; }) | undefined;
                        options?: ({
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_409 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_410 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_411 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_412 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_413 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_414 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_415 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                        reservedRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                        } & { [K_416 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_417 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[]>]: never; }) | undefined;
                        reservedName?: (string[] & string[] & { [K_418 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                    } & { [K_419 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_420 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["enumType"], keyof {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[]>]: never; }) | undefined;
                    extensionRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: ({
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_421 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_422 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_423 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_424 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_425 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_426 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_427 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                    } & { [K_428 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_429 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["extensionRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>]: never; }) | undefined;
                    oneofDecl?: ({
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        options?: ({
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_430 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_431 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_432 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_433 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_434 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_435 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_436 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                    } & { [K_437 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_438 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["oneofDecl"], keyof {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>]: never; }) | undefined;
                    options?: ({
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_439 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_440 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_441 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_442 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_443 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_444 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_445 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                    reservedRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                    } & { [K_446 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_447 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["reservedRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[]>]: never; }) | undefined;
                    reservedName?: (string[] & string[] & { [K_448 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                } & { [K_449 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_450 in Exclude<keyof I["file"][number]["messageType"][number]["nestedType"], keyof {
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[]>]: never; }) | undefined;
                enumType?: ({
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] & ({
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                } & {
                    name?: string | undefined;
                    value?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: ({
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_451 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_452 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_453 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_454 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_455 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_456 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_457 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                    } & { [K_458 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_459 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["value"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>]: never; }) | undefined;
                    options?: ({
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_460 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_461 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_462 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_463 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_464 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_465 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_466 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                    reservedRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                    } & { [K_467 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_468 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["reservedRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[]>]: never; }) | undefined;
                    reservedName?: (string[] & string[] & { [K_469 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                } & { [K_470 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_471 in Exclude<keyof I["file"][number]["messageType"][number]["enumType"], keyof {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[]>]: never; }) | undefined;
                extensionRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: ({
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_472 in Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_473 in Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_474 in Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_475 in Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_476 in Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_477 in Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_478 in Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                } & { [K_479 in Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_480 in Exclude<keyof I["file"][number]["messageType"][number]["extensionRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>]: never; }) | undefined;
                oneofDecl?: ({
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    options?: ({
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_481 in Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_482 in Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_483 in Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_484 in Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_485 in Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_486 in Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_487 in Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                } & { [K_488 in Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_489 in Exclude<keyof I["file"][number]["messageType"][number]["oneofDecl"], keyof {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>]: never; }) | undefined;
                options?: ({
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_490 in Exclude<keyof I["file"][number]["messageType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_491 in Exclude<keyof I["file"][number]["messageType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_492 in Exclude<keyof I["file"][number]["messageType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_493 in Exclude<keyof I["file"][number]["messageType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_494 in Exclude<keyof I["file"][number]["messageType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_495 in Exclude<keyof I["file"][number]["messageType"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_496 in Exclude<keyof I["file"][number]["messageType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                reservedRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                } & { [K_497 in Exclude<keyof I["file"][number]["messageType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_498 in Exclude<keyof I["file"][number]["messageType"][number]["reservedRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                }[]>]: never; }) | undefined;
                reservedName?: (string[] & string[] & { [K_499 in Exclude<keyof I["file"][number]["messageType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
            } & { [K_500 in Exclude<keyof I["file"][number]["messageType"][number], keyof DescriptorProto>]: never; })[] & { [K_501 in Exclude<keyof I["file"][number]["messageType"], keyof {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[]>]: never; }) | undefined;
            enumType?: ({
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] & ({
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            } & {
                name?: string | undefined;
                value?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: ({
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_502 in Exclude<keyof I["file"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_503 in Exclude<keyof I["file"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_504 in Exclude<keyof I["file"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_505 in Exclude<keyof I["file"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_506 in Exclude<keyof I["file"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_507 in Exclude<keyof I["file"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_508 in Exclude<keyof I["file"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                } & { [K_509 in Exclude<keyof I["file"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_510 in Exclude<keyof I["file"][number]["enumType"][number]["value"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>]: never; }) | undefined;
                options?: ({
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_511 in Exclude<keyof I["file"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_512 in Exclude<keyof I["file"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_513 in Exclude<keyof I["file"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_514 in Exclude<keyof I["file"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_515 in Exclude<keyof I["file"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_516 in Exclude<keyof I["file"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_517 in Exclude<keyof I["file"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                reservedRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                } & { [K_518 in Exclude<keyof I["file"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_519 in Exclude<keyof I["file"][number]["enumType"][number]["reservedRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                }[]>]: never; }) | undefined;
                reservedName?: (string[] & string[] & { [K_520 in Exclude<keyof I["file"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
            } & { [K_521 in Exclude<keyof I["file"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_522 in Exclude<keyof I["file"][number]["enumType"], keyof {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[]>]: never; }) | undefined;
            service?: ({
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                method?: ({
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] & ({
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                } & {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: ({
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_523 in Exclude<keyof I["file"][number]["service"][number]["method"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_524 in Exclude<keyof I["file"][number]["service"][number]["method"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_525 in Exclude<keyof I["file"][number]["service"][number]["method"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_526 in Exclude<keyof I["file"][number]["service"][number]["method"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_527 in Exclude<keyof I["file"][number]["service"][number]["method"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_528 in Exclude<keyof I["file"][number]["service"][number]["method"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_529 in Exclude<keyof I["file"][number]["service"][number]["method"][number]["options"], keyof MethodOptions>]: never; }) | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                } & { [K_530 in Exclude<keyof I["file"][number]["service"][number]["method"][number], keyof MethodDescriptorProto>]: never; })[] & { [K_531 in Exclude<keyof I["file"][number]["service"][number]["method"], keyof {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[]>]: never; }) | undefined;
                options?: ({
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_532 in Exclude<keyof I["file"][number]["service"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_533 in Exclude<keyof I["file"][number]["service"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_534 in Exclude<keyof I["file"][number]["service"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_535 in Exclude<keyof I["file"][number]["service"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_536 in Exclude<keyof I["file"][number]["service"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_537 in Exclude<keyof I["file"][number]["service"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_538 in Exclude<keyof I["file"][number]["service"][number]["options"], keyof ServiceOptions>]: never; }) | undefined;
            } & { [K_539 in Exclude<keyof I["file"][number]["service"][number], keyof ServiceDescriptorProto>]: never; })[] & { [K_540 in Exclude<keyof I["file"][number]["service"], keyof {
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>]: never; }) | undefined;
            extension?: ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] & ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            } & {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: ({
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_541 in Exclude<keyof I["file"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_542 in Exclude<keyof I["file"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_543 in Exclude<keyof I["file"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_544 in Exclude<keyof I["file"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_545 in Exclude<keyof I["file"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_546 in Exclude<keyof I["file"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_547 in Exclude<keyof I["file"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                proto3Optional?: boolean | undefined;
            } & { [K_548 in Exclude<keyof I["file"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_549 in Exclude<keyof I["file"][number]["extension"], keyof {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[]>]: never; }) | undefined;
            options?: ({
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & { [K_550 in Exclude<keyof I["file"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_551 in Exclude<keyof I["file"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_552 in Exclude<keyof I["file"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                    negativeIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_553 in Exclude<keyof I["file"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & { [K_554 in Exclude<keyof I["file"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_555 in Exclude<keyof I["file"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>]: never; }) | undefined;
            } & { [K_556 in Exclude<keyof I["file"][number]["options"], keyof FileOptions>]: never; }) | undefined;
            sourceCodeInfo?: ({
                location?: {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] | undefined;
            } & {
                location?: ({
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] & ({
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                } & {
                    path?: (number[] & number[] & { [K_557 in Exclude<keyof I["file"][number]["sourceCodeInfo"]["location"][number]["path"], keyof number[]>]: never; }) | undefined;
                    span?: (number[] & number[] & { [K_558 in Exclude<keyof I["file"][number]["sourceCodeInfo"]["location"][number]["span"], keyof number[]>]: never; }) | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: (string[] & string[] & { [K_559 in Exclude<keyof I["file"][number]["sourceCodeInfo"]["location"][number]["leadingDetachedComments"], keyof string[]>]: never; }) | undefined;
                } & { [K_560 in Exclude<keyof I["file"][number]["sourceCodeInfo"]["location"][number], keyof SourceCodeInfo_Location>]: never; })[] & { [K_561 in Exclude<keyof I["file"][number]["sourceCodeInfo"]["location"], keyof {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[]>]: never; }) | undefined;
            } & { [K_562 in Exclude<keyof I["file"][number]["sourceCodeInfo"], "location">]: never; }) | undefined;
            syntax?: string | undefined;
        } & { [K_563 in Exclude<keyof I["file"][number], keyof FileDescriptorProto>]: never; })[] & { [K_564 in Exclude<keyof I["file"], keyof {
            name?: string | undefined;
            package?: string | undefined;
            dependency?: string[] | undefined;
            publicDependency?: number[] | undefined;
            weakDependency?: number[] | undefined;
            messageType?: {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            service?: {
                name?: string | undefined;
                method?: {
                    name?: string | undefined;
                    inputType?: string | undefined;
                    outputType?: string | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    clientStreaming?: boolean | undefined;
                    serverStreaming?: boolean | undefined;
                }[] | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            options?: {
                javaPackage?: string | undefined;
                javaOuterClassname?: string | undefined;
                javaMultipleFiles?: boolean | undefined;
                javaGenerateEqualsAndHash?: boolean | undefined;
                javaStringCheckUtf8?: boolean | undefined;
                optimizeFor?: FileOptions_OptimizeMode | undefined;
                goPackage?: string | undefined;
                ccGenericServices?: boolean | undefined;
                javaGenericServices?: boolean | undefined;
                pyGenericServices?: boolean | undefined;
                phpGenericServices?: boolean | undefined;
                deprecated?: boolean | undefined;
                ccEnableArenas?: boolean | undefined;
                objcClassPrefix?: string | undefined;
                csharpNamespace?: string | undefined;
                swiftPrefix?: string | undefined;
                phpClassPrefix?: string | undefined;
                phpNamespace?: string | undefined;
                phpMetadataNamespace?: string | undefined;
                rubyPackage?: string | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            sourceCodeInfo?: {
                location?: {
                    path?: number[] | undefined;
                    span?: number[] | undefined;
                    leadingComments?: string | undefined;
                    trailingComments?: string | undefined;
                    leadingDetachedComments?: string[] | undefined;
                }[] | undefined;
            } | undefined;
            syntax?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_565 in Exclude<keyof I, "file">]: never; }>(object: I): FileDescriptorSet;
};
export declare const FileDescriptorProto: {
    encode(message: FileDescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): FileDescriptorProto;
    fromJSON(object: any): FileDescriptorProto;
    toJSON(message: FileDescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        package?: string | undefined;
        dependency?: string[] | undefined;
        publicDependency?: number[] | undefined;
        weakDependency?: number[] | undefined;
        messageType?: {
            name?: string | undefined;
            field?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            nestedType?: any[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            extensionRange?: {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            oneofDecl?: {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[] | undefined;
        enumType?: {
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[] | undefined;
        service?: {
            name?: string | undefined;
            method?: {
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            }[] | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] | undefined;
        extension?: {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            proto3Optional?: boolean | undefined;
        }[] | undefined;
        options?: {
            javaPackage?: string | undefined;
            javaOuterClassname?: string | undefined;
            javaMultipleFiles?: boolean | undefined;
            javaGenerateEqualsAndHash?: boolean | undefined;
            javaStringCheckUtf8?: boolean | undefined;
            optimizeFor?: FileOptions_OptimizeMode | undefined;
            goPackage?: string | undefined;
            ccGenericServices?: boolean | undefined;
            javaGenericServices?: boolean | undefined;
            pyGenericServices?: boolean | undefined;
            phpGenericServices?: boolean | undefined;
            deprecated?: boolean | undefined;
            ccEnableArenas?: boolean | undefined;
            objcClassPrefix?: string | undefined;
            csharpNamespace?: string | undefined;
            swiftPrefix?: string | undefined;
            phpClassPrefix?: string | undefined;
            phpNamespace?: string | undefined;
            phpMetadataNamespace?: string | undefined;
            rubyPackage?: string | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
        sourceCodeInfo?: {
            location?: {
                path?: number[] | undefined;
                span?: number[] | undefined;
                leadingComments?: string | undefined;
                trailingComments?: string | undefined;
                leadingDetachedComments?: string[] | undefined;
            }[] | undefined;
        } | undefined;
        syntax?: string | undefined;
    } & {
        name?: string | undefined;
        package?: string | undefined;
        dependency?: (string[] & string[] & { [K in Exclude<keyof I["dependency"], keyof string[]>]: never; }) | undefined;
        publicDependency?: (number[] & number[] & { [K_1 in Exclude<keyof I["publicDependency"], keyof number[]>]: never; }) | undefined;
        weakDependency?: (number[] & number[] & { [K_2 in Exclude<keyof I["weakDependency"], keyof number[]>]: never; }) | undefined;
        messageType?: ({
            name?: string | undefined;
            field?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            nestedType?: any[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            extensionRange?: {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            oneofDecl?: {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[] & ({
            name?: string | undefined;
            field?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            nestedType?: any[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            extensionRange?: {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            oneofDecl?: {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        } & {
            name?: string | undefined;
            field?: ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] & ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            } & {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: ({
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_3 in Exclude<keyof I["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_4 in Exclude<keyof I["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_5 in Exclude<keyof I["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_6 in Exclude<keyof I["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_7 in Exclude<keyof I["messageType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_8 in Exclude<keyof I["messageType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_9 in Exclude<keyof I["messageType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                proto3Optional?: boolean | undefined;
            } & { [K_10 in Exclude<keyof I["messageType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_11 in Exclude<keyof I["messageType"][number]["field"], keyof {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[]>]: never; }) | undefined;
            extension?: ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] & ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            } & {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: ({
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_12 in Exclude<keyof I["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_13 in Exclude<keyof I["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_14 in Exclude<keyof I["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_15 in Exclude<keyof I["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_16 in Exclude<keyof I["messageType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_17 in Exclude<keyof I["messageType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_18 in Exclude<keyof I["messageType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                proto3Optional?: boolean | undefined;
            } & { [K_19 in Exclude<keyof I["messageType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_20 in Exclude<keyof I["messageType"][number]["extension"], keyof {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[]>]: never; }) | undefined;
            nestedType?: ({
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] & ({
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            } & {
                name?: string | undefined;
                field?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: ({
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_21 in Exclude<keyof I["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_22 in Exclude<keyof I["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_23 in Exclude<keyof I["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_24 in Exclude<keyof I["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_25 in Exclude<keyof I["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_26 in Exclude<keyof I["messageType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_27 in Exclude<keyof I["messageType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                    proto3Optional?: boolean | undefined;
                } & { [K_28 in Exclude<keyof I["messageType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_29 in Exclude<keyof I["messageType"][number]["nestedType"][number]["field"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[]>]: never; }) | undefined;
                extension?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: ({
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_30 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_31 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_32 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_33 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_34 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_35 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_36 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                    proto3Optional?: boolean | undefined;
                } & { [K_37 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_38 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extension"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[]>]: never; }) | undefined;
                nestedType?: ({
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] & ({
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                } & {
                    name?: string | undefined;
                    field?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: ({
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_39 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_40 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_41 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_42 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_43 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_44 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_45 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                        proto3Optional?: boolean | undefined;
                    } & { [K_46 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_47 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    extension?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: ({
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_48 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_49 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_50 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_51 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_52 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_53 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_54 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                        proto3Optional?: boolean | undefined;
                    } & { [K_55 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_56 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    nestedType?: ({
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] & ({
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    } & {
                        name?: string | undefined;
                        field?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: ({
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_57 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_58 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_59 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_60 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_61 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_62 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_63 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                            proto3Optional?: boolean | undefined;
                        } & { [K_64 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_65 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        extension?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: ({
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_66 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_67 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_68 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_69 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_70 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_71 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_72 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                            proto3Optional?: boolean | undefined;
                        } & { [K_73 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_74 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        nestedType?: ({
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] & ({
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        } & {
                            name?: string | undefined;
                            field?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: ({
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_75 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_76 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_77 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_78 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_79 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_80 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_81 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                proto3Optional?: boolean | undefined;
                            } & { [K_82 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_83 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            extension?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: ({
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_84 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_85 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_86 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_87 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_88 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_89 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_90 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                proto3Optional?: boolean | undefined;
                            } & { [K_91 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_92 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            nestedType?: ({
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] & ({
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            } & {
                                name?: string | undefined;
                                field?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: ({
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_93 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_94 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_95 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_96 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_97 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_98 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_99 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                    proto3Optional?: boolean | undefined;
                                } & { [K_100 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_101 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                extension?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: ({
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_102 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_103 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_104 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_105 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_106 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_107 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_108 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                    proto3Optional?: boolean | undefined;
                                } & { [K_109 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_110 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                nestedType?: ({
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                } & {
                                    name?: string | undefined;
                                    field?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: ({
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_111 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_112 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_113 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_114 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_115 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_116 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_117 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                        proto3Optional?: boolean | undefined;
                                    } & { [K_118 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_119 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    extension?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: ({
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_120 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_121 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_122 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_123 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_124 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_125 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_126 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                        proto3Optional?: boolean | undefined;
                                    } & { [K_127 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_128 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    nestedType?: ({
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    } & {
                                        name?: string | undefined;
                                        field?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: ({
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_129 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_130 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_131 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                            proto3Optional?: boolean | undefined;
                                        } & { [K_132 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_133 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        extension?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: ({
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_134 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_135 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_136 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                            proto3Optional?: boolean | undefined;
                                        } & { [K_137 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_138 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        nestedType?: ({
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        } & {
                                            name?: string | undefined;
                                            field?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: ({
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_139 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                                proto3Optional?: boolean | undefined;
                                            } & { [K_140 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_141 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            extension?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: ({
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_142 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                                proto3Optional?: boolean | undefined;
                                            } & { [K_143 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_144 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            nestedType?: ({
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            } & {
                                                name?: string | undefined;
                                                field?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                } & any & { [K_145 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_146 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                extension?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                } & any & { [K_147 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_148 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                nestedType?: ({
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                } & any & { [K_149 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_150 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[]>]: never; }) | undefined;
                                                enumType?: ({
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                } & any & { [K_151 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_152 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[]>]: never; }) | undefined;
                                                extensionRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & { [K_153 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_154 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>]: never; }) | undefined;
                                                oneofDecl?: ({
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & { [K_155 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_156 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>]: never; }) | undefined;
                                                options?: ({
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_157 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                                                reservedRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                } & any & { [K_158 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_159 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[]>]: never; }) | undefined;
                                                reservedName?: (string[] & string[] & { [K_160 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                            } & { [K_161 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_162 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[]>]: never; }) | undefined;
                                            enumType?: ({
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            } & {
                                                name?: string | undefined;
                                                value?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & { [K_163 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_164 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>]: never; }) | undefined;
                                                options?: ({
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_165 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                                                reservedRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                } & any & { [K_166 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_167 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[]>]: never; }) | undefined;
                                                reservedName?: (string[] & string[] & { [K_168 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                            } & { [K_169 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_170 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[]>]: never; }) | undefined;
                                            extensionRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: ({
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_171 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                            } & { [K_172 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_173 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>]: never; }) | undefined;
                                            oneofDecl?: ({
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                options?: ({
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_174 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                            } & { [K_175 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_176 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>]: never; }) | undefined;
                                            options?: ({
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_177 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_178 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_179 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                                            reservedRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & { [K_180 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_181 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[]>]: never; }) | undefined;
                                            reservedName?: (string[] & string[] & { [K_182 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                        } & { [K_183 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_184 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[]>]: never; }) | undefined;
                                        enumType?: ({
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        } & {
                                            name?: string | undefined;
                                            value?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: ({
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_185 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                                            } & { [K_186 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_187 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>]: never; }) | undefined;
                                            options?: ({
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_188 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_189 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_190 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                                            reservedRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & { [K_191 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_192 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[]>]: never; }) | undefined;
                                            reservedName?: (string[] & string[] & { [K_193 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                        } & { [K_194 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_195 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[]>]: never; }) | undefined;
                                        extensionRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: ({
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_196 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_197 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_198 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                        } & { [K_199 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_200 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>]: never; }) | undefined;
                                        oneofDecl?: ({
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            options?: ({
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_201 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_202 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_203 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                        } & { [K_204 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_205 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>]: never; }) | undefined;
                                        options?: ({
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_206 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_207 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_208 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_209 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_210 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_211 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_212 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                                        reservedRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & { [K_213 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_214 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[]>]: never; }) | undefined;
                                        reservedName?: (string[] & string[] & { [K_215 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                    } & { [K_216 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_217 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[]>]: never; }) | undefined;
                                    enumType?: ({
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    } & {
                                        name?: string | undefined;
                                        value?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: ({
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_218 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_219 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_220 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                                        } & { [K_221 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_222 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>]: never; }) | undefined;
                                        options?: ({
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_223 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_224 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_225 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_226 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_227 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_228 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_229 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                                        reservedRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & { [K_230 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_231 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[]>]: never; }) | undefined;
                                        reservedName?: (string[] & string[] & { [K_232 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                    } & { [K_233 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_234 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[]>]: never; }) | undefined;
                                    extensionRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: ({
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_235 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_236 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_237 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_238 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_239 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_240 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_241 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                    } & { [K_242 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_243 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>]: never; }) | undefined;
                                    oneofDecl?: ({
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        options?: ({
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_244 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_245 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_246 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_247 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_248 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_249 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_250 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                    } & { [K_251 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_252 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>]: never; }) | undefined;
                                    options?: ({
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_253 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_254 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_255 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_256 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_257 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_258 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_259 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                                    reservedRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & { [K_260 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_261 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[]>]: never; }) | undefined;
                                    reservedName?: (string[] & string[] & { [K_262 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                } & { [K_263 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_264 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[]>]: never; }) | undefined;
                                enumType?: ({
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                } & {
                                    name?: string | undefined;
                                    value?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: ({
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_265 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_266 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_267 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_268 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_269 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_270 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_271 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                                    } & { [K_272 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_273 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>]: never; }) | undefined;
                                    options?: ({
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_274 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_275 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_276 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_277 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_278 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_279 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_280 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                                    reservedRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & { [K_281 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_282 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[]>]: never; }) | undefined;
                                    reservedName?: (string[] & string[] & { [K_283 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                } & { [K_284 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_285 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[]>]: never; }) | undefined;
                                extensionRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: ({
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_286 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_287 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_288 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_289 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_290 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_291 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_292 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                } & { [K_293 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_294 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>]: never; }) | undefined;
                                oneofDecl?: ({
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    options?: ({
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_295 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_296 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_297 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_298 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_299 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_300 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_301 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                } & { [K_302 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_303 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>]: never; }) | undefined;
                                options?: ({
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_304 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_305 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_306 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_307 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_308 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_309 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_310 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                                reservedRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & { [K_311 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_312 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[]>]: never; }) | undefined;
                                reservedName?: (string[] & string[] & { [K_313 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                            } & { [K_314 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_315 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[]>]: never; }) | undefined;
                            enumType?: ({
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] & ({
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            } & {
                                name?: string | undefined;
                                value?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: ({
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_316 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_317 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_318 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_319 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_320 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_321 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_322 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                                } & { [K_323 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_324 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>]: never; }) | undefined;
                                options?: ({
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_325 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_326 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_327 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_328 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_329 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_330 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_331 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                                reservedRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & { [K_332 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_333 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[]>]: never; }) | undefined;
                                reservedName?: (string[] & string[] & { [K_334 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                            } & { [K_335 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_336 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[]>]: never; }) | undefined;
                            extensionRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: ({
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_337 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_338 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_339 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_340 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_341 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_342 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_343 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                            } & { [K_344 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_345 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>]: never; }) | undefined;
                            oneofDecl?: ({
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                options?: ({
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_346 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_347 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_348 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_349 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_350 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_351 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_352 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                            } & { [K_353 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_354 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>]: never; }) | undefined;
                            options?: ({
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_355 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_356 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_357 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_358 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_359 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_360 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_361 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                            reservedRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                            } & { [K_362 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_363 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[]>]: never; }) | undefined;
                            reservedName?: (string[] & string[] & { [K_364 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                        } & { [K_365 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_366 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[]>]: never; }) | undefined;
                        enumType?: ({
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] & ({
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        } & {
                            name?: string | undefined;
                            value?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: ({
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_367 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_368 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_369 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_370 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_371 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_372 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_373 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                            } & { [K_374 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_375 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>]: never; }) | undefined;
                            options?: ({
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_376 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_377 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_378 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_379 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_380 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_381 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_382 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                            reservedRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                            } & { [K_383 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_384 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[]>]: never; }) | undefined;
                            reservedName?: (string[] & string[] & { [K_385 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                        } & { [K_386 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_387 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[]>]: never; }) | undefined;
                        extensionRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: ({
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_388 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_389 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_390 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_391 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_392 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_393 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_394 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                        } & { [K_395 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_396 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>]: never; }) | undefined;
                        oneofDecl?: ({
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            options?: ({
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_397 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_398 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_399 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_400 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_401 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_402 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_403 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                        } & { [K_404 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_405 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>]: never; }) | undefined;
                        options?: ({
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_406 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_407 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_408 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_409 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_410 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_411 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_412 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                        reservedRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                        } & { [K_413 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_414 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[]>]: never; }) | undefined;
                        reservedName?: (string[] & string[] & { [K_415 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                    } & { [K_416 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_417 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[]>]: never; }) | undefined;
                    enumType?: ({
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] & ({
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    } & {
                        name?: string | undefined;
                        value?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: ({
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_418 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_419 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_420 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_421 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_422 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_423 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_424 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                        } & { [K_425 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_426 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>]: never; }) | undefined;
                        options?: ({
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_427 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_428 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_429 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_430 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_431 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_432 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_433 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                        reservedRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                        } & { [K_434 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_435 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[]>]: never; }) | undefined;
                        reservedName?: (string[] & string[] & { [K_436 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                    } & { [K_437 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_438 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[]>]: never; }) | undefined;
                    extensionRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: ({
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_439 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_440 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_441 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_442 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_443 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_444 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_445 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                    } & { [K_446 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_447 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>]: never; }) | undefined;
                    oneofDecl?: ({
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        options?: ({
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_448 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_449 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_450 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_451 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_452 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_453 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_454 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                    } & { [K_455 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_456 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>]: never; }) | undefined;
                    options?: ({
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_457 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_458 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_459 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_460 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_461 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_462 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_463 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                    reservedRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                    } & { [K_464 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_465 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[]>]: never; }) | undefined;
                    reservedName?: (string[] & string[] & { [K_466 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                } & { [K_467 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_468 in Exclude<keyof I["messageType"][number]["nestedType"][number]["nestedType"], keyof {
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[]>]: never; }) | undefined;
                enumType?: ({
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] & ({
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                } & {
                    name?: string | undefined;
                    value?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: ({
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_469 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_470 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_471 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_472 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_473 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_474 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_475 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                    } & { [K_476 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_477 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>]: never; }) | undefined;
                    options?: ({
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_478 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_479 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_480 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_481 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_482 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_483 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_484 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                    reservedRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                    } & { [K_485 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_486 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[]>]: never; }) | undefined;
                    reservedName?: (string[] & string[] & { [K_487 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                } & { [K_488 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_489 in Exclude<keyof I["messageType"][number]["nestedType"][number]["enumType"], keyof {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[]>]: never; }) | undefined;
                extensionRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: ({
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_490 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_491 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_492 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_493 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_494 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_495 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_496 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                } & { [K_497 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_498 in Exclude<keyof I["messageType"][number]["nestedType"][number]["extensionRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>]: never; }) | undefined;
                oneofDecl?: ({
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    options?: ({
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_499 in Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_500 in Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_501 in Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_502 in Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_503 in Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_504 in Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_505 in Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                } & { [K_506 in Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_507 in Exclude<keyof I["messageType"][number]["nestedType"][number]["oneofDecl"], keyof {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>]: never; }) | undefined;
                options?: ({
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_508 in Exclude<keyof I["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_509 in Exclude<keyof I["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_510 in Exclude<keyof I["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_511 in Exclude<keyof I["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_512 in Exclude<keyof I["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_513 in Exclude<keyof I["messageType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_514 in Exclude<keyof I["messageType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                reservedRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                } & { [K_515 in Exclude<keyof I["messageType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_516 in Exclude<keyof I["messageType"][number]["nestedType"][number]["reservedRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                }[]>]: never; }) | undefined;
                reservedName?: (string[] & string[] & { [K_517 in Exclude<keyof I["messageType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
            } & { [K_518 in Exclude<keyof I["messageType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_519 in Exclude<keyof I["messageType"][number]["nestedType"], keyof {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[]>]: never; }) | undefined;
            enumType?: ({
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] & ({
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            } & {
                name?: string | undefined;
                value?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: ({
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_520 in Exclude<keyof I["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_521 in Exclude<keyof I["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_522 in Exclude<keyof I["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_523 in Exclude<keyof I["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_524 in Exclude<keyof I["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_525 in Exclude<keyof I["messageType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_526 in Exclude<keyof I["messageType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                } & { [K_527 in Exclude<keyof I["messageType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_528 in Exclude<keyof I["messageType"][number]["enumType"][number]["value"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>]: never; }) | undefined;
                options?: ({
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_529 in Exclude<keyof I["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_530 in Exclude<keyof I["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_531 in Exclude<keyof I["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_532 in Exclude<keyof I["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_533 in Exclude<keyof I["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_534 in Exclude<keyof I["messageType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_535 in Exclude<keyof I["messageType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                reservedRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                } & { [K_536 in Exclude<keyof I["messageType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_537 in Exclude<keyof I["messageType"][number]["enumType"][number]["reservedRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                }[]>]: never; }) | undefined;
                reservedName?: (string[] & string[] & { [K_538 in Exclude<keyof I["messageType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
            } & { [K_539 in Exclude<keyof I["messageType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_540 in Exclude<keyof I["messageType"][number]["enumType"], keyof {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[]>]: never; }) | undefined;
            extensionRange?: ({
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                start?: number | undefined;
                end?: number | undefined;
                options?: ({
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_541 in Exclude<keyof I["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_542 in Exclude<keyof I["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_543 in Exclude<keyof I["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_544 in Exclude<keyof I["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_545 in Exclude<keyof I["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_546 in Exclude<keyof I["messageType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_547 in Exclude<keyof I["messageType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
            } & { [K_548 in Exclude<keyof I["messageType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_549 in Exclude<keyof I["messageType"][number]["extensionRange"], keyof {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>]: never; }) | undefined;
            oneofDecl?: ({
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                options?: ({
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_550 in Exclude<keyof I["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_551 in Exclude<keyof I["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_552 in Exclude<keyof I["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_553 in Exclude<keyof I["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_554 in Exclude<keyof I["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_555 in Exclude<keyof I["messageType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_556 in Exclude<keyof I["messageType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
            } & { [K_557 in Exclude<keyof I["messageType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_558 in Exclude<keyof I["messageType"][number]["oneofDecl"], keyof {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>]: never; }) | undefined;
            options?: ({
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & { [K_559 in Exclude<keyof I["messageType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_560 in Exclude<keyof I["messageType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_561 in Exclude<keyof I["messageType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                    negativeIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_562 in Exclude<keyof I["messageType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & { [K_563 in Exclude<keyof I["messageType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_564 in Exclude<keyof I["messageType"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>]: never; }) | undefined;
            } & { [K_565 in Exclude<keyof I["messageType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
            reservedRange?: ({
                start?: number | undefined;
                end?: number | undefined;
            }[] & ({
                start?: number | undefined;
                end?: number | undefined;
            } & {
                start?: number | undefined;
                end?: number | undefined;
            } & { [K_566 in Exclude<keyof I["messageType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_567 in Exclude<keyof I["messageType"][number]["reservedRange"], keyof {
                start?: number | undefined;
                end?: number | undefined;
            }[]>]: never; }) | undefined;
            reservedName?: (string[] & string[] & { [K_568 in Exclude<keyof I["messageType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
        } & { [K_569 in Exclude<keyof I["messageType"][number], keyof DescriptorProto>]: never; })[] & { [K_570 in Exclude<keyof I["messageType"], keyof {
            name?: string | undefined;
            field?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            nestedType?: any[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            extensionRange?: {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            oneofDecl?: {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[]>]: never; }) | undefined;
        enumType?: ({
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[] & ({
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        } & {
            name?: string | undefined;
            value?: ({
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                number?: number | undefined;
                options?: ({
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_571 in Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_572 in Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_573 in Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_574 in Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_575 in Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_576 in Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_577 in Exclude<keyof I["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
            } & { [K_578 in Exclude<keyof I["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_579 in Exclude<keyof I["enumType"][number]["value"], keyof {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>]: never; }) | undefined;
            options?: ({
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & { [K_580 in Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_581 in Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_582 in Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                    negativeIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_583 in Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & { [K_584 in Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_585 in Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>]: never; }) | undefined;
            } & { [K_586 in Exclude<keyof I["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
            reservedRange?: ({
                start?: number | undefined;
                end?: number | undefined;
            }[] & ({
                start?: number | undefined;
                end?: number | undefined;
            } & {
                start?: number | undefined;
                end?: number | undefined;
            } & { [K_587 in Exclude<keyof I["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_588 in Exclude<keyof I["enumType"][number]["reservedRange"], keyof {
                start?: number | undefined;
                end?: number | undefined;
            }[]>]: never; }) | undefined;
            reservedName?: (string[] & string[] & { [K_589 in Exclude<keyof I["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
        } & { [K_590 in Exclude<keyof I["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_591 in Exclude<keyof I["enumType"], keyof {
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[]>]: never; }) | undefined;
        service?: ({
            name?: string | undefined;
            method?: {
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            }[] | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] & ({
            name?: string | undefined;
            method?: {
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            }[] | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        } & {
            name?: string | undefined;
            method?: ({
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            }[] & ({
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            } & {
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: ({
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_592 in Exclude<keyof I["service"][number]["method"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_593 in Exclude<keyof I["service"][number]["method"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_594 in Exclude<keyof I["service"][number]["method"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_595 in Exclude<keyof I["service"][number]["method"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_596 in Exclude<keyof I["service"][number]["method"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_597 in Exclude<keyof I["service"][number]["method"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_598 in Exclude<keyof I["service"][number]["method"][number]["options"], keyof MethodOptions>]: never; }) | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            } & { [K_599 in Exclude<keyof I["service"][number]["method"][number], keyof MethodDescriptorProto>]: never; })[] & { [K_600 in Exclude<keyof I["service"][number]["method"], keyof {
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            }[]>]: never; }) | undefined;
            options?: ({
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                deprecated?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & { [K_601 in Exclude<keyof I["service"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_602 in Exclude<keyof I["service"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_603 in Exclude<keyof I["service"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                    negativeIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_604 in Exclude<keyof I["service"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & { [K_605 in Exclude<keyof I["service"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_606 in Exclude<keyof I["service"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>]: never; }) | undefined;
            } & { [K_607 in Exclude<keyof I["service"][number]["options"], keyof ServiceOptions>]: never; }) | undefined;
        } & { [K_608 in Exclude<keyof I["service"][number], keyof ServiceDescriptorProto>]: never; })[] & { [K_609 in Exclude<keyof I["service"], keyof {
            name?: string | undefined;
            method?: {
                name?: string | undefined;
                inputType?: string | undefined;
                outputType?: string | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                clientStreaming?: boolean | undefined;
                serverStreaming?: boolean | undefined;
            }[] | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[]>]: never; }) | undefined;
        extension?: ({
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            proto3Optional?: boolean | undefined;
        }[] & ({
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            proto3Optional?: boolean | undefined;
        } & {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: ({
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & { [K_610 in Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_611 in Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_612 in Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                    negativeIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_613 in Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & { [K_614 in Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_615 in Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>]: never; }) | undefined;
            } & { [K_616 in Exclude<keyof I["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
            proto3Optional?: boolean | undefined;
        } & { [K_617 in Exclude<keyof I["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_618 in Exclude<keyof I["extension"], keyof {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            proto3Optional?: boolean | undefined;
        }[]>]: never; }) | undefined;
        options?: ({
            javaPackage?: string | undefined;
            javaOuterClassname?: string | undefined;
            javaMultipleFiles?: boolean | undefined;
            javaGenerateEqualsAndHash?: boolean | undefined;
            javaStringCheckUtf8?: boolean | undefined;
            optimizeFor?: FileOptions_OptimizeMode | undefined;
            goPackage?: string | undefined;
            ccGenericServices?: boolean | undefined;
            javaGenericServices?: boolean | undefined;
            pyGenericServices?: boolean | undefined;
            phpGenericServices?: boolean | undefined;
            deprecated?: boolean | undefined;
            ccEnableArenas?: boolean | undefined;
            objcClassPrefix?: string | undefined;
            csharpNamespace?: string | undefined;
            swiftPrefix?: string | undefined;
            phpClassPrefix?: string | undefined;
            phpNamespace?: string | undefined;
            phpMetadataNamespace?: string | undefined;
            rubyPackage?: string | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            javaPackage?: string | undefined;
            javaOuterClassname?: string | undefined;
            javaMultipleFiles?: boolean | undefined;
            javaGenerateEqualsAndHash?: boolean | undefined;
            javaStringCheckUtf8?: boolean | undefined;
            optimizeFor?: FileOptions_OptimizeMode | undefined;
            goPackage?: string | undefined;
            ccGenericServices?: boolean | undefined;
            javaGenericServices?: boolean | undefined;
            pyGenericServices?: boolean | undefined;
            phpGenericServices?: boolean | undefined;
            deprecated?: boolean | undefined;
            ccEnableArenas?: boolean | undefined;
            objcClassPrefix?: string | undefined;
            csharpNamespace?: string | undefined;
            swiftPrefix?: string | undefined;
            phpClassPrefix?: string | undefined;
            phpNamespace?: string | undefined;
            phpMetadataNamespace?: string | undefined;
            rubyPackage?: string | undefined;
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & { [K_619 in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_620 in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>]: never; }) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_621 in Exclude<keyof I["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                negativeIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_622 in Exclude<keyof I["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & { [K_623 in Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_624 in Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>]: never; }) | undefined;
        } & { [K_625 in Exclude<keyof I["options"], keyof FileOptions>]: never; }) | undefined;
        sourceCodeInfo?: ({
            location?: {
                path?: number[] | undefined;
                span?: number[] | undefined;
                leadingComments?: string | undefined;
                trailingComments?: string | undefined;
                leadingDetachedComments?: string[] | undefined;
            }[] | undefined;
        } & {
            location?: ({
                path?: number[] | undefined;
                span?: number[] | undefined;
                leadingComments?: string | undefined;
                trailingComments?: string | undefined;
                leadingDetachedComments?: string[] | undefined;
            }[] & ({
                path?: number[] | undefined;
                span?: number[] | undefined;
                leadingComments?: string | undefined;
                trailingComments?: string | undefined;
                leadingDetachedComments?: string[] | undefined;
            } & {
                path?: (number[] & number[] & { [K_626 in Exclude<keyof I["sourceCodeInfo"]["location"][number]["path"], keyof number[]>]: never; }) | undefined;
                span?: (number[] & number[] & { [K_627 in Exclude<keyof I["sourceCodeInfo"]["location"][number]["span"], keyof number[]>]: never; }) | undefined;
                leadingComments?: string | undefined;
                trailingComments?: string | undefined;
                leadingDetachedComments?: (string[] & string[] & { [K_628 in Exclude<keyof I["sourceCodeInfo"]["location"][number]["leadingDetachedComments"], keyof string[]>]: never; }) | undefined;
            } & { [K_629 in Exclude<keyof I["sourceCodeInfo"]["location"][number], keyof SourceCodeInfo_Location>]: never; })[] & { [K_630 in Exclude<keyof I["sourceCodeInfo"]["location"], keyof {
                path?: number[] | undefined;
                span?: number[] | undefined;
                leadingComments?: string | undefined;
                trailingComments?: string | undefined;
                leadingDetachedComments?: string[] | undefined;
            }[]>]: never; }) | undefined;
        } & { [K_631 in Exclude<keyof I["sourceCodeInfo"], "location">]: never; }) | undefined;
        syntax?: string | undefined;
    } & { [K_632 in Exclude<keyof I, keyof FileDescriptorProto>]: never; }>(object: I): FileDescriptorProto;
};
export declare const DescriptorProto: {
    encode(message: DescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): DescriptorProto;
    fromJSON(object: any): DescriptorProto;
    toJSON(message: DescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        field?: {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            proto3Optional?: boolean | undefined;
        }[] | undefined;
        extension?: {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            proto3Optional?: boolean | undefined;
        }[] | undefined;
        nestedType?: any[] | undefined;
        enumType?: {
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[] | undefined;
        extensionRange?: {
            start?: number | undefined;
            end?: number | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] | undefined;
        oneofDecl?: {
            name?: string | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] | undefined;
        options?: {
            messageSetWireFormat?: boolean | undefined;
            noStandardDescriptorAccessor?: boolean | undefined;
            deprecated?: boolean | undefined;
            mapEntry?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
        reservedRange?: {
            start?: number | undefined;
            end?: number | undefined;
        }[] | undefined;
        reservedName?: string[] | undefined;
    } & {
        name?: string | undefined;
        field?: ({
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            proto3Optional?: boolean | undefined;
        }[] & ({
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            proto3Optional?: boolean | undefined;
        } & {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: ({
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & { [K in Exclude<keyof I["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_2 in Exclude<keyof I["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                    negativeIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_3 in Exclude<keyof I["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & { [K_4 in Exclude<keyof I["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["field"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>]: never; }) | undefined;
            } & { [K_6 in Exclude<keyof I["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
            proto3Optional?: boolean | undefined;
        } & { [K_7 in Exclude<keyof I["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_8 in Exclude<keyof I["field"], keyof {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            proto3Optional?: boolean | undefined;
        }[]>]: never; }) | undefined;
        extension?: ({
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            proto3Optional?: boolean | undefined;
        }[] & ({
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            proto3Optional?: boolean | undefined;
        } & {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: ({
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & { [K_9 in Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_10 in Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_11 in Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                    negativeIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_12 in Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & { [K_13 in Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_14 in Exclude<keyof I["extension"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>]: never; }) | undefined;
            } & { [K_15 in Exclude<keyof I["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
            proto3Optional?: boolean | undefined;
        } & { [K_16 in Exclude<keyof I["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_17 in Exclude<keyof I["extension"], keyof {
            name?: string | undefined;
            number?: number | undefined;
            label?: FieldDescriptorProto_Label | undefined;
            type?: FieldDescriptorProto_Type | undefined;
            typeName?: string | undefined;
            extendee?: string | undefined;
            defaultValue?: string | undefined;
            oneofIndex?: number | undefined;
            jsonName?: string | undefined;
            options?: {
                ctype?: FieldOptions_CType | undefined;
                packed?: boolean | undefined;
                jstype?: FieldOptions_JSType | undefined;
                lazy?: boolean | undefined;
                unverifiedLazy?: boolean | undefined;
                deprecated?: boolean | undefined;
                weak?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            proto3Optional?: boolean | undefined;
        }[]>]: never; }) | undefined;
        nestedType?: ({
            name?: string | undefined;
            field?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            nestedType?: any[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            extensionRange?: {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            oneofDecl?: {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[] & ({
            name?: string | undefined;
            field?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            nestedType?: any[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            extensionRange?: {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            oneofDecl?: {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        } & {
            name?: string | undefined;
            field?: ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] & ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            } & {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: ({
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_18 in Exclude<keyof I["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_19 in Exclude<keyof I["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_20 in Exclude<keyof I["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_21 in Exclude<keyof I["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_22 in Exclude<keyof I["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_23 in Exclude<keyof I["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_24 in Exclude<keyof I["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                proto3Optional?: boolean | undefined;
            } & { [K_25 in Exclude<keyof I["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_26 in Exclude<keyof I["nestedType"][number]["field"], keyof {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[]>]: never; }) | undefined;
            extension?: ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] & ({
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            } & {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: ({
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_27 in Exclude<keyof I["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_28 in Exclude<keyof I["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_29 in Exclude<keyof I["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_30 in Exclude<keyof I["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_31 in Exclude<keyof I["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_32 in Exclude<keyof I["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_33 in Exclude<keyof I["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                proto3Optional?: boolean | undefined;
            } & { [K_34 in Exclude<keyof I["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_35 in Exclude<keyof I["nestedType"][number]["extension"], keyof {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[]>]: never; }) | undefined;
            nestedType?: ({
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] & ({
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            } & {
                name?: string | undefined;
                field?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: ({
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_36 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_37 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_38 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_39 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_40 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_41 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_42 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                    proto3Optional?: boolean | undefined;
                } & { [K_43 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_44 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["field"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[]>]: never; }) | undefined;
                extension?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: ({
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_45 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_46 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_47 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_48 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_49 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_50 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_51 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                    proto3Optional?: boolean | undefined;
                } & { [K_52 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_53 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extension"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[]>]: never; }) | undefined;
                nestedType?: ({
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] & ({
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                } & {
                    name?: string | undefined;
                    field?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: ({
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_54 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_55 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_56 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_57 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_58 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_59 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_60 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                        proto3Optional?: boolean | undefined;
                    } & { [K_61 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_62 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    extension?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: ({
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_63 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_64 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_65 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_66 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_67 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_68 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_69 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                        proto3Optional?: boolean | undefined;
                    } & { [K_70 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_71 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    nestedType?: ({
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] & ({
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    } & {
                        name?: string | undefined;
                        field?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: ({
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_72 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_73 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_74 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_75 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_76 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_77 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_78 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                            proto3Optional?: boolean | undefined;
                        } & { [K_79 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_80 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        extension?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: ({
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_81 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_82 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_83 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_84 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_85 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_86 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_87 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                            proto3Optional?: boolean | undefined;
                        } & { [K_88 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_89 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        nestedType?: ({
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] & ({
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        } & {
                            name?: string | undefined;
                            field?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: ({
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_90 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_91 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_92 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_93 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_94 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_95 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_96 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                proto3Optional?: boolean | undefined;
                            } & { [K_97 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_98 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            extension?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: ({
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_99 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_100 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_101 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_102 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_103 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_104 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_105 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                proto3Optional?: boolean | undefined;
                            } & { [K_106 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_107 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            nestedType?: ({
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] & ({
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            } & {
                                name?: string | undefined;
                                field?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: ({
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_108 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_109 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_110 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_111 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_112 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_113 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_114 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                    proto3Optional?: boolean | undefined;
                                } & { [K_115 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_116 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                extension?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: ({
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_117 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_118 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_119 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_120 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_121 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_122 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_123 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                    proto3Optional?: boolean | undefined;
                                } & { [K_124 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_125 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                nestedType?: ({
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                } & {
                                    name?: string | undefined;
                                    field?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: ({
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_126 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_127 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_128 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_129 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_130 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_131 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_132 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                        proto3Optional?: boolean | undefined;
                                    } & { [K_133 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_134 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    extension?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: ({
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_135 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_136 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_137 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_138 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_139 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_140 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_141 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                        proto3Optional?: boolean | undefined;
                                    } & { [K_142 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_143 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    nestedType?: ({
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    } & {
                                        name?: string | undefined;
                                        field?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: ({
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_144 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_145 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_146 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                            proto3Optional?: boolean | undefined;
                                        } & { [K_147 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_148 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        extension?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: ({
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_149 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_150 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_151 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                            proto3Optional?: boolean | undefined;
                                        } & { [K_152 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_153 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        nestedType?: ({
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        } & {
                                            name?: string | undefined;
                                            field?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: ({
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_154 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                                proto3Optional?: boolean | undefined;
                                            } & { [K_155 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_156 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            extension?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: ({
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_157 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number]["options"], keyof FieldOptions>]: never; }) | undefined;
                                                proto3Optional?: boolean | undefined;
                                            } & { [K_158 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_159 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            nestedType?: ({
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            } & {
                                                name?: string | undefined;
                                                field?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                } & any & { [K_160 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_161 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["field"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                extension?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                } & any & { [K_162 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"][number], keyof FieldDescriptorProto>]: never; })[] & { [K_163 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extension"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                nestedType?: ({
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                } & any & { [K_164 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_165 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                                    name?: string | undefined;
                                                    field?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    extension?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        label?: FieldDescriptorProto_Label | undefined;
                                                        type?: FieldDescriptorProto_Type | undefined;
                                                        typeName?: string | undefined;
                                                        extendee?: string | undefined;
                                                        defaultValue?: string | undefined;
                                                        oneofIndex?: number | undefined;
                                                        jsonName?: string | undefined;
                                                        options?: {
                                                            ctype?: FieldOptions_CType | undefined;
                                                            packed?: boolean | undefined;
                                                            jstype?: FieldOptions_JSType | undefined;
                                                            lazy?: boolean | undefined;
                                                            unverifiedLazy?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            weak?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        proto3Optional?: boolean | undefined;
                                                    }[] | undefined;
                                                    nestedType?: any[] | undefined;
                                                    enumType?: {
                                                        name?: string | undefined;
                                                        value?: {
                                                            name?: string | undefined;
                                                            number?: number | undefined;
                                                            options?: {
                                                                deprecated?: boolean | undefined;
                                                                uninterpretedOption?: {
                                                                    name?: {
                                                                        namePart?: string | undefined;
                                                                        isExtension?: boolean | undefined;
                                                                    }[] | undefined;
                                                                    identifierValue?: string | undefined;
                                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                                    doubleValue?: number | undefined;
                                                                    stringValue?: Uint8Array | undefined;
                                                                    aggregateValue?: string | undefined;
                                                                }[] | undefined;
                                                            } | undefined;
                                                        }[] | undefined;
                                                        options?: {
                                                            allowAlias?: boolean | undefined;
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                        reservedRange?: {
                                                            start?: number | undefined;
                                                            end?: number | undefined;
                                                        }[] | undefined;
                                                        reservedName?: string[] | undefined;
                                                    }[] | undefined;
                                                    extensionRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    oneofDecl?: {
                                                        name?: string | undefined;
                                                        options?: {
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        messageSetWireFormat?: boolean | undefined;
                                                        noStandardDescriptorAccessor?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        mapEntry?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[]>]: never; }) | undefined;
                                                enumType?: ({
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                } & any & { [K_166 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_167 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[]>]: never; }) | undefined;
                                                extensionRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & { [K_168 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_169 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>]: never; }) | undefined;
                                                oneofDecl?: ({
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & { [K_170 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_171 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>]: never; }) | undefined;
                                                options?: ({
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_172 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                                                reservedRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                } & any & { [K_173 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_174 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[]>]: never; }) | undefined;
                                                reservedName?: (string[] & string[] & { [K_175 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                            } & { [K_176 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_177 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                                name?: string | undefined;
                                                field?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                extension?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    label?: FieldDescriptorProto_Label | undefined;
                                                    type?: FieldDescriptorProto_Type | undefined;
                                                    typeName?: string | undefined;
                                                    extendee?: string | undefined;
                                                    defaultValue?: string | undefined;
                                                    oneofIndex?: number | undefined;
                                                    jsonName?: string | undefined;
                                                    options?: {
                                                        ctype?: FieldOptions_CType | undefined;
                                                        packed?: boolean | undefined;
                                                        jstype?: FieldOptions_JSType | undefined;
                                                        lazy?: boolean | undefined;
                                                        unverifiedLazy?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        weak?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    proto3Optional?: boolean | undefined;
                                                }[] | undefined;
                                                nestedType?: any[] | undefined;
                                                enumType?: {
                                                    name?: string | undefined;
                                                    value?: {
                                                        name?: string | undefined;
                                                        number?: number | undefined;
                                                        options?: {
                                                            deprecated?: boolean | undefined;
                                                            uninterpretedOption?: {
                                                                name?: {
                                                                    namePart?: string | undefined;
                                                                    isExtension?: boolean | undefined;
                                                                }[] | undefined;
                                                                identifierValue?: string | undefined;
                                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                                doubleValue?: number | undefined;
                                                                stringValue?: Uint8Array | undefined;
                                                                aggregateValue?: string | undefined;
                                                            }[] | undefined;
                                                        } | undefined;
                                                    }[] | undefined;
                                                    options?: {
                                                        allowAlias?: boolean | undefined;
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                    reservedRange?: {
                                                        start?: number | undefined;
                                                        end?: number | undefined;
                                                    }[] | undefined;
                                                    reservedName?: string[] | undefined;
                                                }[] | undefined;
                                                extensionRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                oneofDecl?: {
                                                    name?: string | undefined;
                                                    options?: {
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    messageSetWireFormat?: boolean | undefined;
                                                    noStandardDescriptorAccessor?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    mapEntry?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[]>]: never; }) | undefined;
                                            enumType?: ({
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            } & {
                                                name?: string | undefined;
                                                value?: ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] & ({
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                } & any & { [K_178 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_179 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[]>]: never; }) | undefined;
                                                options?: ({
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_180 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                                                reservedRange?: ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] & ({
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                } & any & { [K_181 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_182 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[]>]: never; }) | undefined;
                                                reservedName?: (string[] & string[] & { [K_183 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                            } & { [K_184 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_185 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[]>]: never; }) | undefined;
                                            extensionRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: ({
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_186 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                            } & { [K_187 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_188 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>]: never; }) | undefined;
                                            oneofDecl?: ({
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                options?: ({
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_189 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                            } & { [K_190 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_191 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>]: never; }) | undefined;
                                            options?: ({
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_192 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_193 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_194 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                                            reservedRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & { [K_195 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_196 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[]>]: never; }) | undefined;
                                            reservedName?: (string[] & string[] & { [K_197 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                        } & { [K_198 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_199 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                            name?: string | undefined;
                                            field?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            extension?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                label?: FieldDescriptorProto_Label | undefined;
                                                type?: FieldDescriptorProto_Type | undefined;
                                                typeName?: string | undefined;
                                                extendee?: string | undefined;
                                                defaultValue?: string | undefined;
                                                oneofIndex?: number | undefined;
                                                jsonName?: string | undefined;
                                                options?: {
                                                    ctype?: FieldOptions_CType | undefined;
                                                    packed?: boolean | undefined;
                                                    jstype?: FieldOptions_JSType | undefined;
                                                    lazy?: boolean | undefined;
                                                    unverifiedLazy?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    weak?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                proto3Optional?: boolean | undefined;
                                            }[] | undefined;
                                            nestedType?: any[] | undefined;
                                            enumType?: {
                                                name?: string | undefined;
                                                value?: {
                                                    name?: string | undefined;
                                                    number?: number | undefined;
                                                    options?: {
                                                        deprecated?: boolean | undefined;
                                                        uninterpretedOption?: {
                                                            name?: {
                                                                namePart?: string | undefined;
                                                                isExtension?: boolean | undefined;
                                                            }[] | undefined;
                                                            identifierValue?: string | undefined;
                                                            positiveIntValue?: string | number | Long.Long | undefined;
                                                            negativeIntValue?: string | number | Long.Long | undefined;
                                                            doubleValue?: number | undefined;
                                                            stringValue?: Uint8Array | undefined;
                                                            aggregateValue?: string | undefined;
                                                        }[] | undefined;
                                                    } | undefined;
                                                }[] | undefined;
                                                options?: {
                                                    allowAlias?: boolean | undefined;
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                                reservedRange?: {
                                                    start?: number | undefined;
                                                    end?: number | undefined;
                                                }[] | undefined;
                                                reservedName?: string[] | undefined;
                                            }[] | undefined;
                                            extensionRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            oneofDecl?: {
                                                name?: string | undefined;
                                                options?: {
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                messageSetWireFormat?: boolean | undefined;
                                                noStandardDescriptorAccessor?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                mapEntry?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[]>]: never; }) | undefined;
                                        enumType?: ({
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        } & {
                                            name?: string | undefined;
                                            value?: ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] & ({
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            } & {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: ({
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } & any & { [K_200 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                                            } & { [K_201 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_202 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[]>]: never; }) | undefined;
                                            options?: ({
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_203 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_204 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_205 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                                            reservedRange?: ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] & ({
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            } & { [K_206 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_207 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[]>]: never; }) | undefined;
                                            reservedName?: (string[] & string[] & { [K_208 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                        } & { [K_209 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_210 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[]>]: never; }) | undefined;
                                        extensionRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: ({
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_211 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_212 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_213 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                        } & { [K_214 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_215 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>]: never; }) | undefined;
                                        oneofDecl?: ({
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            options?: ({
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_216 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_217 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_218 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                        } & { [K_219 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_220 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>]: never; }) | undefined;
                                        options?: ({
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_221 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_222 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_223 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_224 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_225 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_226 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_227 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                                        reservedRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & { [K_228 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_229 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[]>]: never; }) | undefined;
                                        reservedName?: (string[] & string[] & { [K_230 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                    } & { [K_231 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_232 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                        name?: string | undefined;
                                        field?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        extension?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            label?: FieldDescriptorProto_Label | undefined;
                                            type?: FieldDescriptorProto_Type | undefined;
                                            typeName?: string | undefined;
                                            extendee?: string | undefined;
                                            defaultValue?: string | undefined;
                                            oneofIndex?: number | undefined;
                                            jsonName?: string | undefined;
                                            options?: {
                                                ctype?: FieldOptions_CType | undefined;
                                                packed?: boolean | undefined;
                                                jstype?: FieldOptions_JSType | undefined;
                                                lazy?: boolean | undefined;
                                                unverifiedLazy?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                weak?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            proto3Optional?: boolean | undefined;
                                        }[] | undefined;
                                        nestedType?: any[] | undefined;
                                        enumType?: {
                                            name?: string | undefined;
                                            value?: {
                                                name?: string | undefined;
                                                number?: number | undefined;
                                                options?: {
                                                    deprecated?: boolean | undefined;
                                                    uninterpretedOption?: {
                                                        name?: {
                                                            namePart?: string | undefined;
                                                            isExtension?: boolean | undefined;
                                                        }[] | undefined;
                                                        identifierValue?: string | undefined;
                                                        positiveIntValue?: string | number | Long.Long | undefined;
                                                        negativeIntValue?: string | number | Long.Long | undefined;
                                                        doubleValue?: number | undefined;
                                                        stringValue?: Uint8Array | undefined;
                                                        aggregateValue?: string | undefined;
                                                    }[] | undefined;
                                                } | undefined;
                                            }[] | undefined;
                                            options?: {
                                                allowAlias?: boolean | undefined;
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                            reservedRange?: {
                                                start?: number | undefined;
                                                end?: number | undefined;
                                            }[] | undefined;
                                            reservedName?: string[] | undefined;
                                        }[] | undefined;
                                        extensionRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        oneofDecl?: {
                                            name?: string | undefined;
                                            options?: {
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            messageSetWireFormat?: boolean | undefined;
                                            noStandardDescriptorAccessor?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            mapEntry?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[]>]: never; }) | undefined;
                                    enumType?: ({
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    } & {
                                        name?: string | undefined;
                                        value?: ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] & ({
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        } & {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: ({
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } & {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] & ({
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                } & any & { [K_233 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_234 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[]>]: never; }) | undefined;
                                            } & { [K_235 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                                        } & { [K_236 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_237 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[]>]: never; }) | undefined;
                                        options?: ({
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_238 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_239 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_240 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_241 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_242 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_243 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_244 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                                        reservedRange?: ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] & ({
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        } & { [K_245 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_246 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[]>]: never; }) | undefined;
                                        reservedName?: (string[] & string[] & { [K_247 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                    } & { [K_248 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_249 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[]>]: never; }) | undefined;
                                    extensionRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: ({
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_250 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_251 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_252 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_253 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_254 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_255 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_256 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                    } & { [K_257 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_258 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>]: never; }) | undefined;
                                    oneofDecl?: ({
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        options?: ({
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_259 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_260 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_261 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_262 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_263 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_264 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_265 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                    } & { [K_266 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_267 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>]: never; }) | undefined;
                                    options?: ({
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_268 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_269 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_270 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_271 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_272 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_273 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_274 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                                    reservedRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & { [K_275 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_276 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[]>]: never; }) | undefined;
                                    reservedName?: (string[] & string[] & { [K_277 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                } & { [K_278 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_279 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                    name?: string | undefined;
                                    field?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    extension?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        label?: FieldDescriptorProto_Label | undefined;
                                        type?: FieldDescriptorProto_Type | undefined;
                                        typeName?: string | undefined;
                                        extendee?: string | undefined;
                                        defaultValue?: string | undefined;
                                        oneofIndex?: number | undefined;
                                        jsonName?: string | undefined;
                                        options?: {
                                            ctype?: FieldOptions_CType | undefined;
                                            packed?: boolean | undefined;
                                            jstype?: FieldOptions_JSType | undefined;
                                            lazy?: boolean | undefined;
                                            unverifiedLazy?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            weak?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        proto3Optional?: boolean | undefined;
                                    }[] | undefined;
                                    nestedType?: any[] | undefined;
                                    enumType?: {
                                        name?: string | undefined;
                                        value?: {
                                            name?: string | undefined;
                                            number?: number | undefined;
                                            options?: {
                                                deprecated?: boolean | undefined;
                                                uninterpretedOption?: {
                                                    name?: {
                                                        namePart?: string | undefined;
                                                        isExtension?: boolean | undefined;
                                                    }[] | undefined;
                                                    identifierValue?: string | undefined;
                                                    positiveIntValue?: string | number | Long.Long | undefined;
                                                    negativeIntValue?: string | number | Long.Long | undefined;
                                                    doubleValue?: number | undefined;
                                                    stringValue?: Uint8Array | undefined;
                                                    aggregateValue?: string | undefined;
                                                }[] | undefined;
                                            } | undefined;
                                        }[] | undefined;
                                        options?: {
                                            allowAlias?: boolean | undefined;
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                        reservedRange?: {
                                            start?: number | undefined;
                                            end?: number | undefined;
                                        }[] | undefined;
                                        reservedName?: string[] | undefined;
                                    }[] | undefined;
                                    extensionRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    oneofDecl?: {
                                        name?: string | undefined;
                                        options?: {
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        messageSetWireFormat?: boolean | undefined;
                                        noStandardDescriptorAccessor?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        mapEntry?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[]>]: never; }) | undefined;
                                enumType?: ({
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                } & {
                                    name?: string | undefined;
                                    value?: ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] & ({
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    } & {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: ({
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } & {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] & ({
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & {
                                                name?: ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] & ({
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                } & any & { [K_280 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_281 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[]>]: never; }) | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | (Long.Long & any & { [K_282 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                negativeIntValue?: string | number | (Long.Long & any & { [K_283 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            } & { [K_284 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_285 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[]>]: never; }) | undefined;
                                        } & { [K_286 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                                    } & { [K_287 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_288 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[]>]: never; }) | undefined;
                                    options?: ({
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_289 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_290 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_291 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_292 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_293 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_294 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_295 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                                    reservedRange?: ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] & ({
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    } & { [K_296 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_297 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[]>]: never; }) | undefined;
                                    reservedName?: (string[] & string[] & { [K_298 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                                } & { [K_299 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_300 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[]>]: never; }) | undefined;
                                extensionRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: ({
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_301 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_302 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_303 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_304 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_305 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_306 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_307 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                } & { [K_308 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_309 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>]: never; }) | undefined;
                                oneofDecl?: ({
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    options?: ({
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_310 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_311 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_312 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_313 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_314 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_315 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_316 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                                } & { [K_317 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_318 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>]: never; }) | undefined;
                                options?: ({
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_319 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_320 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_321 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_322 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_323 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_324 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_325 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                                reservedRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & { [K_326 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_327 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[]>]: never; }) | undefined;
                                reservedName?: (string[] & string[] & { [K_328 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                            } & { [K_329 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_330 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                                name?: string | undefined;
                                field?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                extension?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    label?: FieldDescriptorProto_Label | undefined;
                                    type?: FieldDescriptorProto_Type | undefined;
                                    typeName?: string | undefined;
                                    extendee?: string | undefined;
                                    defaultValue?: string | undefined;
                                    oneofIndex?: number | undefined;
                                    jsonName?: string | undefined;
                                    options?: {
                                        ctype?: FieldOptions_CType | undefined;
                                        packed?: boolean | undefined;
                                        jstype?: FieldOptions_JSType | undefined;
                                        lazy?: boolean | undefined;
                                        unverifiedLazy?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        weak?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    proto3Optional?: boolean | undefined;
                                }[] | undefined;
                                nestedType?: any[] | undefined;
                                enumType?: {
                                    name?: string | undefined;
                                    value?: {
                                        name?: string | undefined;
                                        number?: number | undefined;
                                        options?: {
                                            deprecated?: boolean | undefined;
                                            uninterpretedOption?: {
                                                name?: {
                                                    namePart?: string | undefined;
                                                    isExtension?: boolean | undefined;
                                                }[] | undefined;
                                                identifierValue?: string | undefined;
                                                positiveIntValue?: string | number | Long.Long | undefined;
                                                negativeIntValue?: string | number | Long.Long | undefined;
                                                doubleValue?: number | undefined;
                                                stringValue?: Uint8Array | undefined;
                                                aggregateValue?: string | undefined;
                                            }[] | undefined;
                                        } | undefined;
                                    }[] | undefined;
                                    options?: {
                                        allowAlias?: boolean | undefined;
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                    reservedRange?: {
                                        start?: number | undefined;
                                        end?: number | undefined;
                                    }[] | undefined;
                                    reservedName?: string[] | undefined;
                                }[] | undefined;
                                extensionRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                oneofDecl?: {
                                    name?: string | undefined;
                                    options?: {
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    messageSetWireFormat?: boolean | undefined;
                                    noStandardDescriptorAccessor?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    mapEntry?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[]>]: never; }) | undefined;
                            enumType?: ({
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] & ({
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            } & {
                                name?: string | undefined;
                                value?: ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] & ({
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                } & {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: ({
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } & {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] & ({
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & {
                                            name?: ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] & ({
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            } & { [K_331 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_332 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[]>]: never; }) | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_333 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            negativeIntValue?: string | number | (Long.Long & {
                                                high: number;
                                                low: number;
                                                unsigned: boolean;
                                                add: (addend: string | number | Long.Long) => Long.Long;
                                                and: (other: string | number | Long.Long) => Long.Long;
                                                compare: (other: string | number | Long.Long) => number;
                                                comp: (other: string | number | Long.Long) => number;
                                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                                div: (divisor: string | number | Long.Long) => Long.Long;
                                                equals: (other: string | number | Long.Long) => boolean;
                                                eq: (other: string | number | Long.Long) => boolean;
                                                getHighBits: () => number;
                                                getHighBitsUnsigned: () => number;
                                                getLowBits: () => number;
                                                getLowBitsUnsigned: () => number;
                                                getNumBitsAbs: () => number;
                                                greaterThan: (other: string | number | Long.Long) => boolean;
                                                gt: (other: string | number | Long.Long) => boolean;
                                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                gte: (other: string | number | Long.Long) => boolean;
                                                isEven: () => boolean;
                                                isNegative: () => boolean;
                                                isOdd: () => boolean;
                                                isPositive: () => boolean;
                                                isZero: () => boolean;
                                                lessThan: (other: string | number | Long.Long) => boolean;
                                                lt: (other: string | number | Long.Long) => boolean;
                                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                                lte: (other: string | number | Long.Long) => boolean;
                                                modulo: (other: string | number | Long.Long) => Long.Long;
                                                mod: (other: string | number | Long.Long) => Long.Long;
                                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                                negate: () => Long.Long;
                                                neg: () => Long.Long;
                                                not: () => Long.Long;
                                                notEquals: (other: string | number | Long.Long) => boolean;
                                                neq: (other: string | number | Long.Long) => boolean;
                                                or: (other: string | number | Long.Long) => Long.Long;
                                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                                shl: (numBits: number | Long.Long) => Long.Long;
                                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                                shr: (numBits: number | Long.Long) => Long.Long;
                                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                                shru: (numBits: number | Long.Long) => Long.Long;
                                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                                toInt: () => number;
                                                toNumber: () => number;
                                                toBytes: (le?: boolean | undefined) => number[];
                                                toBytesLE: () => number[];
                                                toBytesBE: () => number[];
                                                toSigned: () => Long.Long;
                                                toString: (radix?: number | undefined) => string;
                                                toUnsigned: () => Long.Long;
                                                xor: (other: string | number | Long.Long) => Long.Long;
                                            } & { [K_334 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        } & { [K_335 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_336 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[]>]: never; }) | undefined;
                                    } & { [K_337 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                                } & { [K_338 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_339 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[]>]: never; }) | undefined;
                                options?: ({
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_340 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_341 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_342 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_343 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_344 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_345 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_346 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                                reservedRange?: ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] & ({
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                } & { [K_347 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_348 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[]>]: never; }) | undefined;
                                reservedName?: (string[] & string[] & { [K_349 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                            } & { [K_350 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_351 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[]>]: never; }) | undefined;
                            extensionRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: ({
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_352 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_353 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_354 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_355 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_356 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_357 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_358 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                            } & { [K_359 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_360 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>]: never; }) | undefined;
                            oneofDecl?: ({
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                options?: ({
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_361 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_362 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_363 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_364 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_365 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_366 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_367 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                            } & { [K_368 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_369 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>]: never; }) | undefined;
                            options?: ({
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_370 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_371 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_372 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_373 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_374 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_375 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_376 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                            reservedRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                            } & { [K_377 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_378 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[]>]: never; }) | undefined;
                            reservedName?: (string[] & string[] & { [K_379 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                        } & { [K_380 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_381 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                            name?: string | undefined;
                            field?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            extension?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                label?: FieldDescriptorProto_Label | undefined;
                                type?: FieldDescriptorProto_Type | undefined;
                                typeName?: string | undefined;
                                extendee?: string | undefined;
                                defaultValue?: string | undefined;
                                oneofIndex?: number | undefined;
                                jsonName?: string | undefined;
                                options?: {
                                    ctype?: FieldOptions_CType | undefined;
                                    packed?: boolean | undefined;
                                    jstype?: FieldOptions_JSType | undefined;
                                    lazy?: boolean | undefined;
                                    unverifiedLazy?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    weak?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                proto3Optional?: boolean | undefined;
                            }[] | undefined;
                            nestedType?: any[] | undefined;
                            enumType?: {
                                name?: string | undefined;
                                value?: {
                                    name?: string | undefined;
                                    number?: number | undefined;
                                    options?: {
                                        deprecated?: boolean | undefined;
                                        uninterpretedOption?: {
                                            name?: {
                                                namePart?: string | undefined;
                                                isExtension?: boolean | undefined;
                                            }[] | undefined;
                                            identifierValue?: string | undefined;
                                            positiveIntValue?: string | number | Long.Long | undefined;
                                            negativeIntValue?: string | number | Long.Long | undefined;
                                            doubleValue?: number | undefined;
                                            stringValue?: Uint8Array | undefined;
                                            aggregateValue?: string | undefined;
                                        }[] | undefined;
                                    } | undefined;
                                }[] | undefined;
                                options?: {
                                    allowAlias?: boolean | undefined;
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                                reservedRange?: {
                                    start?: number | undefined;
                                    end?: number | undefined;
                                }[] | undefined;
                                reservedName?: string[] | undefined;
                            }[] | undefined;
                            extensionRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            oneofDecl?: {
                                name?: string | undefined;
                                options?: {
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                messageSetWireFormat?: boolean | undefined;
                                noStandardDescriptorAccessor?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                mapEntry?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[]>]: never; }) | undefined;
                        enumType?: ({
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] & ({
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        } & {
                            name?: string | undefined;
                            value?: ({
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] & ({
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            } & {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: ({
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } & {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] & ({
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & {
                                        name?: ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] & ({
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        } & { [K_382 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_383 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[]>]: never; }) | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_384 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        negativeIntValue?: string | number | (Long.Long & {
                                            high: number;
                                            low: number;
                                            unsigned: boolean;
                                            add: (addend: string | number | Long.Long) => Long.Long;
                                            and: (other: string | number | Long.Long) => Long.Long;
                                            compare: (other: string | number | Long.Long) => number;
                                            comp: (other: string | number | Long.Long) => number;
                                            divide: (divisor: string | number | Long.Long) => Long.Long;
                                            div: (divisor: string | number | Long.Long) => Long.Long;
                                            equals: (other: string | number | Long.Long) => boolean;
                                            eq: (other: string | number | Long.Long) => boolean;
                                            getHighBits: () => number;
                                            getHighBitsUnsigned: () => number;
                                            getLowBits: () => number;
                                            getLowBitsUnsigned: () => number;
                                            getNumBitsAbs: () => number;
                                            greaterThan: (other: string | number | Long.Long) => boolean;
                                            gt: (other: string | number | Long.Long) => boolean;
                                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            gte: (other: string | number | Long.Long) => boolean;
                                            isEven: () => boolean;
                                            isNegative: () => boolean;
                                            isOdd: () => boolean;
                                            isPositive: () => boolean;
                                            isZero: () => boolean;
                                            lessThan: (other: string | number | Long.Long) => boolean;
                                            lt: (other: string | number | Long.Long) => boolean;
                                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                            lte: (other: string | number | Long.Long) => boolean;
                                            modulo: (other: string | number | Long.Long) => Long.Long;
                                            mod: (other: string | number | Long.Long) => Long.Long;
                                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                                            negate: () => Long.Long;
                                            neg: () => Long.Long;
                                            not: () => Long.Long;
                                            notEquals: (other: string | number | Long.Long) => boolean;
                                            neq: (other: string | number | Long.Long) => boolean;
                                            or: (other: string | number | Long.Long) => Long.Long;
                                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                            shl: (numBits: number | Long.Long) => Long.Long;
                                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                                            shr: (numBits: number | Long.Long) => Long.Long;
                                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                            shru: (numBits: number | Long.Long) => Long.Long;
                                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                            toInt: () => number;
                                            toNumber: () => number;
                                            toBytes: (le?: boolean | undefined) => number[];
                                            toBytesLE: () => number[];
                                            toBytesBE: () => number[];
                                            toSigned: () => Long.Long;
                                            toString: (radix?: number | undefined) => string;
                                            toUnsigned: () => Long.Long;
                                            xor: (other: string | number | Long.Long) => Long.Long;
                                        } & { [K_385 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    } & { [K_386 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_387 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[]>]: never; }) | undefined;
                                } & { [K_388 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                            } & { [K_389 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_390 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[]>]: never; }) | undefined;
                            options?: ({
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_391 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_392 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_393 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_394 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_395 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_396 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_397 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                            reservedRange?: ({
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] & ({
                                start?: number | undefined;
                                end?: number | undefined;
                            } & {
                                start?: number | undefined;
                                end?: number | undefined;
                            } & { [K_398 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_399 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[]>]: never; }) | undefined;
                            reservedName?: (string[] & string[] & { [K_400 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                        } & { [K_401 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_402 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[]>]: never; }) | undefined;
                        extensionRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: ({
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_403 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_404 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_405 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_406 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_407 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_408 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_409 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                        } & { [K_410 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_411 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>]: never; }) | undefined;
                        oneofDecl?: ({
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            options?: ({
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_412 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_413 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_414 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_415 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_416 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_417 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_418 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                        } & { [K_419 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_420 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>]: never; }) | undefined;
                        options?: ({
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_421 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_422 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_423 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_424 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_425 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_426 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_427 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                        reservedRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                        } & { [K_428 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_429 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[]>]: never; }) | undefined;
                        reservedName?: (string[] & string[] & { [K_430 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                    } & { [K_431 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_432 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                        name?: string | undefined;
                        field?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        extension?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            label?: FieldDescriptorProto_Label | undefined;
                            type?: FieldDescriptorProto_Type | undefined;
                            typeName?: string | undefined;
                            extendee?: string | undefined;
                            defaultValue?: string | undefined;
                            oneofIndex?: number | undefined;
                            jsonName?: string | undefined;
                            options?: {
                                ctype?: FieldOptions_CType | undefined;
                                packed?: boolean | undefined;
                                jstype?: FieldOptions_JSType | undefined;
                                lazy?: boolean | undefined;
                                unverifiedLazy?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                weak?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            proto3Optional?: boolean | undefined;
                        }[] | undefined;
                        nestedType?: any[] | undefined;
                        enumType?: {
                            name?: string | undefined;
                            value?: {
                                name?: string | undefined;
                                number?: number | undefined;
                                options?: {
                                    deprecated?: boolean | undefined;
                                    uninterpretedOption?: {
                                        name?: {
                                            namePart?: string | undefined;
                                            isExtension?: boolean | undefined;
                                        }[] | undefined;
                                        identifierValue?: string | undefined;
                                        positiveIntValue?: string | number | Long.Long | undefined;
                                        negativeIntValue?: string | number | Long.Long | undefined;
                                        doubleValue?: number | undefined;
                                        stringValue?: Uint8Array | undefined;
                                        aggregateValue?: string | undefined;
                                    }[] | undefined;
                                } | undefined;
                            }[] | undefined;
                            options?: {
                                allowAlias?: boolean | undefined;
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                            reservedRange?: {
                                start?: number | undefined;
                                end?: number | undefined;
                            }[] | undefined;
                            reservedName?: string[] | undefined;
                        }[] | undefined;
                        extensionRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        oneofDecl?: {
                            name?: string | undefined;
                            options?: {
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            messageSetWireFormat?: boolean | undefined;
                            noStandardDescriptorAccessor?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            mapEntry?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[]>]: never; }) | undefined;
                    enumType?: ({
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] & ({
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    } & {
                        name?: string | undefined;
                        value?: ({
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] & ({
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        } & {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: ({
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } & {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] & ({
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & {
                                    name?: ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] & ({
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    } & { [K_433 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_434 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[]>]: never; }) | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_435 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    negativeIntValue?: string | number | (Long.Long & {
                                        high: number;
                                        low: number;
                                        unsigned: boolean;
                                        add: (addend: string | number | Long.Long) => Long.Long;
                                        and: (other: string | number | Long.Long) => Long.Long;
                                        compare: (other: string | number | Long.Long) => number;
                                        comp: (other: string | number | Long.Long) => number;
                                        divide: (divisor: string | number | Long.Long) => Long.Long;
                                        div: (divisor: string | number | Long.Long) => Long.Long;
                                        equals: (other: string | number | Long.Long) => boolean;
                                        eq: (other: string | number | Long.Long) => boolean;
                                        getHighBits: () => number;
                                        getHighBitsUnsigned: () => number;
                                        getLowBits: () => number;
                                        getLowBitsUnsigned: () => number;
                                        getNumBitsAbs: () => number;
                                        greaterThan: (other: string | number | Long.Long) => boolean;
                                        gt: (other: string | number | Long.Long) => boolean;
                                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        gte: (other: string | number | Long.Long) => boolean;
                                        isEven: () => boolean;
                                        isNegative: () => boolean;
                                        isOdd: () => boolean;
                                        isPositive: () => boolean;
                                        isZero: () => boolean;
                                        lessThan: (other: string | number | Long.Long) => boolean;
                                        lt: (other: string | number | Long.Long) => boolean;
                                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                        lte: (other: string | number | Long.Long) => boolean;
                                        modulo: (other: string | number | Long.Long) => Long.Long;
                                        mod: (other: string | number | Long.Long) => Long.Long;
                                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                                        negate: () => Long.Long;
                                        neg: () => Long.Long;
                                        not: () => Long.Long;
                                        notEquals: (other: string | number | Long.Long) => boolean;
                                        neq: (other: string | number | Long.Long) => boolean;
                                        or: (other: string | number | Long.Long) => Long.Long;
                                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                        shl: (numBits: number | Long.Long) => Long.Long;
                                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                                        shr: (numBits: number | Long.Long) => Long.Long;
                                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                        shru: (numBits: number | Long.Long) => Long.Long;
                                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                        toInt: () => number;
                                        toNumber: () => number;
                                        toBytes: (le?: boolean | undefined) => number[];
                                        toBytesLE: () => number[];
                                        toBytesBE: () => number[];
                                        toSigned: () => Long.Long;
                                        toString: (radix?: number | undefined) => string;
                                        toUnsigned: () => Long.Long;
                                        xor: (other: string | number | Long.Long) => Long.Long;
                                    } & { [K_436 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                } & { [K_437 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_438 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[]>]: never; }) | undefined;
                            } & { [K_439 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                        } & { [K_440 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_441 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[]>]: never; }) | undefined;
                        options?: ({
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_442 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_443 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_444 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_445 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_446 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_447 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_448 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                        reservedRange?: ({
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] & ({
                            start?: number | undefined;
                            end?: number | undefined;
                        } & {
                            start?: number | undefined;
                            end?: number | undefined;
                        } & { [K_449 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_450 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[]>]: never; }) | undefined;
                        reservedName?: (string[] & string[] & { [K_451 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                    } & { [K_452 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_453 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[]>]: never; }) | undefined;
                    extensionRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: ({
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_454 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_455 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_456 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_457 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_458 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_459 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_460 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                    } & { [K_461 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_462 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>]: never; }) | undefined;
                    oneofDecl?: ({
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        options?: ({
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_463 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_464 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_465 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_466 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_467 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_468 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_469 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                    } & { [K_470 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_471 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>]: never; }) | undefined;
                    options?: ({
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_472 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_473 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_474 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_475 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_476 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_477 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_478 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                    reservedRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                    } & { [K_479 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_480 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[]>]: never; }) | undefined;
                    reservedName?: (string[] & string[] & { [K_481 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                } & { [K_482 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_483 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["nestedType"], keyof {
                    name?: string | undefined;
                    field?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    extension?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        label?: FieldDescriptorProto_Label | undefined;
                        type?: FieldDescriptorProto_Type | undefined;
                        typeName?: string | undefined;
                        extendee?: string | undefined;
                        defaultValue?: string | undefined;
                        oneofIndex?: number | undefined;
                        jsonName?: string | undefined;
                        options?: {
                            ctype?: FieldOptions_CType | undefined;
                            packed?: boolean | undefined;
                            jstype?: FieldOptions_JSType | undefined;
                            lazy?: boolean | undefined;
                            unverifiedLazy?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            weak?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        proto3Optional?: boolean | undefined;
                    }[] | undefined;
                    nestedType?: any[] | undefined;
                    enumType?: {
                        name?: string | undefined;
                        value?: {
                            name?: string | undefined;
                            number?: number | undefined;
                            options?: {
                                deprecated?: boolean | undefined;
                                uninterpretedOption?: {
                                    name?: {
                                        namePart?: string | undefined;
                                        isExtension?: boolean | undefined;
                                    }[] | undefined;
                                    identifierValue?: string | undefined;
                                    positiveIntValue?: string | number | Long.Long | undefined;
                                    negativeIntValue?: string | number | Long.Long | undefined;
                                    doubleValue?: number | undefined;
                                    stringValue?: Uint8Array | undefined;
                                    aggregateValue?: string | undefined;
                                }[] | undefined;
                            } | undefined;
                        }[] | undefined;
                        options?: {
                            allowAlias?: boolean | undefined;
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                        reservedRange?: {
                            start?: number | undefined;
                            end?: number | undefined;
                        }[] | undefined;
                        reservedName?: string[] | undefined;
                    }[] | undefined;
                    extensionRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    oneofDecl?: {
                        name?: string | undefined;
                        options?: {
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        messageSetWireFormat?: boolean | undefined;
                        noStandardDescriptorAccessor?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        mapEntry?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[]>]: never; }) | undefined;
                enumType?: ({
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] & ({
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                } & {
                    name?: string | undefined;
                    value?: ({
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] & ({
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    } & {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: ({
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } & {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] & ({
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & {
                                name?: ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] & ({
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                } & { [K_484 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_485 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[]>]: never; }) | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_486 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                                negativeIntValue?: string | number | (Long.Long & {
                                    high: number;
                                    low: number;
                                    unsigned: boolean;
                                    add: (addend: string | number | Long.Long) => Long.Long;
                                    and: (other: string | number | Long.Long) => Long.Long;
                                    compare: (other: string | number | Long.Long) => number;
                                    comp: (other: string | number | Long.Long) => number;
                                    divide: (divisor: string | number | Long.Long) => Long.Long;
                                    div: (divisor: string | number | Long.Long) => Long.Long;
                                    equals: (other: string | number | Long.Long) => boolean;
                                    eq: (other: string | number | Long.Long) => boolean;
                                    getHighBits: () => number;
                                    getHighBitsUnsigned: () => number;
                                    getLowBits: () => number;
                                    getLowBitsUnsigned: () => number;
                                    getNumBitsAbs: () => number;
                                    greaterThan: (other: string | number | Long.Long) => boolean;
                                    gt: (other: string | number | Long.Long) => boolean;
                                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    gte: (other: string | number | Long.Long) => boolean;
                                    isEven: () => boolean;
                                    isNegative: () => boolean;
                                    isOdd: () => boolean;
                                    isPositive: () => boolean;
                                    isZero: () => boolean;
                                    lessThan: (other: string | number | Long.Long) => boolean;
                                    lt: (other: string | number | Long.Long) => boolean;
                                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                    lte: (other: string | number | Long.Long) => boolean;
                                    modulo: (other: string | number | Long.Long) => Long.Long;
                                    mod: (other: string | number | Long.Long) => Long.Long;
                                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                                    negate: () => Long.Long;
                                    neg: () => Long.Long;
                                    not: () => Long.Long;
                                    notEquals: (other: string | number | Long.Long) => boolean;
                                    neq: (other: string | number | Long.Long) => boolean;
                                    or: (other: string | number | Long.Long) => Long.Long;
                                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                    shl: (numBits: number | Long.Long) => Long.Long;
                                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                                    shr: (numBits: number | Long.Long) => Long.Long;
                                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                    shru: (numBits: number | Long.Long) => Long.Long;
                                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                    toInt: () => number;
                                    toNumber: () => number;
                                    toBytes: (le?: boolean | undefined) => number[];
                                    toBytesLE: () => number[];
                                    toBytesBE: () => number[];
                                    toSigned: () => Long.Long;
                                    toString: (radix?: number | undefined) => string;
                                    toUnsigned: () => Long.Long;
                                    xor: (other: string | number | Long.Long) => Long.Long;
                                } & { [K_487 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            } & { [K_488 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_489 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[]>]: never; }) | undefined;
                        } & { [K_490 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                    } & { [K_491 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_492 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["value"], keyof {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[]>]: never; }) | undefined;
                    options?: ({
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_493 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_494 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_495 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_496 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_497 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_498 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_499 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                    reservedRange?: ({
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] & ({
                        start?: number | undefined;
                        end?: number | undefined;
                    } & {
                        start?: number | undefined;
                        end?: number | undefined;
                    } & { [K_500 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_501 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[]>]: never; }) | undefined;
                    reservedName?: (string[] & string[] & { [K_502 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
                } & { [K_503 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_504 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["enumType"], keyof {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[]>]: never; }) | undefined;
                extensionRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: ({
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_505 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_506 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_507 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_508 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_509 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_510 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_511 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                } & { [K_512 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_513 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["extensionRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>]: never; }) | undefined;
                oneofDecl?: ({
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    options?: ({
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_514 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_515 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_516 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_517 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_518 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_519 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_520 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
                } & { [K_521 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_522 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["oneofDecl"], keyof {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>]: never; }) | undefined;
                options?: ({
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_523 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_524 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_525 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_526 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_527 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_528 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_529 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
                reservedRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                } & { [K_530 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_531 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["reservedRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                }[]>]: never; }) | undefined;
                reservedName?: (string[] & string[] & { [K_532 in Exclude<keyof I["nestedType"][number]["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
            } & { [K_533 in Exclude<keyof I["nestedType"][number]["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_534 in Exclude<keyof I["nestedType"][number]["nestedType"], keyof {
                name?: string | undefined;
                field?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                extension?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    label?: FieldDescriptorProto_Label | undefined;
                    type?: FieldDescriptorProto_Type | undefined;
                    typeName?: string | undefined;
                    extendee?: string | undefined;
                    defaultValue?: string | undefined;
                    oneofIndex?: number | undefined;
                    jsonName?: string | undefined;
                    options?: {
                        ctype?: FieldOptions_CType | undefined;
                        packed?: boolean | undefined;
                        jstype?: FieldOptions_JSType | undefined;
                        lazy?: boolean | undefined;
                        unverifiedLazy?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        weak?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    proto3Optional?: boolean | undefined;
                }[] | undefined;
                nestedType?: any[] | undefined;
                enumType?: {
                    name?: string | undefined;
                    value?: {
                        name?: string | undefined;
                        number?: number | undefined;
                        options?: {
                            deprecated?: boolean | undefined;
                            uninterpretedOption?: {
                                name?: {
                                    namePart?: string | undefined;
                                    isExtension?: boolean | undefined;
                                }[] | undefined;
                                identifierValue?: string | undefined;
                                positiveIntValue?: string | number | Long.Long | undefined;
                                negativeIntValue?: string | number | Long.Long | undefined;
                                doubleValue?: number | undefined;
                                stringValue?: Uint8Array | undefined;
                                aggregateValue?: string | undefined;
                            }[] | undefined;
                        } | undefined;
                    }[] | undefined;
                    options?: {
                        allowAlias?: boolean | undefined;
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                    reservedRange?: {
                        start?: number | undefined;
                        end?: number | undefined;
                    }[] | undefined;
                    reservedName?: string[] | undefined;
                }[] | undefined;
                extensionRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                oneofDecl?: {
                    name?: string | undefined;
                    options?: {
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    messageSetWireFormat?: boolean | undefined;
                    noStandardDescriptorAccessor?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    mapEntry?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[]>]: never; }) | undefined;
            enumType?: ({
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] & ({
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            } & {
                name?: string | undefined;
                value?: ({
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] & ({
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                } & {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: ({
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } & {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] & ({
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & {
                            name?: ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] & ({
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            } & { [K_535 in Exclude<keyof I["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_536 in Exclude<keyof I["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[]>]: never; }) | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_537 in Exclude<keyof I["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                            negativeIntValue?: string | number | (Long.Long & {
                                high: number;
                                low: number;
                                unsigned: boolean;
                                add: (addend: string | number | Long.Long) => Long.Long;
                                and: (other: string | number | Long.Long) => Long.Long;
                                compare: (other: string | number | Long.Long) => number;
                                comp: (other: string | number | Long.Long) => number;
                                divide: (divisor: string | number | Long.Long) => Long.Long;
                                div: (divisor: string | number | Long.Long) => Long.Long;
                                equals: (other: string | number | Long.Long) => boolean;
                                eq: (other: string | number | Long.Long) => boolean;
                                getHighBits: () => number;
                                getHighBitsUnsigned: () => number;
                                getLowBits: () => number;
                                getLowBitsUnsigned: () => number;
                                getNumBitsAbs: () => number;
                                greaterThan: (other: string | number | Long.Long) => boolean;
                                gt: (other: string | number | Long.Long) => boolean;
                                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                                gte: (other: string | number | Long.Long) => boolean;
                                isEven: () => boolean;
                                isNegative: () => boolean;
                                isOdd: () => boolean;
                                isPositive: () => boolean;
                                isZero: () => boolean;
                                lessThan: (other: string | number | Long.Long) => boolean;
                                lt: (other: string | number | Long.Long) => boolean;
                                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                                lte: (other: string | number | Long.Long) => boolean;
                                modulo: (other: string | number | Long.Long) => Long.Long;
                                mod: (other: string | number | Long.Long) => Long.Long;
                                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                                mul: (multiplier: string | number | Long.Long) => Long.Long;
                                negate: () => Long.Long;
                                neg: () => Long.Long;
                                not: () => Long.Long;
                                notEquals: (other: string | number | Long.Long) => boolean;
                                neq: (other: string | number | Long.Long) => boolean;
                                or: (other: string | number | Long.Long) => Long.Long;
                                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                                shl: (numBits: number | Long.Long) => Long.Long;
                                shiftRight: (numBits: number | Long.Long) => Long.Long;
                                shr: (numBits: number | Long.Long) => Long.Long;
                                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                                shru: (numBits: number | Long.Long) => Long.Long;
                                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                                toInt: () => number;
                                toNumber: () => number;
                                toBytes: (le?: boolean | undefined) => number[];
                                toBytesLE: () => number[];
                                toBytesBE: () => number[];
                                toSigned: () => Long.Long;
                                toString: (radix?: number | undefined) => string;
                                toUnsigned: () => Long.Long;
                                xor: (other: string | number | Long.Long) => Long.Long;
                            } & { [K_538 in Exclude<keyof I["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        } & { [K_539 in Exclude<keyof I["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_540 in Exclude<keyof I["nestedType"][number]["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[]>]: never; }) | undefined;
                    } & { [K_541 in Exclude<keyof I["nestedType"][number]["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
                } & { [K_542 in Exclude<keyof I["nestedType"][number]["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_543 in Exclude<keyof I["nestedType"][number]["enumType"][number]["value"], keyof {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[]>]: never; }) | undefined;
                options?: ({
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_544 in Exclude<keyof I["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_545 in Exclude<keyof I["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_546 in Exclude<keyof I["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_547 in Exclude<keyof I["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_548 in Exclude<keyof I["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_549 in Exclude<keyof I["nestedType"][number]["enumType"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_550 in Exclude<keyof I["nestedType"][number]["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
                reservedRange?: ({
                    start?: number | undefined;
                    end?: number | undefined;
                }[] & ({
                    start?: number | undefined;
                    end?: number | undefined;
                } & {
                    start?: number | undefined;
                    end?: number | undefined;
                } & { [K_551 in Exclude<keyof I["nestedType"][number]["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_552 in Exclude<keyof I["nestedType"][number]["enumType"][number]["reservedRange"], keyof {
                    start?: number | undefined;
                    end?: number | undefined;
                }[]>]: never; }) | undefined;
                reservedName?: (string[] & string[] & { [K_553 in Exclude<keyof I["nestedType"][number]["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
            } & { [K_554 in Exclude<keyof I["nestedType"][number]["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_555 in Exclude<keyof I["nestedType"][number]["enumType"], keyof {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[]>]: never; }) | undefined;
            extensionRange?: ({
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                start?: number | undefined;
                end?: number | undefined;
                options?: ({
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_556 in Exclude<keyof I["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_557 in Exclude<keyof I["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_558 in Exclude<keyof I["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_559 in Exclude<keyof I["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_560 in Exclude<keyof I["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_561 in Exclude<keyof I["nestedType"][number]["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_562 in Exclude<keyof I["nestedType"][number]["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
            } & { [K_563 in Exclude<keyof I["nestedType"][number]["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_564 in Exclude<keyof I["nestedType"][number]["extensionRange"], keyof {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>]: never; }) | undefined;
            oneofDecl?: ({
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                options?: ({
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_565 in Exclude<keyof I["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_566 in Exclude<keyof I["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_567 in Exclude<keyof I["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_568 in Exclude<keyof I["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_569 in Exclude<keyof I["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_570 in Exclude<keyof I["nestedType"][number]["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_571 in Exclude<keyof I["nestedType"][number]["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
            } & { [K_572 in Exclude<keyof I["nestedType"][number]["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_573 in Exclude<keyof I["nestedType"][number]["oneofDecl"], keyof {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>]: never; }) | undefined;
            options?: ({
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & { [K_574 in Exclude<keyof I["nestedType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_575 in Exclude<keyof I["nestedType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_576 in Exclude<keyof I["nestedType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                    negativeIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_577 in Exclude<keyof I["nestedType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & { [K_578 in Exclude<keyof I["nestedType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_579 in Exclude<keyof I["nestedType"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>]: never; }) | undefined;
            } & { [K_580 in Exclude<keyof I["nestedType"][number]["options"], keyof MessageOptions>]: never; }) | undefined;
            reservedRange?: ({
                start?: number | undefined;
                end?: number | undefined;
            }[] & ({
                start?: number | undefined;
                end?: number | undefined;
            } & {
                start?: number | undefined;
                end?: number | undefined;
            } & { [K_581 in Exclude<keyof I["nestedType"][number]["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_582 in Exclude<keyof I["nestedType"][number]["reservedRange"], keyof {
                start?: number | undefined;
                end?: number | undefined;
            }[]>]: never; }) | undefined;
            reservedName?: (string[] & string[] & { [K_583 in Exclude<keyof I["nestedType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
        } & { [K_584 in Exclude<keyof I["nestedType"][number], keyof DescriptorProto>]: never; })[] & { [K_585 in Exclude<keyof I["nestedType"], keyof {
            name?: string | undefined;
            field?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            extension?: {
                name?: string | undefined;
                number?: number | undefined;
                label?: FieldDescriptorProto_Label | undefined;
                type?: FieldDescriptorProto_Type | undefined;
                typeName?: string | undefined;
                extendee?: string | undefined;
                defaultValue?: string | undefined;
                oneofIndex?: number | undefined;
                jsonName?: string | undefined;
                options?: {
                    ctype?: FieldOptions_CType | undefined;
                    packed?: boolean | undefined;
                    jstype?: FieldOptions_JSType | undefined;
                    lazy?: boolean | undefined;
                    unverifiedLazy?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    weak?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                proto3Optional?: boolean | undefined;
            }[] | undefined;
            nestedType?: any[] | undefined;
            enumType?: {
                name?: string | undefined;
                value?: {
                    name?: string | undefined;
                    number?: number | undefined;
                    options?: {
                        deprecated?: boolean | undefined;
                        uninterpretedOption?: {
                            name?: {
                                namePart?: string | undefined;
                                isExtension?: boolean | undefined;
                            }[] | undefined;
                            identifierValue?: string | undefined;
                            positiveIntValue?: string | number | Long.Long | undefined;
                            negativeIntValue?: string | number | Long.Long | undefined;
                            doubleValue?: number | undefined;
                            stringValue?: Uint8Array | undefined;
                            aggregateValue?: string | undefined;
                        }[] | undefined;
                    } | undefined;
                }[] | undefined;
                options?: {
                    allowAlias?: boolean | undefined;
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
                reservedRange?: {
                    start?: number | undefined;
                    end?: number | undefined;
                }[] | undefined;
                reservedName?: string[] | undefined;
            }[] | undefined;
            extensionRange?: {
                start?: number | undefined;
                end?: number | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            oneofDecl?: {
                name?: string | undefined;
                options?: {
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                messageSetWireFormat?: boolean | undefined;
                noStandardDescriptorAccessor?: boolean | undefined;
                deprecated?: boolean | undefined;
                mapEntry?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[]>]: never; }) | undefined;
        enumType?: ({
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[] & ({
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        } & {
            name?: string | undefined;
            value?: ({
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] & ({
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            } & {
                name?: string | undefined;
                number?: number | undefined;
                options?: ({
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } & {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] & ({
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & {
                        name?: ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] & ({
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        } & { [K_586 in Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_587 in Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[]>]: never; }) | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_588 in Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                        negativeIntValue?: string | number | (Long.Long & {
                            high: number;
                            low: number;
                            unsigned: boolean;
                            add: (addend: string | number | Long.Long) => Long.Long;
                            and: (other: string | number | Long.Long) => Long.Long;
                            compare: (other: string | number | Long.Long) => number;
                            comp: (other: string | number | Long.Long) => number;
                            divide: (divisor: string | number | Long.Long) => Long.Long;
                            div: (divisor: string | number | Long.Long) => Long.Long;
                            equals: (other: string | number | Long.Long) => boolean;
                            eq: (other: string | number | Long.Long) => boolean;
                            getHighBits: () => number;
                            getHighBitsUnsigned: () => number;
                            getLowBits: () => number;
                            getLowBitsUnsigned: () => number;
                            getNumBitsAbs: () => number;
                            greaterThan: (other: string | number | Long.Long) => boolean;
                            gt: (other: string | number | Long.Long) => boolean;
                            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                            gte: (other: string | number | Long.Long) => boolean;
                            isEven: () => boolean;
                            isNegative: () => boolean;
                            isOdd: () => boolean;
                            isPositive: () => boolean;
                            isZero: () => boolean;
                            lessThan: (other: string | number | Long.Long) => boolean;
                            lt: (other: string | number | Long.Long) => boolean;
                            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                            lte: (other: string | number | Long.Long) => boolean;
                            modulo: (other: string | number | Long.Long) => Long.Long;
                            mod: (other: string | number | Long.Long) => Long.Long;
                            multiply: (multiplier: string | number | Long.Long) => Long.Long;
                            mul: (multiplier: string | number | Long.Long) => Long.Long;
                            negate: () => Long.Long;
                            neg: () => Long.Long;
                            not: () => Long.Long;
                            notEquals: (other: string | number | Long.Long) => boolean;
                            neq: (other: string | number | Long.Long) => boolean;
                            or: (other: string | number | Long.Long) => Long.Long;
                            shiftLeft: (numBits: number | Long.Long) => Long.Long;
                            shl: (numBits: number | Long.Long) => Long.Long;
                            shiftRight: (numBits: number | Long.Long) => Long.Long;
                            shr: (numBits: number | Long.Long) => Long.Long;
                            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                            shru: (numBits: number | Long.Long) => Long.Long;
                            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                            sub: (subtrahend: string | number | Long.Long) => Long.Long;
                            toInt: () => number;
                            toNumber: () => number;
                            toBytes: (le?: boolean | undefined) => number[];
                            toBytesLE: () => number[];
                            toBytesBE: () => number[];
                            toSigned: () => Long.Long;
                            toString: (radix?: number | undefined) => string;
                            toUnsigned: () => Long.Long;
                            xor: (other: string | number | Long.Long) => Long.Long;
                        } & { [K_589 in Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    } & { [K_590 in Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_591 in Exclude<keyof I["enumType"][number]["value"][number]["options"]["uninterpretedOption"], keyof {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[]>]: never; }) | undefined;
                } & { [K_592 in Exclude<keyof I["enumType"][number]["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
            } & { [K_593 in Exclude<keyof I["enumType"][number]["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_594 in Exclude<keyof I["enumType"][number]["value"], keyof {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[]>]: never; }) | undefined;
            options?: ({
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & { [K_595 in Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_596 in Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_597 in Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                    negativeIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_598 in Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & { [K_599 in Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_600 in Exclude<keyof I["enumType"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>]: never; }) | undefined;
            } & { [K_601 in Exclude<keyof I["enumType"][number]["options"], keyof EnumOptions>]: never; }) | undefined;
            reservedRange?: ({
                start?: number | undefined;
                end?: number | undefined;
            }[] & ({
                start?: number | undefined;
                end?: number | undefined;
            } & {
                start?: number | undefined;
                end?: number | undefined;
            } & { [K_602 in Exclude<keyof I["enumType"][number]["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_603 in Exclude<keyof I["enumType"][number]["reservedRange"], keyof {
                start?: number | undefined;
                end?: number | undefined;
            }[]>]: never; }) | undefined;
            reservedName?: (string[] & string[] & { [K_604 in Exclude<keyof I["enumType"][number]["reservedName"], keyof string[]>]: never; }) | undefined;
        } & { [K_605 in Exclude<keyof I["enumType"][number], keyof EnumDescriptorProto>]: never; })[] & { [K_606 in Exclude<keyof I["enumType"], keyof {
            name?: string | undefined;
            value?: {
                name?: string | undefined;
                number?: number | undefined;
                options?: {
                    deprecated?: boolean | undefined;
                    uninterpretedOption?: {
                        name?: {
                            namePart?: string | undefined;
                            isExtension?: boolean | undefined;
                        }[] | undefined;
                        identifierValue?: string | undefined;
                        positiveIntValue?: string | number | Long.Long | undefined;
                        negativeIntValue?: string | number | Long.Long | undefined;
                        doubleValue?: number | undefined;
                        stringValue?: Uint8Array | undefined;
                        aggregateValue?: string | undefined;
                    }[] | undefined;
                } | undefined;
            }[] | undefined;
            options?: {
                allowAlias?: boolean | undefined;
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            reservedRange?: {
                start?: number | undefined;
                end?: number | undefined;
            }[] | undefined;
            reservedName?: string[] | undefined;
        }[]>]: never; }) | undefined;
        extensionRange?: ({
            start?: number | undefined;
            end?: number | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] & ({
            start?: number | undefined;
            end?: number | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        } & {
            start?: number | undefined;
            end?: number | undefined;
            options?: ({
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & { [K_607 in Exclude<keyof I["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_608 in Exclude<keyof I["extensionRange"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_609 in Exclude<keyof I["extensionRange"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                    negativeIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_610 in Exclude<keyof I["extensionRange"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & { [K_611 in Exclude<keyof I["extensionRange"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_612 in Exclude<keyof I["extensionRange"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>]: never; }) | undefined;
            } & { [K_613 in Exclude<keyof I["extensionRange"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
        } & { [K_614 in Exclude<keyof I["extensionRange"][number], keyof DescriptorProto_ExtensionRange>]: never; })[] & { [K_615 in Exclude<keyof I["extensionRange"], keyof {
            start?: number | undefined;
            end?: number | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[]>]: never; }) | undefined;
        oneofDecl?: ({
            name?: string | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] & ({
            name?: string | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        } & {
            name?: string | undefined;
            options?: ({
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & { [K_616 in Exclude<keyof I["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_617 in Exclude<keyof I["oneofDecl"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_618 in Exclude<keyof I["oneofDecl"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                    negativeIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_619 in Exclude<keyof I["oneofDecl"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & { [K_620 in Exclude<keyof I["oneofDecl"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_621 in Exclude<keyof I["oneofDecl"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>]: never; }) | undefined;
            } & { [K_622 in Exclude<keyof I["oneofDecl"][number]["options"], "uninterpretedOption">]: never; }) | undefined;
        } & { [K_623 in Exclude<keyof I["oneofDecl"][number], keyof OneofDescriptorProto>]: never; })[] & { [K_624 in Exclude<keyof I["oneofDecl"], keyof {
            name?: string | undefined;
            options?: {
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[]>]: never; }) | undefined;
        options?: ({
            messageSetWireFormat?: boolean | undefined;
            noStandardDescriptorAccessor?: boolean | undefined;
            deprecated?: boolean | undefined;
            mapEntry?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            messageSetWireFormat?: boolean | undefined;
            noStandardDescriptorAccessor?: boolean | undefined;
            deprecated?: boolean | undefined;
            mapEntry?: boolean | undefined;
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & { [K_625 in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_626 in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>]: never; }) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_627 in Exclude<keyof I["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                negativeIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_628 in Exclude<keyof I["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & { [K_629 in Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_630 in Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>]: never; }) | undefined;
        } & { [K_631 in Exclude<keyof I["options"], keyof MessageOptions>]: never; }) | undefined;
        reservedRange?: ({
            start?: number | undefined;
            end?: number | undefined;
        }[] & ({
            start?: number | undefined;
            end?: number | undefined;
        } & {
            start?: number | undefined;
            end?: number | undefined;
        } & { [K_632 in Exclude<keyof I["reservedRange"][number], keyof DescriptorProto_ReservedRange>]: never; })[] & { [K_633 in Exclude<keyof I["reservedRange"], keyof {
            start?: number | undefined;
            end?: number | undefined;
        }[]>]: never; }) | undefined;
        reservedName?: (string[] & string[] & { [K_634 in Exclude<keyof I["reservedName"], keyof string[]>]: never; }) | undefined;
    } & { [K_635 in Exclude<keyof I, keyof DescriptorProto>]: never; }>(object: I): DescriptorProto;
};
export declare const DescriptorProto_ExtensionRange: {
    encode(message: DescriptorProto_ExtensionRange, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): DescriptorProto_ExtensionRange;
    fromJSON(object: any): DescriptorProto_ExtensionRange;
    toJSON(message: DescriptorProto_ExtensionRange): unknown;
    fromPartial<I extends {
        start?: number | undefined;
        end?: number | undefined;
        options?: {
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
    } & {
        start?: number | undefined;
        end?: number | undefined;
        options?: ({
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & { [K in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>]: never; }) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_2 in Exclude<keyof I["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                negativeIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_3 in Exclude<keyof I["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & { [K_4 in Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>]: never; }) | undefined;
        } & { [K_6 in Exclude<keyof I["options"], "uninterpretedOption">]: never; }) | undefined;
    } & { [K_7 in Exclude<keyof I, keyof DescriptorProto_ExtensionRange>]: never; }>(object: I): DescriptorProto_ExtensionRange;
};
export declare const DescriptorProto_ReservedRange: {
    encode(message: DescriptorProto_ReservedRange, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): DescriptorProto_ReservedRange;
    fromJSON(object: any): DescriptorProto_ReservedRange;
    toJSON(message: DescriptorProto_ReservedRange): unknown;
    fromPartial<I extends {
        start?: number | undefined;
        end?: number | undefined;
    } & {
        start?: number | undefined;
        end?: number | undefined;
    } & { [K in Exclude<keyof I, keyof DescriptorProto_ReservedRange>]: never; }>(object: I): DescriptorProto_ReservedRange;
};
export declare const ExtensionRangeOptions: {
    encode(message: ExtensionRangeOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ExtensionRangeOptions;
    fromJSON(object: any): ExtensionRangeOptions;
    toJSON(message: ExtensionRangeOptions): unknown;
    fromPartial<I extends {
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & { [K in Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>]: never; }) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_2 in Exclude<keyof I["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
            negativeIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_3 in Exclude<keyof I["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & { [K_4 in Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_6 in Exclude<keyof I, "uninterpretedOption">]: never; }>(object: I): ExtensionRangeOptions;
};
export declare const FieldDescriptorProto: {
    encode(message: FieldDescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): FieldDescriptorProto;
    fromJSON(object: any): FieldDescriptorProto;
    toJSON(message: FieldDescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        number?: number | undefined;
        label?: FieldDescriptorProto_Label | undefined;
        type?: FieldDescriptorProto_Type | undefined;
        typeName?: string | undefined;
        extendee?: string | undefined;
        defaultValue?: string | undefined;
        oneofIndex?: number | undefined;
        jsonName?: string | undefined;
        options?: {
            ctype?: FieldOptions_CType | undefined;
            packed?: boolean | undefined;
            jstype?: FieldOptions_JSType | undefined;
            lazy?: boolean | undefined;
            unverifiedLazy?: boolean | undefined;
            deprecated?: boolean | undefined;
            weak?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
        proto3Optional?: boolean | undefined;
    } & {
        name?: string | undefined;
        number?: number | undefined;
        label?: FieldDescriptorProto_Label | undefined;
        type?: FieldDescriptorProto_Type | undefined;
        typeName?: string | undefined;
        extendee?: string | undefined;
        defaultValue?: string | undefined;
        oneofIndex?: number | undefined;
        jsonName?: string | undefined;
        options?: ({
            ctype?: FieldOptions_CType | undefined;
            packed?: boolean | undefined;
            jstype?: FieldOptions_JSType | undefined;
            lazy?: boolean | undefined;
            unverifiedLazy?: boolean | undefined;
            deprecated?: boolean | undefined;
            weak?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            ctype?: FieldOptions_CType | undefined;
            packed?: boolean | undefined;
            jstype?: FieldOptions_JSType | undefined;
            lazy?: boolean | undefined;
            unverifiedLazy?: boolean | undefined;
            deprecated?: boolean | undefined;
            weak?: boolean | undefined;
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & { [K in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>]: never; }) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_2 in Exclude<keyof I["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                negativeIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_3 in Exclude<keyof I["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & { [K_4 in Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>]: never; }) | undefined;
        } & { [K_6 in Exclude<keyof I["options"], keyof FieldOptions>]: never; }) | undefined;
        proto3Optional?: boolean | undefined;
    } & { [K_7 in Exclude<keyof I, keyof FieldDescriptorProto>]: never; }>(object: I): FieldDescriptorProto;
};
export declare const OneofDescriptorProto: {
    encode(message: OneofDescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): OneofDescriptorProto;
    fromJSON(object: any): OneofDescriptorProto;
    toJSON(message: OneofDescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        options?: {
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
    } & {
        name?: string | undefined;
        options?: ({
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & { [K in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>]: never; }) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_2 in Exclude<keyof I["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                negativeIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_3 in Exclude<keyof I["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & { [K_4 in Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>]: never; }) | undefined;
        } & { [K_6 in Exclude<keyof I["options"], "uninterpretedOption">]: never; }) | undefined;
    } & { [K_7 in Exclude<keyof I, keyof OneofDescriptorProto>]: never; }>(object: I): OneofDescriptorProto;
};
export declare const EnumDescriptorProto: {
    encode(message: EnumDescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EnumDescriptorProto;
    fromJSON(object: any): EnumDescriptorProto;
    toJSON(message: EnumDescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        value?: {
            name?: string | undefined;
            number?: number | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] | undefined;
        options?: {
            allowAlias?: boolean | undefined;
            deprecated?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
        reservedRange?: {
            start?: number | undefined;
            end?: number | undefined;
        }[] | undefined;
        reservedName?: string[] | undefined;
    } & {
        name?: string | undefined;
        value?: ({
            name?: string | undefined;
            number?: number | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[] & ({
            name?: string | undefined;
            number?: number | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        } & {
            name?: string | undefined;
            number?: number | undefined;
            options?: ({
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                deprecated?: boolean | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & { [K in Exclude<keyof I["value"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["value"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_2 in Exclude<keyof I["value"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                    negativeIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_3 in Exclude<keyof I["value"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & { [K_4 in Exclude<keyof I["value"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["value"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>]: never; }) | undefined;
            } & { [K_6 in Exclude<keyof I["value"][number]["options"], keyof EnumValueOptions>]: never; }) | undefined;
        } & { [K_7 in Exclude<keyof I["value"][number], keyof EnumValueDescriptorProto>]: never; })[] & { [K_8 in Exclude<keyof I["value"], keyof {
            name?: string | undefined;
            number?: number | undefined;
            options?: {
                deprecated?: boolean | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
        }[]>]: never; }) | undefined;
        options?: ({
            allowAlias?: boolean | undefined;
            deprecated?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            allowAlias?: boolean | undefined;
            deprecated?: boolean | undefined;
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & { [K_9 in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_10 in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>]: never; }) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_11 in Exclude<keyof I["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                negativeIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_12 in Exclude<keyof I["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & { [K_13 in Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_14 in Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>]: never; }) | undefined;
        } & { [K_15 in Exclude<keyof I["options"], keyof EnumOptions>]: never; }) | undefined;
        reservedRange?: ({
            start?: number | undefined;
            end?: number | undefined;
        }[] & ({
            start?: number | undefined;
            end?: number | undefined;
        } & {
            start?: number | undefined;
            end?: number | undefined;
        } & { [K_16 in Exclude<keyof I["reservedRange"][number], keyof EnumDescriptorProto_EnumReservedRange>]: never; })[] & { [K_17 in Exclude<keyof I["reservedRange"], keyof {
            start?: number | undefined;
            end?: number | undefined;
        }[]>]: never; }) | undefined;
        reservedName?: (string[] & string[] & { [K_18 in Exclude<keyof I["reservedName"], keyof string[]>]: never; }) | undefined;
    } & { [K_19 in Exclude<keyof I, keyof EnumDescriptorProto>]: never; }>(object: I): EnumDescriptorProto;
};
export declare const EnumDescriptorProto_EnumReservedRange: {
    encode(message: EnumDescriptorProto_EnumReservedRange, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EnumDescriptorProto_EnumReservedRange;
    fromJSON(object: any): EnumDescriptorProto_EnumReservedRange;
    toJSON(message: EnumDescriptorProto_EnumReservedRange): unknown;
    fromPartial<I extends {
        start?: number | undefined;
        end?: number | undefined;
    } & {
        start?: number | undefined;
        end?: number | undefined;
    } & { [K in Exclude<keyof I, keyof EnumDescriptorProto_EnumReservedRange>]: never; }>(object: I): EnumDescriptorProto_EnumReservedRange;
};
export declare const EnumValueDescriptorProto: {
    encode(message: EnumValueDescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EnumValueDescriptorProto;
    fromJSON(object: any): EnumValueDescriptorProto;
    toJSON(message: EnumValueDescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        number?: number | undefined;
        options?: {
            deprecated?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
    } & {
        name?: string | undefined;
        number?: number | undefined;
        options?: ({
            deprecated?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            deprecated?: boolean | undefined;
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & { [K in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>]: never; }) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_2 in Exclude<keyof I["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                negativeIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_3 in Exclude<keyof I["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & { [K_4 in Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>]: never; }) | undefined;
        } & { [K_6 in Exclude<keyof I["options"], keyof EnumValueOptions>]: never; }) | undefined;
    } & { [K_7 in Exclude<keyof I, keyof EnumValueDescriptorProto>]: never; }>(object: I): EnumValueDescriptorProto;
};
export declare const ServiceDescriptorProto: {
    encode(message: ServiceDescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ServiceDescriptorProto;
    fromJSON(object: any): ServiceDescriptorProto;
    toJSON(message: ServiceDescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        method?: {
            name?: string | undefined;
            inputType?: string | undefined;
            outputType?: string | undefined;
            options?: {
                deprecated?: boolean | undefined;
                idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            clientStreaming?: boolean | undefined;
            serverStreaming?: boolean | undefined;
        }[] | undefined;
        options?: {
            deprecated?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
    } & {
        name?: string | undefined;
        method?: ({
            name?: string | undefined;
            inputType?: string | undefined;
            outputType?: string | undefined;
            options?: {
                deprecated?: boolean | undefined;
                idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            clientStreaming?: boolean | undefined;
            serverStreaming?: boolean | undefined;
        }[] & ({
            name?: string | undefined;
            inputType?: string | undefined;
            outputType?: string | undefined;
            options?: {
                deprecated?: boolean | undefined;
                idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            clientStreaming?: boolean | undefined;
            serverStreaming?: boolean | undefined;
        } & {
            name?: string | undefined;
            inputType?: string | undefined;
            outputType?: string | undefined;
            options?: ({
                deprecated?: boolean | undefined;
                idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } & {
                deprecated?: boolean | undefined;
                idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                uninterpretedOption?: ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] & ({
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & {
                    name?: ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] & ({
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    } & { [K in Exclude<keyof I["method"][number]["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["method"][number]["options"]["uninterpretedOption"][number]["name"], keyof {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[]>]: never; }) | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_2 in Exclude<keyof I["method"][number]["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                    negativeIntValue?: string | number | (Long.Long & {
                        high: number;
                        low: number;
                        unsigned: boolean;
                        add: (addend: string | number | Long.Long) => Long.Long;
                        and: (other: string | number | Long.Long) => Long.Long;
                        compare: (other: string | number | Long.Long) => number;
                        comp: (other: string | number | Long.Long) => number;
                        divide: (divisor: string | number | Long.Long) => Long.Long;
                        div: (divisor: string | number | Long.Long) => Long.Long;
                        equals: (other: string | number | Long.Long) => boolean;
                        eq: (other: string | number | Long.Long) => boolean;
                        getHighBits: () => number;
                        getHighBitsUnsigned: () => number;
                        getLowBits: () => number;
                        getLowBitsUnsigned: () => number;
                        getNumBitsAbs: () => number;
                        greaterThan: (other: string | number | Long.Long) => boolean;
                        gt: (other: string | number | Long.Long) => boolean;
                        greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                        gte: (other: string | number | Long.Long) => boolean;
                        isEven: () => boolean;
                        isNegative: () => boolean;
                        isOdd: () => boolean;
                        isPositive: () => boolean;
                        isZero: () => boolean;
                        lessThan: (other: string | number | Long.Long) => boolean;
                        lt: (other: string | number | Long.Long) => boolean;
                        lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                        lte: (other: string | number | Long.Long) => boolean;
                        modulo: (other: string | number | Long.Long) => Long.Long;
                        mod: (other: string | number | Long.Long) => Long.Long;
                        multiply: (multiplier: string | number | Long.Long) => Long.Long;
                        mul: (multiplier: string | number | Long.Long) => Long.Long;
                        negate: () => Long.Long;
                        neg: () => Long.Long;
                        not: () => Long.Long;
                        notEquals: (other: string | number | Long.Long) => boolean;
                        neq: (other: string | number | Long.Long) => boolean;
                        or: (other: string | number | Long.Long) => Long.Long;
                        shiftLeft: (numBits: number | Long.Long) => Long.Long;
                        shl: (numBits: number | Long.Long) => Long.Long;
                        shiftRight: (numBits: number | Long.Long) => Long.Long;
                        shr: (numBits: number | Long.Long) => Long.Long;
                        shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                        shru: (numBits: number | Long.Long) => Long.Long;
                        subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                        sub: (subtrahend: string | number | Long.Long) => Long.Long;
                        toInt: () => number;
                        toNumber: () => number;
                        toBytes: (le?: boolean | undefined) => number[];
                        toBytesLE: () => number[];
                        toBytesBE: () => number[];
                        toSigned: () => Long.Long;
                        toString: (radix?: number | undefined) => string;
                        toUnsigned: () => Long.Long;
                        xor: (other: string | number | Long.Long) => Long.Long;
                    } & { [K_3 in Exclude<keyof I["method"][number]["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                } & { [K_4 in Exclude<keyof I["method"][number]["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["method"][number]["options"]["uninterpretedOption"], keyof {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[]>]: never; }) | undefined;
            } & { [K_6 in Exclude<keyof I["method"][number]["options"], keyof MethodOptions>]: never; }) | undefined;
            clientStreaming?: boolean | undefined;
            serverStreaming?: boolean | undefined;
        } & { [K_7 in Exclude<keyof I["method"][number], keyof MethodDescriptorProto>]: never; })[] & { [K_8 in Exclude<keyof I["method"], keyof {
            name?: string | undefined;
            inputType?: string | undefined;
            outputType?: string | undefined;
            options?: {
                deprecated?: boolean | undefined;
                idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
                uninterpretedOption?: {
                    name?: {
                        namePart?: string | undefined;
                        isExtension?: boolean | undefined;
                    }[] | undefined;
                    identifierValue?: string | undefined;
                    positiveIntValue?: string | number | Long.Long | undefined;
                    negativeIntValue?: string | number | Long.Long | undefined;
                    doubleValue?: number | undefined;
                    stringValue?: Uint8Array | undefined;
                    aggregateValue?: string | undefined;
                }[] | undefined;
            } | undefined;
            clientStreaming?: boolean | undefined;
            serverStreaming?: boolean | undefined;
        }[]>]: never; }) | undefined;
        options?: ({
            deprecated?: boolean | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            deprecated?: boolean | undefined;
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & { [K_9 in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_10 in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>]: never; }) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_11 in Exclude<keyof I["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                negativeIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_12 in Exclude<keyof I["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & { [K_13 in Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_14 in Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>]: never; }) | undefined;
        } & { [K_15 in Exclude<keyof I["options"], keyof ServiceOptions>]: never; }) | undefined;
    } & { [K_16 in Exclude<keyof I, keyof ServiceDescriptorProto>]: never; }>(object: I): ServiceDescriptorProto;
};
export declare const MethodDescriptorProto: {
    encode(message: MethodDescriptorProto, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MethodDescriptorProto;
    fromJSON(object: any): MethodDescriptorProto;
    toJSON(message: MethodDescriptorProto): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        inputType?: string | undefined;
        outputType?: string | undefined;
        options?: {
            deprecated?: boolean | undefined;
            idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } | undefined;
        clientStreaming?: boolean | undefined;
        serverStreaming?: boolean | undefined;
    } & {
        name?: string | undefined;
        inputType?: string | undefined;
        outputType?: string | undefined;
        options?: ({
            deprecated?: boolean | undefined;
            idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
            uninterpretedOption?: {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] | undefined;
        } & {
            deprecated?: boolean | undefined;
            idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
            uninterpretedOption?: ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[] & ({
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & {
                name?: ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] & ({
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                } & { [K in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["options"]["uninterpretedOption"][number]["name"], keyof {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[]>]: never; }) | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_2 in Exclude<keyof I["options"]["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
                negativeIntValue?: string | number | (Long.Long & {
                    high: number;
                    low: number;
                    unsigned: boolean;
                    add: (addend: string | number | Long.Long) => Long.Long;
                    and: (other: string | number | Long.Long) => Long.Long;
                    compare: (other: string | number | Long.Long) => number;
                    comp: (other: string | number | Long.Long) => number;
                    divide: (divisor: string | number | Long.Long) => Long.Long;
                    div: (divisor: string | number | Long.Long) => Long.Long;
                    equals: (other: string | number | Long.Long) => boolean;
                    eq: (other: string | number | Long.Long) => boolean;
                    getHighBits: () => number;
                    getHighBitsUnsigned: () => number;
                    getLowBits: () => number;
                    getLowBitsUnsigned: () => number;
                    getNumBitsAbs: () => number;
                    greaterThan: (other: string | number | Long.Long) => boolean;
                    gt: (other: string | number | Long.Long) => boolean;
                    greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                    gte: (other: string | number | Long.Long) => boolean;
                    isEven: () => boolean;
                    isNegative: () => boolean;
                    isOdd: () => boolean;
                    isPositive: () => boolean;
                    isZero: () => boolean;
                    lessThan: (other: string | number | Long.Long) => boolean;
                    lt: (other: string | number | Long.Long) => boolean;
                    lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                    lte: (other: string | number | Long.Long) => boolean;
                    modulo: (other: string | number | Long.Long) => Long.Long;
                    mod: (other: string | number | Long.Long) => Long.Long;
                    multiply: (multiplier: string | number | Long.Long) => Long.Long;
                    mul: (multiplier: string | number | Long.Long) => Long.Long;
                    negate: () => Long.Long;
                    neg: () => Long.Long;
                    not: () => Long.Long;
                    notEquals: (other: string | number | Long.Long) => boolean;
                    neq: (other: string | number | Long.Long) => boolean;
                    or: (other: string | number | Long.Long) => Long.Long;
                    shiftLeft: (numBits: number | Long.Long) => Long.Long;
                    shl: (numBits: number | Long.Long) => Long.Long;
                    shiftRight: (numBits: number | Long.Long) => Long.Long;
                    shr: (numBits: number | Long.Long) => Long.Long;
                    shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                    shru: (numBits: number | Long.Long) => Long.Long;
                    subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                    sub: (subtrahend: string | number | Long.Long) => Long.Long;
                    toInt: () => number;
                    toNumber: () => number;
                    toBytes: (le?: boolean | undefined) => number[];
                    toBytesLE: () => number[];
                    toBytesBE: () => number[];
                    toSigned: () => Long.Long;
                    toString: (radix?: number | undefined) => string;
                    toUnsigned: () => Long.Long;
                    xor: (other: string | number | Long.Long) => Long.Long;
                } & { [K_3 in Exclude<keyof I["options"]["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            } & { [K_4 in Exclude<keyof I["options"]["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["options"]["uninterpretedOption"], keyof {
                name?: {
                    namePart?: string | undefined;
                    isExtension?: boolean | undefined;
                }[] | undefined;
                identifierValue?: string | undefined;
                positiveIntValue?: string | number | Long.Long | undefined;
                negativeIntValue?: string | number | Long.Long | undefined;
                doubleValue?: number | undefined;
                stringValue?: Uint8Array | undefined;
                aggregateValue?: string | undefined;
            }[]>]: never; }) | undefined;
        } & { [K_6 in Exclude<keyof I["options"], keyof MethodOptions>]: never; }) | undefined;
        clientStreaming?: boolean | undefined;
        serverStreaming?: boolean | undefined;
    } & { [K_7 in Exclude<keyof I, keyof MethodDescriptorProto>]: never; }>(object: I): MethodDescriptorProto;
};
export declare const FileOptions: {
    encode(message: FileOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): FileOptions;
    fromJSON(object: any): FileOptions;
    toJSON(message: FileOptions): unknown;
    fromPartial<I extends {
        javaPackage?: string | undefined;
        javaOuterClassname?: string | undefined;
        javaMultipleFiles?: boolean | undefined;
        javaGenerateEqualsAndHash?: boolean | undefined;
        javaStringCheckUtf8?: boolean | undefined;
        optimizeFor?: FileOptions_OptimizeMode | undefined;
        goPackage?: string | undefined;
        ccGenericServices?: boolean | undefined;
        javaGenericServices?: boolean | undefined;
        pyGenericServices?: boolean | undefined;
        phpGenericServices?: boolean | undefined;
        deprecated?: boolean | undefined;
        ccEnableArenas?: boolean | undefined;
        objcClassPrefix?: string | undefined;
        csharpNamespace?: string | undefined;
        swiftPrefix?: string | undefined;
        phpClassPrefix?: string | undefined;
        phpNamespace?: string | undefined;
        phpMetadataNamespace?: string | undefined;
        rubyPackage?: string | undefined;
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        javaPackage?: string | undefined;
        javaOuterClassname?: string | undefined;
        javaMultipleFiles?: boolean | undefined;
        javaGenerateEqualsAndHash?: boolean | undefined;
        javaStringCheckUtf8?: boolean | undefined;
        optimizeFor?: FileOptions_OptimizeMode | undefined;
        goPackage?: string | undefined;
        ccGenericServices?: boolean | undefined;
        javaGenericServices?: boolean | undefined;
        pyGenericServices?: boolean | undefined;
        phpGenericServices?: boolean | undefined;
        deprecated?: boolean | undefined;
        ccEnableArenas?: boolean | undefined;
        objcClassPrefix?: string | undefined;
        csharpNamespace?: string | undefined;
        swiftPrefix?: string | undefined;
        phpClassPrefix?: string | undefined;
        phpNamespace?: string | undefined;
        phpMetadataNamespace?: string | undefined;
        rubyPackage?: string | undefined;
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & { [K in Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>]: never; }) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_2 in Exclude<keyof I["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
            negativeIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_3 in Exclude<keyof I["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & { [K_4 in Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_6 in Exclude<keyof I, keyof FileOptions>]: never; }>(object: I): FileOptions;
};
export declare const MessageOptions: {
    encode(message: MessageOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MessageOptions;
    fromJSON(object: any): MessageOptions;
    toJSON(message: MessageOptions): unknown;
    fromPartial<I extends {
        messageSetWireFormat?: boolean | undefined;
        noStandardDescriptorAccessor?: boolean | undefined;
        deprecated?: boolean | undefined;
        mapEntry?: boolean | undefined;
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        messageSetWireFormat?: boolean | undefined;
        noStandardDescriptorAccessor?: boolean | undefined;
        deprecated?: boolean | undefined;
        mapEntry?: boolean | undefined;
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & { [K in Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>]: never; }) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_2 in Exclude<keyof I["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
            negativeIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_3 in Exclude<keyof I["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & { [K_4 in Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_6 in Exclude<keyof I, keyof MessageOptions>]: never; }>(object: I): MessageOptions;
};
export declare const FieldOptions: {
    encode(message: FieldOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): FieldOptions;
    fromJSON(object: any): FieldOptions;
    toJSON(message: FieldOptions): unknown;
    fromPartial<I extends {
        ctype?: FieldOptions_CType | undefined;
        packed?: boolean | undefined;
        jstype?: FieldOptions_JSType | undefined;
        lazy?: boolean | undefined;
        unverifiedLazy?: boolean | undefined;
        deprecated?: boolean | undefined;
        weak?: boolean | undefined;
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        ctype?: FieldOptions_CType | undefined;
        packed?: boolean | undefined;
        jstype?: FieldOptions_JSType | undefined;
        lazy?: boolean | undefined;
        unverifiedLazy?: boolean | undefined;
        deprecated?: boolean | undefined;
        weak?: boolean | undefined;
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & { [K in Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>]: never; }) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_2 in Exclude<keyof I["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
            negativeIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_3 in Exclude<keyof I["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & { [K_4 in Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_6 in Exclude<keyof I, keyof FieldOptions>]: never; }>(object: I): FieldOptions;
};
export declare const OneofOptions: {
    encode(message: OneofOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): OneofOptions;
    fromJSON(object: any): OneofOptions;
    toJSON(message: OneofOptions): unknown;
    fromPartial<I extends {
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & { [K in Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>]: never; }) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_2 in Exclude<keyof I["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
            negativeIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_3 in Exclude<keyof I["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & { [K_4 in Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_6 in Exclude<keyof I, "uninterpretedOption">]: never; }>(object: I): OneofOptions;
};
export declare const EnumOptions: {
    encode(message: EnumOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EnumOptions;
    fromJSON(object: any): EnumOptions;
    toJSON(message: EnumOptions): unknown;
    fromPartial<I extends {
        allowAlias?: boolean | undefined;
        deprecated?: boolean | undefined;
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        allowAlias?: boolean | undefined;
        deprecated?: boolean | undefined;
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & { [K in Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>]: never; }) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_2 in Exclude<keyof I["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
            negativeIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_3 in Exclude<keyof I["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & { [K_4 in Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_6 in Exclude<keyof I, keyof EnumOptions>]: never; }>(object: I): EnumOptions;
};
export declare const EnumValueOptions: {
    encode(message: EnumValueOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EnumValueOptions;
    fromJSON(object: any): EnumValueOptions;
    toJSON(message: EnumValueOptions): unknown;
    fromPartial<I extends {
        deprecated?: boolean | undefined;
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        deprecated?: boolean | undefined;
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & { [K in Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>]: never; }) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_2 in Exclude<keyof I["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
            negativeIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_3 in Exclude<keyof I["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & { [K_4 in Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_6 in Exclude<keyof I, keyof EnumValueOptions>]: never; }>(object: I): EnumValueOptions;
};
export declare const ServiceOptions: {
    encode(message: ServiceOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ServiceOptions;
    fromJSON(object: any): ServiceOptions;
    toJSON(message: ServiceOptions): unknown;
    fromPartial<I extends {
        deprecated?: boolean | undefined;
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        deprecated?: boolean | undefined;
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & { [K in Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>]: never; }) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_2 in Exclude<keyof I["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
            negativeIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_3 in Exclude<keyof I["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & { [K_4 in Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_6 in Exclude<keyof I, keyof ServiceOptions>]: never; }>(object: I): ServiceOptions;
};
export declare const MethodOptions: {
    encode(message: MethodOptions, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MethodOptions;
    fromJSON(object: any): MethodOptions;
    toJSON(message: MethodOptions): unknown;
    fromPartial<I extends {
        deprecated?: boolean | undefined;
        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
        uninterpretedOption?: {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] | undefined;
    } & {
        deprecated?: boolean | undefined;
        idempotencyLevel?: MethodOptions_IdempotencyLevel | undefined;
        uninterpretedOption?: ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[] & ({
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & {
            name?: ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] & ({
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            } & { [K in Exclude<keyof I["uninterpretedOption"][number]["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["uninterpretedOption"][number]["name"], keyof {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[]>]: never; }) | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_2 in Exclude<keyof I["uninterpretedOption"][number]["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
            negativeIntValue?: string | number | (Long.Long & {
                high: number;
                low: number;
                unsigned: boolean;
                add: (addend: string | number | Long.Long) => Long.Long;
                and: (other: string | number | Long.Long) => Long.Long;
                compare: (other: string | number | Long.Long) => number;
                comp: (other: string | number | Long.Long) => number;
                divide: (divisor: string | number | Long.Long) => Long.Long;
                div: (divisor: string | number | Long.Long) => Long.Long;
                equals: (other: string | number | Long.Long) => boolean;
                eq: (other: string | number | Long.Long) => boolean;
                getHighBits: () => number;
                getHighBitsUnsigned: () => number;
                getLowBits: () => number;
                getLowBitsUnsigned: () => number;
                getNumBitsAbs: () => number;
                greaterThan: (other: string | number | Long.Long) => boolean;
                gt: (other: string | number | Long.Long) => boolean;
                greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
                gte: (other: string | number | Long.Long) => boolean;
                isEven: () => boolean;
                isNegative: () => boolean;
                isOdd: () => boolean;
                isPositive: () => boolean;
                isZero: () => boolean;
                lessThan: (other: string | number | Long.Long) => boolean;
                lt: (other: string | number | Long.Long) => boolean;
                lessThanOrEqual: (other: string | number | Long.Long) => boolean;
                lte: (other: string | number | Long.Long) => boolean;
                modulo: (other: string | number | Long.Long) => Long.Long;
                mod: (other: string | number | Long.Long) => Long.Long;
                multiply: (multiplier: string | number | Long.Long) => Long.Long;
                mul: (multiplier: string | number | Long.Long) => Long.Long;
                negate: () => Long.Long;
                neg: () => Long.Long;
                not: () => Long.Long;
                notEquals: (other: string | number | Long.Long) => boolean;
                neq: (other: string | number | Long.Long) => boolean;
                or: (other: string | number | Long.Long) => Long.Long;
                shiftLeft: (numBits: number | Long.Long) => Long.Long;
                shl: (numBits: number | Long.Long) => Long.Long;
                shiftRight: (numBits: number | Long.Long) => Long.Long;
                shr: (numBits: number | Long.Long) => Long.Long;
                shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
                shru: (numBits: number | Long.Long) => Long.Long;
                subtract: (subtrahend: string | number | Long.Long) => Long.Long;
                sub: (subtrahend: string | number | Long.Long) => Long.Long;
                toInt: () => number;
                toNumber: () => number;
                toBytes: (le?: boolean | undefined) => number[];
                toBytesLE: () => number[];
                toBytesBE: () => number[];
                toSigned: () => Long.Long;
                toString: (radix?: number | undefined) => string;
                toUnsigned: () => Long.Long;
                xor: (other: string | number | Long.Long) => Long.Long;
            } & { [K_3 in Exclude<keyof I["uninterpretedOption"][number]["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        } & { [K_4 in Exclude<keyof I["uninterpretedOption"][number], keyof UninterpretedOption>]: never; })[] & { [K_5 in Exclude<keyof I["uninterpretedOption"], keyof {
            name?: {
                namePart?: string | undefined;
                isExtension?: boolean | undefined;
            }[] | undefined;
            identifierValue?: string | undefined;
            positiveIntValue?: string | number | Long.Long | undefined;
            negativeIntValue?: string | number | Long.Long | undefined;
            doubleValue?: number | undefined;
            stringValue?: Uint8Array | undefined;
            aggregateValue?: string | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_6 in Exclude<keyof I, keyof MethodOptions>]: never; }>(object: I): MethodOptions;
};
export declare const UninterpretedOption: {
    encode(message: UninterpretedOption, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UninterpretedOption;
    fromJSON(object: any): UninterpretedOption;
    toJSON(message: UninterpretedOption): unknown;
    fromPartial<I extends {
        name?: {
            namePart?: string | undefined;
            isExtension?: boolean | undefined;
        }[] | undefined;
        identifierValue?: string | undefined;
        positiveIntValue?: string | number | Long.Long | undefined;
        negativeIntValue?: string | number | Long.Long | undefined;
        doubleValue?: number | undefined;
        stringValue?: Uint8Array | undefined;
        aggregateValue?: string | undefined;
    } & {
        name?: ({
            namePart?: string | undefined;
            isExtension?: boolean | undefined;
        }[] & ({
            namePart?: string | undefined;
            isExtension?: boolean | undefined;
        } & {
            namePart?: string | undefined;
            isExtension?: boolean | undefined;
        } & { [K in Exclude<keyof I["name"][number], keyof UninterpretedOption_NamePart>]: never; })[] & { [K_1 in Exclude<keyof I["name"], keyof {
            namePart?: string | undefined;
            isExtension?: boolean | undefined;
        }[]>]: never; }) | undefined;
        identifierValue?: string | undefined;
        positiveIntValue?: string | number | (Long.Long & {
            high: number;
            low: number;
            unsigned: boolean;
            add: (addend: string | number | Long.Long) => Long.Long;
            and: (other: string | number | Long.Long) => Long.Long;
            compare: (other: string | number | Long.Long) => number;
            comp: (other: string | number | Long.Long) => number;
            divide: (divisor: string | number | Long.Long) => Long.Long;
            div: (divisor: string | number | Long.Long) => Long.Long;
            equals: (other: string | number | Long.Long) => boolean;
            eq: (other: string | number | Long.Long) => boolean;
            getHighBits: () => number;
            getHighBitsUnsigned: () => number;
            getLowBits: () => number;
            getLowBitsUnsigned: () => number;
            getNumBitsAbs: () => number;
            greaterThan: (other: string | number | Long.Long) => boolean;
            gt: (other: string | number | Long.Long) => boolean;
            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
            gte: (other: string | number | Long.Long) => boolean;
            isEven: () => boolean;
            isNegative: () => boolean;
            isOdd: () => boolean;
            isPositive: () => boolean;
            isZero: () => boolean;
            lessThan: (other: string | number | Long.Long) => boolean;
            lt: (other: string | number | Long.Long) => boolean;
            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
            lte: (other: string | number | Long.Long) => boolean;
            modulo: (other: string | number | Long.Long) => Long.Long;
            mod: (other: string | number | Long.Long) => Long.Long;
            multiply: (multiplier: string | number | Long.Long) => Long.Long;
            mul: (multiplier: string | number | Long.Long) => Long.Long;
            negate: () => Long.Long;
            neg: () => Long.Long;
            not: () => Long.Long;
            notEquals: (other: string | number | Long.Long) => boolean;
            neq: (other: string | number | Long.Long) => boolean;
            or: (other: string | number | Long.Long) => Long.Long;
            shiftLeft: (numBits: number | Long.Long) => Long.Long;
            shl: (numBits: number | Long.Long) => Long.Long;
            shiftRight: (numBits: number | Long.Long) => Long.Long;
            shr: (numBits: number | Long.Long) => Long.Long;
            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
            shru: (numBits: number | Long.Long) => Long.Long;
            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
            sub: (subtrahend: string | number | Long.Long) => Long.Long;
            toInt: () => number;
            toNumber: () => number;
            toBytes: (le?: boolean | undefined) => number[];
            toBytesLE: () => number[];
            toBytesBE: () => number[];
            toSigned: () => Long.Long;
            toString: (radix?: number | undefined) => string;
            toUnsigned: () => Long.Long;
            xor: (other: string | number | Long.Long) => Long.Long;
        } & { [K_2 in Exclude<keyof I["positiveIntValue"], keyof Long.Long>]: never; }) | undefined;
        negativeIntValue?: string | number | (Long.Long & {
            high: number;
            low: number;
            unsigned: boolean;
            add: (addend: string | number | Long.Long) => Long.Long;
            and: (other: string | number | Long.Long) => Long.Long;
            compare: (other: string | number | Long.Long) => number;
            comp: (other: string | number | Long.Long) => number;
            divide: (divisor: string | number | Long.Long) => Long.Long;
            div: (divisor: string | number | Long.Long) => Long.Long;
            equals: (other: string | number | Long.Long) => boolean;
            eq: (other: string | number | Long.Long) => boolean;
            getHighBits: () => number;
            getHighBitsUnsigned: () => number;
            getLowBits: () => number;
            getLowBitsUnsigned: () => number;
            getNumBitsAbs: () => number;
            greaterThan: (other: string | number | Long.Long) => boolean;
            gt: (other: string | number | Long.Long) => boolean;
            greaterThanOrEqual: (other: string | number | Long.Long) => boolean;
            gte: (other: string | number | Long.Long) => boolean;
            isEven: () => boolean;
            isNegative: () => boolean;
            isOdd: () => boolean;
            isPositive: () => boolean;
            isZero: () => boolean;
            lessThan: (other: string | number | Long.Long) => boolean;
            lt: (other: string | number | Long.Long) => boolean;
            lessThanOrEqual: (other: string | number | Long.Long) => boolean;
            lte: (other: string | number | Long.Long) => boolean;
            modulo: (other: string | number | Long.Long) => Long.Long;
            mod: (other: string | number | Long.Long) => Long.Long;
            multiply: (multiplier: string | number | Long.Long) => Long.Long;
            mul: (multiplier: string | number | Long.Long) => Long.Long;
            negate: () => Long.Long;
            neg: () => Long.Long;
            not: () => Long.Long;
            notEquals: (other: string | number | Long.Long) => boolean;
            neq: (other: string | number | Long.Long) => boolean;
            or: (other: string | number | Long.Long) => Long.Long;
            shiftLeft: (numBits: number | Long.Long) => Long.Long;
            shl: (numBits: number | Long.Long) => Long.Long;
            shiftRight: (numBits: number | Long.Long) => Long.Long;
            shr: (numBits: number | Long.Long) => Long.Long;
            shiftRightUnsigned: (numBits: number | Long.Long) => Long.Long;
            shru: (numBits: number | Long.Long) => Long.Long;
            subtract: (subtrahend: string | number | Long.Long) => Long.Long;
            sub: (subtrahend: string | number | Long.Long) => Long.Long;
            toInt: () => number;
            toNumber: () => number;
            toBytes: (le?: boolean | undefined) => number[];
            toBytesLE: () => number[];
            toBytesBE: () => number[];
            toSigned: () => Long.Long;
            toString: (radix?: number | undefined) => string;
            toUnsigned: () => Long.Long;
            xor: (other: string | number | Long.Long) => Long.Long;
        } & { [K_3 in Exclude<keyof I["negativeIntValue"], keyof Long.Long>]: never; }) | undefined;
        doubleValue?: number | undefined;
        stringValue?: Uint8Array | undefined;
        aggregateValue?: string | undefined;
    } & { [K_4 in Exclude<keyof I, keyof UninterpretedOption>]: never; }>(object: I): UninterpretedOption;
};
export declare const UninterpretedOption_NamePart: {
    encode(message: UninterpretedOption_NamePart, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UninterpretedOption_NamePart;
    fromJSON(object: any): UninterpretedOption_NamePart;
    toJSON(message: UninterpretedOption_NamePart): unknown;
    fromPartial<I extends {
        namePart?: string | undefined;
        isExtension?: boolean | undefined;
    } & {
        namePart?: string | undefined;
        isExtension?: boolean | undefined;
    } & { [K in Exclude<keyof I, keyof UninterpretedOption_NamePart>]: never; }>(object: I): UninterpretedOption_NamePart;
};
export declare const SourceCodeInfo: {
    encode(message: SourceCodeInfo, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): SourceCodeInfo;
    fromJSON(object: any): SourceCodeInfo;
    toJSON(message: SourceCodeInfo): unknown;
    fromPartial<I extends {
        location?: {
            path?: number[] | undefined;
            span?: number[] | undefined;
            leadingComments?: string | undefined;
            trailingComments?: string | undefined;
            leadingDetachedComments?: string[] | undefined;
        }[] | undefined;
    } & {
        location?: ({
            path?: number[] | undefined;
            span?: number[] | undefined;
            leadingComments?: string | undefined;
            trailingComments?: string | undefined;
            leadingDetachedComments?: string[] | undefined;
        }[] & ({
            path?: number[] | undefined;
            span?: number[] | undefined;
            leadingComments?: string | undefined;
            trailingComments?: string | undefined;
            leadingDetachedComments?: string[] | undefined;
        } & {
            path?: (number[] & number[] & { [K in Exclude<keyof I["location"][number]["path"], keyof number[]>]: never; }) | undefined;
            span?: (number[] & number[] & { [K_1 in Exclude<keyof I["location"][number]["span"], keyof number[]>]: never; }) | undefined;
            leadingComments?: string | undefined;
            trailingComments?: string | undefined;
            leadingDetachedComments?: (string[] & string[] & { [K_2 in Exclude<keyof I["location"][number]["leadingDetachedComments"], keyof string[]>]: never; }) | undefined;
        } & { [K_3 in Exclude<keyof I["location"][number], keyof SourceCodeInfo_Location>]: never; })[] & { [K_4 in Exclude<keyof I["location"], keyof {
            path?: number[] | undefined;
            span?: number[] | undefined;
            leadingComments?: string | undefined;
            trailingComments?: string | undefined;
            leadingDetachedComments?: string[] | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_5 in Exclude<keyof I, "location">]: never; }>(object: I): SourceCodeInfo;
};
export declare const SourceCodeInfo_Location: {
    encode(message: SourceCodeInfo_Location, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): SourceCodeInfo_Location;
    fromJSON(object: any): SourceCodeInfo_Location;
    toJSON(message: SourceCodeInfo_Location): unknown;
    fromPartial<I extends {
        path?: number[] | undefined;
        span?: number[] | undefined;
        leadingComments?: string | undefined;
        trailingComments?: string | undefined;
        leadingDetachedComments?: string[] | undefined;
    } & {
        path?: (number[] & number[] & { [K in Exclude<keyof I["path"], keyof number[]>]: never; }) | undefined;
        span?: (number[] & number[] & { [K_1 in Exclude<keyof I["span"], keyof number[]>]: never; }) | undefined;
        leadingComments?: string | undefined;
        trailingComments?: string | undefined;
        leadingDetachedComments?: (string[] & string[] & { [K_2 in Exclude<keyof I["leadingDetachedComments"], keyof string[]>]: never; }) | undefined;
    } & { [K_3 in Exclude<keyof I, keyof SourceCodeInfo_Location>]: never; }>(object: I): SourceCodeInfo_Location;
};
export declare const GeneratedCodeInfo: {
    encode(message: GeneratedCodeInfo, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GeneratedCodeInfo;
    fromJSON(object: any): GeneratedCodeInfo;
    toJSON(message: GeneratedCodeInfo): unknown;
    fromPartial<I extends {
        annotation?: {
            path?: number[] | undefined;
            sourceFile?: string | undefined;
            begin?: number | undefined;
            end?: number | undefined;
        }[] | undefined;
    } & {
        annotation?: ({
            path?: number[] | undefined;
            sourceFile?: string | undefined;
            begin?: number | undefined;
            end?: number | undefined;
        }[] & ({
            path?: number[] | undefined;
            sourceFile?: string | undefined;
            begin?: number | undefined;
            end?: number | undefined;
        } & {
            path?: (number[] & number[] & { [K in Exclude<keyof I["annotation"][number]["path"], keyof number[]>]: never; }) | undefined;
            sourceFile?: string | undefined;
            begin?: number | undefined;
            end?: number | undefined;
        } & { [K_1 in Exclude<keyof I["annotation"][number], keyof GeneratedCodeInfo_Annotation>]: never; })[] & { [K_2 in Exclude<keyof I["annotation"], keyof {
            path?: number[] | undefined;
            sourceFile?: string | undefined;
            begin?: number | undefined;
            end?: number | undefined;
        }[]>]: never; }) | undefined;
    } & { [K_3 in Exclude<keyof I, "annotation">]: never; }>(object: I): GeneratedCodeInfo;
};
export declare const GeneratedCodeInfo_Annotation: {
    encode(message: GeneratedCodeInfo_Annotation, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GeneratedCodeInfo_Annotation;
    fromJSON(object: any): GeneratedCodeInfo_Annotation;
    toJSON(message: GeneratedCodeInfo_Annotation): unknown;
    fromPartial<I extends {
        path?: number[] | undefined;
        sourceFile?: string | undefined;
        begin?: number | undefined;
        end?: number | undefined;
    } & {
        path?: (number[] & number[] & { [K in Exclude<keyof I["path"], keyof number[]>]: never; }) | undefined;
        sourceFile?: string | undefined;
        begin?: number | undefined;
        end?: number | undefined;
    } & { [K_1 in Exclude<keyof I, keyof GeneratedCodeInfo_Annotation>]: never; }>(object: I): GeneratedCodeInfo_Annotation;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export {};
